#include <cstring>  
#include <cstdio>  
#include <iostream>  
#include <vector>  
#include <map>  
#include <set>  
#include <algorithm>  
#define sz size()  
#define pb push_back  
#define _(x,a) memset(x,a,sizeof(x))  
#define LET(x,a) typeof(a) x(a)  
#define FORR(i,a,b) for(LET(i,a);i!=(b);++i)  
#define FOR(i,a,b) for(int i=a;i<b;i++)  
#define REP(i,n) FOR(i,0,n)  
#define EACH(i,v) FOR(i,(v).begin(),(v).end())  
#define LL long long  
#define GI ({int t;scanf("%d",&t);t;})  
#define GL ({LL t;scanf("%lld",&t);t;})  
#define GD ({double t;scanf("%lf",&t);t;})  
#define maxx 1010  
#define maxy 1010  
#define maxn 1000010  
template<class T> inline void checkmax(T &a,T b){if(b>a) a=b;}   
template<class T> inline void checkmin(T &a,T b){if(b<a) a=b;}   
  
bool block[maxx][maxy], vis[maxx][maxy][4], bottomvis[maxy][4];  
int dp[maxx][maxy][4], dpend[maxx][maxy][4], dpenddir[maxx][maxy][4], tree[3*maxy], dx[] = {1,-1,-1,1}, dy[] = {1,1,-1,-1}, xx[maxn], yy[maxn], X, Y, N, Q, a, b, INF = -1;  
  
int big(int a, int b) {  
    return a>b?a:b;  
}  
  
int go(int x, int y, int dir)  {  
    int & ret = dp[x][y][dir];  
    if(ret!=-1) return ret;  
    if(vis[x][y][dir]==true) return ret = INF;  
    vis[x][y][dir] = true;  
    int nx = x+dx[dir], ny = y+dy[dir], ndir = dir;  
    if(nx<0||nx>=X) ndir = ndir^1;  
    if(ny<0||ny>=Y) ndir = 3-ndir;  
    if(ndir!=dir) { ret = go(x,y,ndir); dpend[x][y][dir] = dpend[x][y][ndir]; dpenddir[x][y][dir] = dpenddir[x][y][ndir]; return ret; }  
    nx = x+dx[dir], ny = y+dy[dir], ndir = dir;  
    if(block[nx][y]&&!block[x][ny]) ndir = ndir^1;  
    if(block[x][ny]&&!block[nx][y]) ndir = 3-ndir;  
    if(block[nx][y]&&block[x][ny]||block[nx][ny]) ndir = 3-(ndir^1);  
    if(ndir!=dir) { ret = go(x,y,ndir); dpend[x][y][dir] = dpend[x][y][ndir]; dpenddir[x][y][dir] = dpenddir[x][y][ndir]; return ret; }  
    nx = x+dx[dir], ny = y+dy[dir], ndir = dir;  
    if(nx==0) { dpend[x][y][dir] = ny, dpenddir[x][y][dir] = dir; return ret = 1; }  
    ret = 1+go(nx,ny,dir); dpend[x][y][dir] = dpend[nx][ny][dir]; dpenddir[x][y][dir] = dpenddir[nx][ny][dir];  
    return ret;  
}  
  
void update(int node, int start, int end, int qstart, int qend, int value) {  
    if(qstart>end||qend<start) return;  
    if(qstart<=start&&qend>=end) checkmax(tree[node],value);  
    else {  
        int mid = (start+end)/2;  
        update(2*node+1,start,mid,qstart,qend,value); update(2*node+2,mid+1,end,qstart,qend,value);  
    }  
    return;  
}  
  
int query(int node, int start, int end, int length) {  
    if(length<start||length>end) return -1;  
    if(start==end) return tree[node];  
    int mid = (start+end)/2, temp = 0;  
    if(length>mid) temp = query(2*node+2,mid+1,end,length);  
    else temp = query(2*node+1,start,mid,length);  
    return big(temp,tree[node]);  
}  
  
void bottom(int y, int dir) {  
    _(bottomvis,0);  
    int leftend = y, rightend = y, prevlength = 1, time = 0, now = y, nowdir = dir;  
    while(!bottomvis[now][nowdir]) {  
        bottomvis[now][nowdir] = true;  
        int next = dpend[0][now][nowdir], nextdir = dpenddir[0][now][nowdir];  
        time += dp[0][now][nowdir];  
        if(next>rightend) {  
            update(0,0,Y,prevlength,next,time);  
            rightend = next;  
        } else if(next<leftend) {  
            update(0,0,Y,prevlength,Y-next-1,time);  
            leftend = next;  
        }  
        int nowlength = rightend-leftend+1;  
        prevlength = nowlength, now = next, nowdir = nextdir;  
    }  
    return;  
}  
  
int main (int argc, char const* argv[]) {  
      
    X = GI, Y = GI;  
    N = GI;  
    _(block,0); _(dp,-1); _(vis,0); _(tree,0);  
    int cnt = 0;  
    REP(i,N) {  
        xx[i] = GI, yy[i] = GI;  
        block[xx[i]][yy[i]] = true;  
        cnt++;  
    }  
    REP(i,Y) REP(j,4) go(0,i,j);  
    REP(i,Y) REP(j,4) bottom(i,j);   
    Q = GI;  
    while(Q--) printf("%d\n",query(0,0,Y,GI));  
      
    return 0;  
}  
