#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

int X,Y;
int a[1010][1010];
ll sumx[1010],sumy[1010];
ll costx[1010],costy[1010];

int main(void){
    int i,j;
    
    cin >> X >> Y;
    REP(i,X) REP(j,Y) cin >> a[i][j];
    REP(i,X) REP(j,Y){
        sumx[i] += a[i][j];
        sumy[j] += a[i][j];
    }
    
    REP(i,X+1) REP(j,X) costx[i] += sumx[j] * (2*i-2*j-1) * (2*i-2*j-1);
    REP(i,Y+1) REP(j,Y) costy[i] += sumy[j] * (2*i-2*j-1) * (2*i-2*j-1);
    
    int ansx = 0, ansy = 0;
    REP(i,X+1) if(costx[i] < costx[ansx]) ansx = i;
    REP(i,Y+1) if(costy[i] < costy[ansy]) ansy = i;
    
    cout << 4 * (costx[ansx] + costy[ansy]) << endl << ansx << ' ' << ansy << endl;;
    
    return 0;
}