#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

bool can(ll N, ll M, ll K){
    int i;
    
    if(K < 40 && (1ll<<K) < N) return false;
    
    ll cnt = 0, sum = 0, x = 1;
    for(i=0;;i++){
        ll tmp = min(N-cnt,x);
        cnt += tmp; sum += tmp * i;
        if(cnt == N) break;
        x = x * (K - i) / (i + 1);
    }
    
    M = min(M,N-M);
    return (sum <= K * M);
}

int theMin(int N, int M){
    int high = N-1, low = 0;
    
    if(N == 1) return 0;
    
    while(high-low > 1){
        int mid = (high + low) / 2;
        if(can(N,M,mid)) high = mid; else low = mid;
    }
    
    return high;
}
    
int main(void){
    int T,t,N,M;
        
    cin >> T;
    REP(t,T){
        cin >> N >> M;
        if(M > N/2) M = N/2;
        int ans = theMin(N,M);
        cout << ans << endl;
    }
    
    return 0;
}