#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

#define INF (1<<29)

int h[5010];
int bound[5010][5010];
int dp[5010][5010];

int main(void){
    int N,i,j;
    
    cin >> N;
    REP(i,N) cin >> h[i+1];
    REP(i,N) h[i+1] += h[i];
    
    REP(i,N+1){
        int k = i;
        for(j=i;j<=N;j++){
            while(k > 0 && h[i] - h[k-1] <= h[j] - h[i]) k--;
            bound[i][j] = k;
        }
    }
    
    REP(i,N+1) REP(j,N+1) dp[i][j] = -INF;
    for(j=1;j<=N;j++) for(i=j-1;i>=0;i--){
        dp[i][j] = dp[i+1][j];
        int k = bound[i][j];
        dp[i][j] = max(dp[i][j], dp[k][i] + 1);
        if(i == 0) dp[i][j] = max(dp[i][j], 1);
    }
    
    cout << N - dp[0][N] << endl;
    
    return 0;
}