#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

#define INF 1.0E+9

int K,N;
vector <int> v[1010];
vector <int> all;
int a[1010],b[1010],c[1010];

double flog[1010];
double p[1010],q[1010];
double dp[1010][1010];

int main(void){
    int i,j,k,x;
    
    cin >> K >> N;
    REP(i,N){
        int len;
        cin >> len;
        REP(j,len){
            cin >> x;
            v[i].push_back(x);
        }
    }
    
    REP(i,N) REP(j,v[i].size()) all.push_back(v[i][j]);
    sort(all.begin(),all.end());
    reverse(all.begin(),all.end());
    
    x = all[K-1];
    REP(i,N) REP(j,v[i].size()) if(v[i][j] < x) a[i]++; else if(v[i][j] == x) b[i]++; else c[i]++;
    REP(i,N) K -= c[i];
    
    REP(i,1000) flog[i+1] = flog[i] + log(i+1.0);
    
    REP(i,N) p[i] = exp(flog[a[i]+b[i]] + flog[c[i]] - flog[a[i]+b[i]+c[i]]);
    REP(i,N) if(b[i] == 1) q[i] = exp(flog[a[i]] + flog[b[i]+c[i]] - flog[a[i]+b[i]+c[i]]);
    
    int K2 = 0;
    REP(i,N) if(b[i] == 1) K2++;
    
    dp[0][0] = 1.0;
    REP(i,N) REP(j,i+1){
        dp[i+1][j] += dp[i][j] * p[i];
        dp[i+1][j+1] += dp[i][j] * q[i];
    }
    
    double ans = dp[N][K];
    ans *= exp(flog[K] + flog[K2-K] - flog[K2]);
    printf("%.12f\n", ans);
    
    return 0;
}