#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

int gcd(int x, int y){
    return x ? gcd(y%x,x) : y;
}

bool sqf(int x){
    int i;
    for(i=2;i*i<=x;i++) if(x % (i*i) == 0) return false;
    return true;
}

int sgn(int x){
    int i;
    
    int ans = 1;
    for(i=2;i*i<=x;i++) if(x%i == 0){
        ans = -ans;
        x /= i;
    }
    if(x > 1) ans = -ans;
    
    return ans;
}

int func(int x, int M){
    int ans=0,i;
    for(i=1;i<=M;i++) if(gcd(x,i) == 1) ans += M/i;
    return ans;
}

int main(void){
    int A,B,C,s,x;
    
    cin >> A >> B >> C;
    
    ll ans = 0;
    
    for(s=1;s<=2000;s++) if(sqf(s)){
        int coef = sgn(s);
        for(x=1;x<=A;x++) if(gcd(x,s) == 1) ans += (ll)(A/x) * (ll)coef * (ll)func(x,B/s) * (ll)func(x,C/s);
    }
    
    cout << ans % (1<<30) << endl;
    
    return 0;
}