#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

int N;
int b[4010];
int next[4010];
int dp[4010][4010];

void calc(int x){
    int i;
    next[N-1] = N;
    for(i=N-2;i>=0;i--) if(b[i+1] == x) next[i] = i+1; else next[i] = next[i+1];
}

int main(void){
    int i,j,ans=0;
    
    cin >> N;
    REP(i,N) cin >> b[i];
    
    if(N == 1){
        cout << 1 << endl;
        return 0;
    }
    
    for(i=N-2;i>=0;i--){
        calc(b[i]);
        for(j=i+1;j<N;j++){
            dp[i][j] = 2;
            if(next[j] != N) dp[i][j] = dp[j][next[j]] + 1;
            ans = max(ans, dp[i][j]);
        }
    }
    
    cout << ans << endl;
    
    return 0;
}