#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;

#define FOR(it, c) for(__typeof((c).begin()) it = (c).begin(); it != (c).end(); it++)
#define SZ(c) ((int)(c).size())

const int N = 300005;
int a[N][3], na[N];
int g[N];
int active[N], acnt = 0;
int stack[N], top=0, instack[N];
int is_active(int x) {
    int cnt=0;
    for(int i=0;i<na[x];i++)
        if(g[a[x][i]] == g[x]) ++cnt;
    return cnt>1;
}
void unsetnode(int x) {
    active[x] = 0;
    for(int i=0;i<na[x];i++) active[a[x][i]] = 0;
}
void setnode(int x) {
    for(int i=0;i<na[x];i++) if(is_active(a[x][i])) {
        active[a[x][i]] = 1;
        if(instack[a[x][i]]==0) {
            stack[top++] = a[x][i];
            instack[a[x][i]] = 1;
        }
    }
}
int main(void) {
    int n, m;
    scanf("%d%d", &n, &m);
    for(int i=0;i<m;i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        a[x][na[x]++] = y;
        a[y][na[y]++] = x;
    }
    for(int i=1;i<=n;i++) if(na[i]>1) {
        stack[top++] = i;
        instack[i] = 1;
        active[i] = 1;
        acnt++;
    }
    while(top) {
        int x = stack[--top];
        instack[x] = 0;
        if(!active[x]) continue;
        unsetnode(x);
        g[x]^=1;
        setnode(x);
    }
    for(int i=1;i<=n;i++) printf("%d", g[i]);
    puts("");
    return 0;
}