#include <map>
#include <set>
#include <cmath>
#include <stack>
#include <queue>
#include <string>
#include <vector>
#include <bitset>
#include <fstream>
#include <sstream>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <iostream>
#include <algorithm>
//#include <sys/time.h>
using namespace std;
#define li        long long int
#define rep(i,to) for(li i=0;i<((li)(to));++i)
#define pb        push_back
#define sz(v)     ((li)(v).size())
#define bit(n)    (1ll<<(li)(n))
#define all(vec)  (vec).begin(),(vec).end()
#define each(i,c) for(__typeof((c).begin()) i=(c).begin();i!=(c).end();i++)
#define MP        make_pair
#define F         first
#define S         second



#define MAX 300500
vector<li> parent_to_represent[MAX];
vector<li> represent_to_child[MAX];
li represent_num[MAX];
li represent_m;
li num_of_parent_represent_of_col[MAX];
vector<vector<li> > mp;
pair<li, li> row[MAX];


int main()
{
	li n, m;
	cin >> n >> m;
	mp = vector<vector<li> >(n, vector<li>(m, 0));
	rep(i, n)rep(j, m) cin >> mp[i][j];
	
	rep(i, n){
		rep(j, m) row[j].S = j;
		rep(j, m) row[j].F = mp[i][j];
		sort(row, row + m);
		
		li cur = -1;
		li bef_represent = -1;
		li cur_represent = -1;
		rep(j, m)if(row[j].F != -1){
			if(row[j].F != cur){
				bef_represent = cur_represent;
				cur_represent = represent_m++;
				cur = row[j].F;
			}
			represent_num[cur_represent]++;
			parent_to_represent[row[j].S].pb(cur_represent);
			if(bef_represent != -1){
				represent_to_child[bef_represent].pb(row[j].S);
				num_of_parent_represent_of_col[row[j].S]++;
			}
		}
	}
	
	queue<li> q;
	vector<li> ans;
	rep(i, m)if(num_of_parent_represent_of_col[i] == 0) q.push(i);
	
	while(sz(q)){
		li col = q.front();
		ans.pb(col);
		q.pop();
		rep(i, sz(parent_to_represent[col])){
			li represent = parent_to_represent[col][i];
			if(--represent_num[represent] == 0){
				rep(j, sz(represent_to_child[represent])){
					li c = represent_to_child[represent][j];
					if(--num_of_parent_represent_of_col[c] == 0){
						q.push(c);
					}
				}
			}
		}
	}
	
	if(sz(ans) != m){ cout << -1 << endl; return 0; }
	
	rep(i, sz(ans) - 1){
		li col0 = ans[i];
		li col1 = ans[i + 1];
		rep(row, n){
			if(mp[row][col1] == -1){
				mp[row][col1] = mp[row][col0];
			}else if(mp[row][col1] < mp[row][col0]){
				cout << -1 << endl; return 0;
			}
		}
	}
	
	rep(i, sz(ans)) cout << ans[i] + 1 << " "; cout << endl;
}
