#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define NMAX 100100

vector<int> next[NMAX];
vector<pair<int, int> > v;
int degin[NMAX], q[NMAX], li, ls;
int N, M, i, j, k, pj, x;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d", &N, &M);
	for (i = 0; i < N; i++) {
		v.clear();
		for (j = 0; j < M; j++) {
			scanf("%d", &x);
			v.push_back(make_pair(x, j + 1));
		}

		sort(v.begin(), v.end());
		
		if (N == 1) {
			for (j = 1; j < M; j++) {
				next[v[j - 1].second].push_back(v[j].second);
				degin[v[j].second]++;
			}
			continue;
		}
		
		for (j = pj = 0; j < M; j++) {
			//fprintf(stderr, "i=%d j=%d value=%d col=%d\n", i, j, v[j].first, v[j].second);
			if (v[j].first < 0)
				continue;
			while (pj < j && v[pj].first < 0)
				pj++;
			while (pj < j && v[pj + 1].first < v[j].first)
				pj++;
			if (pj < j && v[pj].first < v[j].first) {
				//fprintf(stderr, "i=%d column %d before %d\n", i, v[pj].second, v[j].second);
				for (k = pj; k >= 0 && v[k].first == v[pj].first; k--) {
					next[v[k].second].push_back(v[j].second);
					degin[v[j].second]++;
				}
			}
		}
	}

	// Create a valid ordering.
	li = 1; ls = 0;
	for (i = 1; i <= M; i++)
		if (degin[i] == 0) {
			ls++;
			q[ls] = i;
		}

	while (li <= ls) {
		i = q[li];
		li++;
		for (k = 0; k < next[i].size(); k++) {
			j = next[i][k];
			degin[j]--;
			if (degin[j] == 0) {
				ls++;
				q[ls] = j;
			}
		}
	}
	
	if (ls < M)
		printf("-1\n");
	else {
		for (i = 1; i <= M; i++) {
			printf("%d", q[i]);
			if (i < M)
				printf(" ");
		}
		printf("\n");
	}
	
	return 0;
}