#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define NMAX 333
#define TMAX 100111
#define MOD 1000000007

char visited[NMAX];
int cnt[2][TMAX], answer;
int a[NMAX], v[NMAX], s[NMAX], next[NMAX], prev[NMAX];
int N, Q, T, i, j, k, S, curr, prv;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d %d", &N, &Q, &T);
	for (i = 1; i <= N; i++)
		scanf("%d", &a[i]);

	for (k = 1; k <= Q; k++) {
		scanf("%d %d", &i, &j);
		next[i] = j;
		prev[j] = i;
	}

	cnt[curr = 0][0] = 1;
	for (i = 1; i <= N; i++)
		if (!prev[i]) {
			k = 1;
			v[1] = i;
			s[1] = a[i];

			while (1) {
				if (!next[v[k]])
					break;
				v[k + 1] = next[v[k]];
				s[k + 1] = s[k] + a[v[k + 1]];
				k++;
			}
		
			for (j = 1; j <= k; j++) {
				visited[v[j]] = 1;
				//fprintf(stderr, "j=%d coin=%d a=%d s=%d\n", j, v[j], a[v[j]], s[j]);
				
				if (j < k) {
					prv = curr;
					curr = 1 - curr;
					memset(cnt[curr], 0, sizeof(cnt[curr]));
					for (S = s[j]; S <= T; S++) {
						cnt[curr][S] = (cnt[curr][S - s[j]] + cnt[prv][S - s[j]]);
						if (cnt[curr][S] >= MOD)
							cnt[curr][S] -= MOD;
					}
				} else {
					for (S = s[j]; S <= T; S++) {
						cnt[curr][S] += cnt[curr][S - s[j]];
						if (cnt[curr][S] >= MOD)
							cnt[curr][S] -= MOD;
					}
				}
			}
		}
	
	answer = cnt[curr][T];
	for (i = 1; i <= N; i++)
		if (!visited[i])
			answer = 0;
	
	printf("%d\n", answer);
	return 0;
}
