#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define DEBUG 0
#define NMAX 1000001

int next[NMAX], prev[NMAX], p[NMAX];
int N, i, j, k, cpoz, targetpoz, nk;

void Swap() {
	for (i = 1; i < nk; i++) {
		if (DEBUG) {
			fprintf(stderr, "At k=%d: p[%d]=%d\n", k, i, p[i]);
		}

		if (next[p[i]] == N + 1)
			continue;
		
		next[prev[p[i]]] = next[p[i]];
		prev[next[p[i]]] = prev[p[i]];
		j = next[p[i]];
		
		prev[p[i]] = prev[p[i + 1]];
		next[p[i]] = p[i + 1];
		next[prev[p[i + 1]]] = p[i];
		prev[p[i + 1]] = p[i];
		
		p[i] = j;
	}

	if (DEBUG) {
		fprintf(stderr, "After k=%d: ", k);
		for (i = 0; i != N + 1; i = next[i]) {
			if (i >= 1 && i <= N)
				fprintf(stderr, "%d ", i);
		}

		fprintf(stderr, "\n");
		for (i = 1; i < nk; i++)
			fprintf(stderr, "  p[%d]=%d\n", i, p[i]);
	}
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++) {
		next[i] = i + 1;
		prev[i] = i - 1;
	}
	
	next[0] = 1;
	prev[N + 1] = N;
	
	p[nk = 1] = 1;
	for (i = 3; i <= N; i += 2) {
		nk++;
		p[nk] = i;
	}

	nk++;
	p[nk] = N + 1;
	k = 2;
	Swap();

	for (k = 3; k <= N; k++) {
		for (i = 2; i < nk; i++) {
			cpoz = 1 + (i - 1) * (k - 1);
			targetpoz = 1 + (i - 1) * k;
			
			if (1 + (i - 2) * k > cpoz) {
				cpoz = 1 + (i - 2) * k;
				p[i] = p[i - 1];
			}

			while (cpoz < targetpoz) {
				p[i] = next[p[i]];
				cpoz++;
				if (p[i] == N + 1)
					break;
			}

			if (p[i] == N + 1) {
				nk = i;
				break;
			}
		}

		Swap();
	}

	for (i = 0; i != N + 1; i = next[i]) {
		if (i >= 1 && i <= N) {
			printf("%d", i);
			if (next[i] != N + 1)
				printf(" ");
		}
	}
	
	printf("\n");	
	return 0;
}
