#pragma comment(linker, "/STACK:60000000")
#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <ctime>
#include <cstring>
#include <cassert>
#include <sstream>
#include <iomanip>
#include <complex>
#include <queue>
#include <functional>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define last(a) int(a.size() - 1)
#define all(a) a.begin(), a.end()
#define seta(a,x) memset (a, x, sizeof (a))
#define I (int)

typedef long long int64;
typedef pair <int, int> pii;
typedef long double ldb;

const long double eps = 1e-9;
const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const long double pi = 3.1415926535897932384626433832795;

template <class T> T sqr (T x) {return x * x;}

string s1, s2;
char buf[2000000];
int next[10000][26];

int main ()
{
//	freopen ("input.txt", "r", stdin);
//	freopen ("output.txt", "w", stdout);
	scanf ("%s", buf);
	s1 = buf;
	scanf ("%s", buf);
	s2 = buf;
	int n = s1.length();
	seta (next, 255);
	forn (j, 26) 
		if (s1.find ('a' + j) != -1) {
			int p = 0;
			char c = j + 'a';
			forn (i, n) {
				if (i == p) 
					p = (p + 1) % n;
				while (s1[p] != c) 
					p = (p + 1) % n;
				next[i][j] = p;
			}
		}
	int res = 0;
	int p = n-1;
	forn (i, s2.length()) {
		char c = s2[i] - 'a';
		if (next[p][c] == -1) {
			cout << -1 << endl;
			return 0;
		}
		if (next[p][c] <= p)
			res ++;
		p = next[p][c];
	}
	cout << res << endl;
	return 0;
}

----

#pragma comment(linker, "/STACK:60000000")
#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <ctime>
#include <cstring>
#include <cassert>
#include <sstream>
#include <iomanip>
#include <complex>
#include <queue>
#include <functional>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define last(a) int(a.size() - 1)
#define all(a) a.begin(), a.end()
#define seta(a,x) memset (a, x, sizeof (a))
#define I (int)

typedef long long int64;
typedef pair <int, int> pii;
typedef long double ldb;

const long double eps = 1e-9;
const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const long double pi = 3.1415926535897932384626433832795;

template <class T> T sqr (T x) {return x * x;}

int n;
vector <pii> a;
int ans[100000];
int x;

int main ()
{
//	freopen ("input.txt", "r", stdin);
//	freopen ("output.txt", "w", stdout);
	scanf ("%d", &n);
	a.resize (n);
	forn (i, n) {
		a[i].sc = i;
		scanf ("%d", &a[i].fs);
	}
	sort (all (a));
	int l = 0;
	x = -1;
	while (l < n) {
		int r = l;
		while (r + 1 < l && a[r+1].fs == a[l].fs)
			r ++;
		for (int i = l; i <= r; i ++) {
			if (x < a[i].sc)
				ans[a[i].sc] = -1;
			else
				ans[a[i].sc] = x - a[i].sc - 1;
		}
		for (int i = l; i <= r; i ++)
			x = max (x, a[i].sc);
		l = r + 1;
	}
	forn (i, n)
		printf ("%d ", ans[i]);
	cout << endl;
	return 0;
}

----

#pragma comment(linker, "/STACK:60000000")
#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <ctime>
#include <cstring>
#include <cassert>
#include <sstream>
#include <iomanip>
#include <complex>
#include <queue>
#include <functional>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define last(a) int(a.size() - 1)
#define all(a) a.begin(), a.end()
#define seta(a,x) memset (a, x, sizeof (a))
#define I (int)

typedef long long int64;
typedef pair <int, int> pii;
typedef long double ldb;

const long double eps = 1e-9;
const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const long double pi = 3.1415926535897932384626433832795;

template <class T> T sqr (T x) {return x * x;}

int n, m, k;
int l[100000];

int leader (int v) {
	if (l[v] != v)
		l[v] = leader (l[v]);
	return l[v];
}

void unite (int x, int y) {
	x = leader (x);
	y = leader (y);
	l[y] = x;
}

int power[1000000];
const int P = 1000000009;

int main ()
{
//	freopen ("input.txt", "r", stdin);
//	freopen ("output.txt", "w", stdout);
	scanf ("%d%d", &n, &m);
	power[0] = 1;
	for (int i = 1; i < 1000000; i ++)
		power[i] = (power[i-1] * 2) % P;	
	forn (i, n)
		l[i] = i;
	k = 0;
	forn (i, m) {
		int x, y;
		scanf ("%d%d", &x, &y);
		if (leader (x) != leader (y)) 
			unite (x, y);
		else
			k ++;
		printf ("%d\n", (power[k] + P - 1) % P);
	}
	return 0;
}

----

#pragma comment(linker, "/STACK:60000000")
#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <ctime>
#include <cstring>
#include <cassert>
#include <sstream>
#include <iomanip>
#include <complex>
#include <queue>
#include <functional>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define last(a) int(a.size() - 1)
#define all(a) a.begin(), a.end()
#define seta(a,x) memset (a, x, sizeof (a))
#define I (int)

typedef long long int64;
typedef pair <int, int> pii;
typedef long double ldb;

const long double eps = 1e-9;
const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const long double pi = 3.1415926535897932384626433832795;

template <class T> T sqr (T x) {return x * x;}

vector < pair < vector <int>, vector <int> > > ans, threes, twos;
int n;
vector <int> a;
char buf[100];

pair < vector <int>, vector <int> > merge (pair < vector <int>, vector <int> > a, pair < vector <int>, vector <int> > b) {
	a.fs.insert (a.fs.end(), b.fs.begin(), b.fs.end());
	a.sc.insert (a.sc.end(), b.sc.begin(), b.sc.end());
	return a;
}

void split (pair < vector <int>, vector <int> > a) {
	pair < vector <int>, vector <int> > a1, a2;
	a1.fs.pb (a.fs[0]);
	a1.fs.pb (a.fs[1]);
	a1.sc.pb (a.fs[1]);
	a1.sc.pb (a.fs[0]);

	a2.fs.pb (a.fs[0]);
	a2.fs.pb (a.fs[2]);
	a2.sc.pb (a.fs[2]);
	a2.sc.pb (a.fs[0]);

	twos.pb (a2);
	twos.pb (a1);
}

int main ()
{
//	freopen ("input.txt", "r", stdin);
//	freopen ("output.txt", "w", stdout);
	scanf ("%d", &n);
	a.resize (n);
	forn (i, n)
		scanf ("%d", &a[i]);
	forn (i, n)
		a[i] --;
	ans.clear ();
	threes.clear ();
	twos.clear ();
	forn (i, n)
		while (a[i] != i) {
			int v = i;
			vector <int> tmp;
			tmp.pb (v);
			while (I tmp.size() < 5 && a[v] != i) {
				v = a[v];
				tmp.pb (v);
			}
			vector <int> tmpans;
			forn (i, tmp.size()) 
				tmpans.pb (tmp[(i+1)%tmp.size()]);
			if (tmp.size() == 2)
				twos.pb (mp (tmp, tmpans));
			else
			if (tmp.size() == 3)
				threes.pb (mp (tmp, tmpans));
			else
				ans.pb (mp (tmp, tmpans));
			ford (i, tmp.size())
				if (i)
					swap (a[tmp[(i+1)%tmp.size()]], a[tmp[i]]);
		}
	while (threes.size() > 0) {
		if (twos.size() > 0) {
			ans.pb (merge (twos.back(), threes.back()));
			twos.pop_back();
			threes.pop_back();
			continue;
		}
		if (threes.size() == 1) {
			ans.pb (threes.back());
			threes.pop_back();
			continue;
		}
		split (threes.back());
		threes.pop_back();
	}

	while (twos.size() > 0) {
		if (twos.size() == 1) {
			ans.pb (twos.back());
			twos.pop_back();
			continue;
		}
		pair < vector <int>, vector <int> > tmp = twos.back();
		twos.pop_back();
		ans.pb (merge (tmp, twos.back()));
		twos.pop_back();
	}
	printf ("%d\n", ans.size());
	forn (i, ans.size()) {
		printf ("%d\n", ans[i].fs.size());
		forn (j, ans[i].fs.size())
			printf ("%d ", ans[i].fs[j]+1);
		printf ("\n");
		forn (j, ans[i].fs.size())
			printf ("%d ", ans[i].sc[j]+1);
		printf ("\n");
	}
	return 0;
}

----

#pragma comment(linker, "/STACK:60000000")
#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <ctime>
#include <cstring>
#include <cassert>
#include <sstream>
#include <iomanip>
#include <complex>
#include <queue>
#include <functional>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; i--)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define last(a) int(a.size() - 1)
#define all(a) a.begin(), a.end()
#define seta(a,x) memset (a, x, sizeof (a))
#define I (int)

typedef long long int64;
typedef pair <int, int> pii;
typedef pair <int64, int64> pii64;
typedef long double ldb;

const long double eps = 1e-9;
const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const long double pi = 3.1415926535897932384626433832795;

template <class T> T sqr (T x) {return x * x;}

const int blocksize = 250;

struct block {
	int l, r;
	int size;
	int64 next_time;
	int pmax;
};

int n, k, m;
pii64 A[100000];
block blocks[500];
int ans[100000];
int L[100000], R[100000], T[100000];
vector <pii> Q;

bool myless (pii64 a, pii64 b, int64 tm) {
	return a.fs + tm * a.sc < b.fs + tm * b.sc;
}

void process (int v, int64 tm) {
	int best = blocks[v].l;
	for (int i = blocks[v].l; i <= blocks[v].r; i ++)
		if (myless (A[best], A[i], tm))
			best = i;
	blocks[v].pmax = best;
	blocks[v].next_time = inf;
	pii64 cur = A[best];
	for (int i = blocks[v].l; i <= blocks[v].r; i ++) {
		pii64 tmp = A[i];
		if (cur.sc < tmp.sc)
			blocks[v].next_time = min (blocks[v].next_time, (cur.fs - tmp.fs) / (tmp.sc - cur.sc) + 1);
	}
}

int main ()
{
//	freopen ("input.txt", "r", stdin);
//	freopen ("output.txt", "w", stdout);
	scanf ("%d%d", &n, &k);
	forn (i, n) {
		int x, y;
		scanf ("%d %d", &x, &y);
		A[i] = mp ((int64)x, (int64)y);
	}
	Q.resize (k);
	forn (i, k) {
		scanf ("%d%d%d", &L[i], &R[i], &T[i]);
		L[i] --;
		R[i] --;
		Q[i] = mp (T[i], i);
	}
	sort (all (Q));
	int l = 0;
	int m = 0;
	while (l < n) {
		int r = min (l + blocksize - 1, n-1);
		blocks[m].l = l;
		blocks[m].r = r;
		blocks[m].size = r - l + 1;
		l = r + 1;
		m ++;
	}
	forn (i, m) {
		blocks[i].pmax = blocks[i].l;
		blocks[i].next_time = -1;
	}
	forn (i, k) {
		int num = Q[i].sc;
		int best = L[num];
		int r1 = R[num];
		int l1 = L[num];
		forn (j, m) {
			if (T[num] >= blocks[j].next_time)
				process (j, T[num]);
			if (L[num] <= blocks[j].l && blocks[j].r <= R[num]) {
				if (myless (A[best], A[blocks[j].pmax], T[num]))
					best = blocks[j].pmax;
				r1 = min (r1, blocks[j].l - 1);
				l1 = max (l1, blocks[j].r + 1);
			}
		}
		l1 = max (l1, r1 + 1);
		for (int j = L[num]; j <= r1; j ++)
			if (myless (A[best], A[j], T[num]))
				best = j;
		for (int j = l1; j <= R[num]; j ++)
			if (myless (A[best], A[j], T[num]))
				best = j;
		ans[num] = best;
	}
	forn (i, k)
		printf ("%d\n", ans[i]+1);
	return 0;
}