#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

string s;
int a[33];
int k;
bool u[33];

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
//	freopen("output.txt","w",stdout);
#endif
	getline(cin,s);
	cin>>k;
	REP(i,s.size()) a[s[i]-'a']++;

	vector<pii> v;
	REP(i,26) v.pb(pii(a[i],i));
	SORT(v);
	int curr = 0;
	while(v.size() && curr + v[0].first<=k){
		curr += v[0].first;
		u[v[0].second] = true;
		v.erase(v.begin());
	}
	cout<<v.size()<<endl;
	string t;
	REP(i,s.size()) if(!u[s[i]-'a']) t.pb(s[i]);
	printf("%s",t.c_str());

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}

----

#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

const int mod = 1000000007 ;

int n,m;
int s[111111];
int t[111111];
vi x;
vector<pii> r;

int rr[444444];

void add(int pos,int val){
	pos += 222222;
	while(pos){
		rr[pos] += val;
		if(rr[pos]>=mod) rr[pos]-=mod;
		pos>>=1;
	}
}

int sum(int p1,int p2){
	p1 += 222222;
	p2 += 222222;

	int res = 0;
	while(p1<=p2){
		if(p1&1){
			res += rr[p1];
			if(res>=mod) res-=mod;
		}
		if(!(p2&1)){
			res += rr[p2];
			if(res>=mod) res-=mod;
		}
		p1= (p1+1)>>1;
		p2=(p2-1)>>1;
	}
	return res;
}

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
//	freopen("output.txt","w",stdout);
#endif

	cin>>n>>m;
	REP(i,m) scanf("%d %d",s+i,t+i),x.pb(s[i]),x.pb(t[i]);
	x.pb(0);
	x.pb(n);
	UN(x);
	REP(i,m){
		s[i] = lower_bound(x.begin(),x.end(),s[i])-x.begin();
		t[i] = lower_bound(x.begin(),x.end(),t[i])-x.begin();
		r.pb(pii(t[i],s[i]));
	}
	SORT(r);
	
	add(0,1);
	REP(i,r.size())
		add(r[i].first, sum(r[i].second, r[i].first-1));
	cout<<sum(x.size()-1,x.size()-1)<<endl;

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}

----

#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int x[3],y[3];

ll det(ll a,ll b, ll c,ll d){return a*d-b*c;}

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
//	freopen("output.txt","w",stdout);
#endif

	REP(i,3) cin>>x[i]>>y[i];
	
	REP(i,4){
		swap(x[0],y[0]);
		y[0] = -y[0];

		int a = x[1] - x[0];
		int b = y[1] - y[0];
		ll d = det(x[2], y[2], y[2], -x[2]);
		ll d1 = det(a, y[2], b, -x[2]);
		ll d2 = det(x[2], a, y[2], b);
		if(d==0){
			if(a==0 && b==0){
				puts("YES");
				return 0;
			}
		}else{
			if(d<0) d=-d;
			if(d1%d==0 && d2%d==0){
				puts("YES");
				return 0;
			}
		}
	}

	puts("NO");


#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}

----

#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

struct R{
	double s;
	int c;
	int len;

	bool operator<(const R& s)const{
		return len *ll(s.c)<s.len*ll(c);
	}
};

int n;
vector<pii> v[111111];

R solve(int ver,int par=-1){
	R res;
	
	res.c=1;
	res.len=0;
	res.s=0;

	vector<R> q;
	REP(i,v[ver].size()) if(v[ver][i].first != par){
		q.pb(solve(v[ver][i].first, ver));
		q.back().s += v[ver][i].second * q.back().c;
		q.back().len += 2 * v[ver][i].second;
	}
	sort(q.begin(),q.end());

	REP(i,q.size()){
		if(i==0){ res = q[i]; res.c++;}
		else{
			res.s += q[i].s;
			res.s += double(q[i].c) * res.len;
			
			res.c+=q[i].c;
			res.len += q[i].len;
		}
	}

	return res;
}

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
//	freopen("output.txt","w",stdout);
#endif

	cin>>n;
	REP(i,n-1){
		int x,y,z;
		scanf("%d %d %d",&x,&y,&z);
		x--,y--;
		v[x].pb(pii(y,z));
		v[y].pb(pii(x,z));
	}

	R res = solve(0);
	printf("%.10lf\n",res.s / (n-1));

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}

----

#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int n,m,p;
int x[22222];
int y[22222];
int d[10007][650];

int d1[20000];
int d2[20000];

string res;
bool first = true;

void go(){
	if(n==0 && m==0) return;
	if(n==0){
		res.pb('S');
		m--;
		go();
		return;
	}
	if(m==0){
		res.pb('C');
		n--;
		go();
		return;
	}
	
	if(n==10000 && first){
		first = false;
		return;
	}

	int row = n;
	if(row>10000) row-=10000;

	int md = m % 31;
	int dv = m / 31;
			
	if(d[row][dv] &(1<<md)){
		res.pb('S');
		m--;
		go();
	}else{
		res.pb('C');
		n--;
		go();
	}
}

int solve(){
	CL(d1,0);
	CL(d2,0);
	CL(d,0);

	int *f1 = d1;
	int *f2 = d2;

	REP(i,n){
		int md = -1;
		int dv = 0;
		REP(j,m){
			md ++;
			if(md>=31) md-=31,dv++;
			int row = i;
			if(row>10000) row-=10000;
			if(d[row][dv] &(1<<md))
				d[row][dv] ^= (1<<md);

			f1[j] = (x[i]+y[j]);
			if(f1[j]>=p) f1[j]-=p;

			int v1 = j?f1[j-1]:-1;
			int v2 = i?f2[j]:-1;

			if(v1==-1 && v2==-1) continue;
			
			
			if(v1>v2){
				f1[j] += v1;
				d[row][dv] |= (1<<md);
			}else{
				f1[j] += v2;
			}
		}
		swap(f1,f2);
	}
	return f2[m-1];
}

bool check(string s,int val){
	int t = (x[0] +y[0])%p;
	int a = 0, b = 0;
	REP(i,s.size()){
		if(s[i]=='C') a++;
		else b++;
		t += (x[a] + y[b])%p;
	}
	if(t!=val){
		puts("FUCK");
		return 0;
	}
	else puts("OK");
	return 1;
}

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
//	freopen("output.txt","w",stdout);
#endif
	cin>>n>>m>>p;
	
	/*int it = 0;
here:
	it++;
	srand(it);
	
	n = 11111;//9999 + rand()%10 + 1;
	m = 5;// + rand() %100 + 1;
	p = rand() % 1000 + 1;
	*/
	REP(i,n){
		scanf("%d",x+i);
		//x[i] = rand();
		x[i]%=p;
	}
	REP(i,m){
		scanf("%d",y+i);
		//y[i] = rand();
		y[i]%=p;
	}
	
	res="";
	int qq = solve();
	cout<<qq<<endl;
	n--,m--;
	go();
	n++,m++;
	solve();
	n--,m--;
	go();
	reverse(res.begin(),res.end());
	//if(check(res,qq))
	//	goto here;
	printf("%s\n",res.c_str());
#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}