#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

int main(void){
    int N,i,j;
    
    cin >> N;
    
    REP(i,7){
        int M = N - 4*i;
        if(M >= 0 && M%7 == 0){
            string ans;
            REP(j,i) ans += '4';
            REP(j,M/7) ans += '7';
            printf("%s\n",ans.c_str());
            return 0;
        }
    }
    
    cout << "-1" << endl;
    
    return 0;
}

----

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

vector <ll> v;

void dfs(ll x){
    if(x > 1000000000) return;
    v.push_back(x);
    dfs(10*x+4);
    dfs(10*x+7);
}

ll func(ll x1, ll x2, ll y1, ll y2, int K){ // x <= y
    int i,j;
    int sz = v.size();
    
    ll ans = 0;
    REP(i,sz){
        j = i + K - 1;
        if(j >= sz) break;
        ll xlow = x1, xhigh = x2, ylow = y1, yhigh = y2;
        if(i != 0) xlow = max(xlow,v[i-1]+1);
        xhigh = min(xhigh,v[i]);
        ylow = max(ylow,v[j]);
        if(j != sz-1) yhigh = min(yhigh,v[j+1]-1);
        if(xhigh >= xlow && yhigh >= ylow) ans += (xhigh - xlow + 1) * (yhigh - ylow + 1);
    }
    
    return ans;
}

int main(void){
    int i;
    
    dfs(4); dfs(7);
    sort(v.begin(),v.end());
    int sz = v.size();
    
    ll x1,y1,x2,y2;
    int K;
    cin >> x1 >> x2 >> y1 >> y2 >> K;
    
    ll total = (x2 - x1 + 1) * (y2 - y1 + 1);
    ll tmp = func(x1,x2,y1,y2,K) + func(y1,y2,x1,x2,K);
    if(K == 1) REP(i,sz) if(v[i] >= x1 && v[i] <= x2 && v[i] >= y1 && v[i] <= y2) tmp--;
    
    double ans = (double)tmp / total;
    printf("%.12f\n",ans);
    
    return 0;
}

----

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

#define MAXV 100010
int parent[MAXV],rank[MAXV];

struct UnionFind{

    UnionFind(int n){
        int i;
        REP(i,n) {parent[i] = i; rank[i] = 1;}
    }

    int root(int x){
        if(parent[x] != x) parent[x] = root(parent[x]);
        return parent[x];
    }

    void connect(int x, int y){
        int rx=root(x),ry=root(y);
        if(rx == ry) return;
        if(rank[rx] > rank[ry]) {parent[ry] = rx; rank[rx] += rank[ry];}
        if(rank[rx] <= rank[ry]) {parent[rx] = ry; rank[ry] += rank[rx];}
    }
    
    int getsize(int x){
        int rx = root(x);
        return rank[rx];
    }
    
};

bool lucky(int n){
    while(n > 0){
        if(n%10 != 4 && n%10 != 7) return false;
        n /= 10;
    }
    return true;
}

int main(void){
    int N,a,b,c,i;
    
    scanf("%d",&N);
    UnionFind uf(N);
    REP(i,N-1){
        scanf("%d%d%d",&a,&b,&c);
        if(!lucky(c)) uf.connect(a-1,b-1);
    }
    
    ll ans = 0;
    REP(i,N){
        ll tmp = N - uf.getsize(i);
        ans += tmp * (tmp - 1);
    }
    
    cout << ans << endl;
    
    return 0;
}

----

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

int N;
int a[100010];
vector <pair <int, int> > p;
int to[100010],ot[100010];

bool used[100010];
vector <pair <int, int> > ans;

bool lucky(int n){
    while(n > 0){
        if(n%10 != 4 && n%10 != 7) return false;
        n /= 10;
    }
    return true;
}

void func(int x, int init){
    if(ot[init] == init){
        used[init] = true;
        return;
    }
    
    int cur = init;
    ans.push_back(make_pair(x,cur));
    
    while(1){
        used[cur] = true;
        int next = ot[cur];
        if(next == init){
            ans.push_back(make_pair(cur,x));
            break;
        }
        ans.push_back(make_pair(cur,next));
        cur = next;
    }
}

int main(void){
    int i;
    
    scanf("%d",&N);
    REP(i,N) scanf("%d",&a[i]);
    
    bool sorted = true;
    REP(i,N-1) if(a[i] > a[i+1]) sorted = false;
    if(sorted){
        cout << 0 << endl;
        return 0;
    }
    
    int x = -1;
    REP(i,N) if(lucky(a[i])) x = i;
    if(x == -1){
        cout << -1 << endl;
        return 0;
    }
    
    REP(i,N) p.push_back(make_pair(a[i],i));
    sort(p.begin(),p.end());
    REP(i,N) to[p[i].second] = i;
    REP(i,N) ot[i] = p[i].second;
    
    int y = to[x];
    if(y != x){
        ans.push_back(make_pair(x,y));
        int z = to[y];
        to[x] = z; ot[z] = x; to[y] = y; ot[y] = y;
        x = y;
    }
    
    used[x] = true;
    REP(i,N) if(!used[i]) func(x,i);
    
    int K = ans.size();
    printf("%d\n",K);
    REP(i,K) printf("%d %d\n", ans[i].first + 1, ans[i].second + 1);
    
    return 0;
}

----

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;
#define INF (1ll<<40)

int lucky(ll x){
    int ans = 0;
    while(x > 0){
        if(x%10 == 4 || x%10 == 7) ans++;
        x /= 10;
    }
    return ans;
}

map <pair <ll, int>, int> mp1;

ll func1(ll low, int x){
    int i;
    ll ans = INF;
    
    if(x < 0) return INF;
    
    pair <ll, int> st = make_pair(low,x);
    if(mp1.find(st) != mp1.end()) return mp1[st];
    
    if(low <= 3){
        if(x == 0) return low;
        ans = 0;
        REP(i,x) ans = ans * 10 + 4;
        return mp1[st] = ans;
    }
    
    REP(i,10){
        if(i < low%10){
            ll tmp = func1(low/10+1,x-lucky(i));
            ans = min(ans,tmp*10+i);
        } else {
            ll tmp = func1(low/10,x-lucky(i));
            ans = min(ans,tmp*10+i);
        }
    }
    
    return mp1[st] = ans;
}

ll func2(ll low, int x, int y){
    int i;
    ll ans = INF;
    
    if(x < 0 || y < 0) return INF;
    
    REP(i,9) if(y - x == lucky(i+1) - lucky(i)){
        if(i < low%10){
            ll tmp = func1(low/10+1,x-lucky(i));
            ans = min(ans,tmp*10+i);
        } else {
            ll tmp = func1(low/10,x-lucky(i));
            ans = min(ans,tmp*10+i);
        }
    }
    
    return ans;
}

ll func3(ll low, int x, int y){
    ll ans = INF;
    
    int i;
    for(i=0;;i++){
        ll tmp = func2(low,x,y);
        int j;
        REP(j,i) tmp = min(tmp * 10 + 9, INF);
        ans = min(ans,tmp);
        
        if(low == 0) return ans;
        low /= 10;
    }
}

ll func(ll low, ll high){
    if(high/10 - low/10 >= 2){
        ll tmp = func(low/10,high/10);
        return tmp * 10 + low % 10;
    }
    
    ll ans = INF;
    
    int i,j,k;
    
    REP(i,10){
        j = i + (int)(high - low);
        if(j >= 20) continue;
        
        int x = lucky(low) - lucky(i);
        int y = 0;
        if(j >= 10) y = lucky(high) - lucky(j-10);
        
        bool failed = false;
        for(k=i;k<=j;k++){
            int tmp1 = lucky(low+k-i);
            int tmp2 = ((k >= 10) ? (y + lucky(k-10)) : (x + lucky(k)));
            if(tmp1 != tmp2){
                failed = true;
                break;
            }
        }
        if(failed) continue;
        
        ll small = (low - i + 10) / 10;
        if(j >= 10){
            ll tmp = func3(small,x,y);
            ans = min(ans,tmp*10+i);
        } else {
            ll tmp = func1(small,x);
            ans = min(ans,tmp*10+i);
        }
    }
    
    return ans;
}

int main(void){
    ll a,d;
    cin >> a >> d;
    ll ans = func(a,a+d-1);
    cout << ans << endl;
    return 0;
}