// Authored by dolphinigle
// CodeForces 83
// 3 Sep 2011

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define DEBUG(x) cout << '>' << #x << ':' << x << '\n';

#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))
#define RESET(Z,Y) memset(Z,Y,sizeof(Z))

#define SZ(Z) ((int)Z.size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;
typedef vector<ll> vll;

int main() {

  ll n, x, y;
  cin >> n >> x >> y;
  FORN(i, n) {
    if (i < n-1) {
      --y;
      --x;
      if (y < 0LL) {
        cout << -1 << endl;
        return 0;
      }
    } else {
      if (y <= 0LL) {
        cout << -1 << endl;
        return 0;
      }
      x -= y*y;
      if (x > 0LL) {
        cout << -1 << endl;
        return 0;
      }
      FORN(j, n-1) {
        printf("1\n");
      }
      cout << y << endl;
      return 0;
    }
  }

  return 0;
}

----

// Authored by dolphinigle
// CodeForces 83
// 3 Sep 2011

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define DEBUG(x) cout << '>' << #x << ':' << x << '\n';

#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))
#define RESET(Z,Y) memset(Z,Y,sizeof(Z))

#define SZ(Z) ((int)Z.size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;
typedef vector<ll> vll;

vector< ll > GetDivisors(long long number) {
	vector<ll> ret;
	for (ll i = 1; i <= ceil(sqrt(number)); ++i) {
		if (number % i == 0) {
			ret.PB(i);
			ret.PB(number / i);
		}
	}
	sort(ALL(ret));
	ret.erase(unique(ALL(ret)), ret.end());
	return ret;
}
//vector<ll> divs = GetDivisors(6); {1,2,3,6} O(sqrt(N))



int main() {

  int n;
  cin >> n;
  int lastdiv[100500];
  FORN(i, 100500) lastdiv[i] = -1;
  FORN(i, n) {
    int num;
    int last;
    scanf("%d%d", &num, &last);
    vector<ll> divisors = GetDivisors(num);
    int ret = 0;
    FORN(j, SZ(divisors)) {
      int d = divisors[j];
      if (lastdiv[d] >= i-last) {
      } else {
        ++ret;
      }
      lastdiv[d] = i;
    }
    printf("%d\n", ret);
  }

  return 0;
}

----

// Authored by dolphinigle
// CodeForces 83
// 3 Sep 2011

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define DEBUG(x) cout << '>' << #x << ':' << x << '\n';

#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))
#define RESET(Z,Y) memset(Z,Y,sizeof(Z))

#define SZ(Z) ((int)Z.size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;
typedef vector<ll> vll;

int dp[45][1 << 6][1 << 6];
int row, col;

int Solve(int nowcol, int up, int now) {
  if (dp[nowcol][up][now] != -1) return dp[nowcol][up][now];
  int& alias = dp[nowcol][up][now];
  if (nowcol == col-1) {
    // we're at the bottom row
    // we have to check it's covered, otherwise we return some huge negative value.
    for (int j = 0; j < row; ++j) {
      int ok = 0;
      for (int k = -1; k < 2; ++k) {
        int c = j+k;
        if (c < 0 || c >= row) continue;
        if (now & (1 << c)) {
          ok = 1;
          break;
        }
      }
      if (up & (1 << j)) ok = 1;
      if (!ok) {
        return alias = -INF;
      }
    }
    alias = 0;
    FORN(j, row) if (!(now & (1 << j))) ++alias;
    return alias;
  } else {
    alias = -INF;
    FORN(mask, (1 << row)) {
      int maskok = 1;
      for (int r = 0; r < row; ++r) {
        int ok = 0;
        for (int k = -1; k < 2; ++k) {
          int rr = r + k;
          if (rr < 0 || rr >= row) continue;
          if ((now & (1 << rr))) {
            ok = 1;
            break;
          }
        }
        if (up & (1 << r)) ok = 1;
        if (mask & (1 << r)) ok = 1;
        if (!ok) {
          maskok = 0;
          break;
        }
      }
      if (!maskok) continue;
      int jml = Solve(nowcol+1, now, mask);
      for (int r = 0; r < row; ++r) if (!(now & (1 << r))) ++jml;
      MX(alias, jml);
    }
    return alias;
  }
}

int main() {

  cin >> row >> col;

  if (row > col) swap(row, col);
  // row <= 6;
  FORN(i, 45) FORN(j, (1 << 6)) FORN(k, (1 << 6)) dp[i][j][k] = -1;
  int ret = -INF;
  FORN(i, (1 << row)) MX(ret, Solve(0, 0, i));
  cout << ret << endl;

  return 0;
}

----

// Authored by dolphinigle
// CodeForces 83
// 3 Sep 2011

#include <vector>
#include <list>
#include <map>
#include <set>

#include <queue>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>

#define FORN(X,Y) for (int (X) = 0;(X) < (Y);++(X))
#define DEBUG(x) cout << '>' << #x << ':' << x << '\n';

#define REP(X,Y,Z) for (int (X) = (Y);(X) < (Z);++(X))
#define RESET(Z,Y) memset(Z,Y,sizeof(Z))

#define SZ(Z) ((int)Z.size())
#define ALL(W) W.begin(), W.end()
#define PB push_back

#define MP make_pair
#define A first
#define B second

#define INF 1023123123
#define EPS 1e-11

#define MX(Z,Y) Z = max((Z),(Y))
#define MN(X,Y) X = min((X),(Y))

#define FORIT(X,Y) for(typeof((Y).begin()) X = (Y).begin();X!=(Y).end();X++)

using namespace std;

typedef long long ll;
typedef double db;
typedef vector<int> vint;
typedef vector<ll> vll;

//(number**exponent) % ivalue;
ll Power(ll number,ll exponent,ll ivalue) {
	ll ret = 1;
	ll multiplier = number;
	while (exponent > 0LL) {
		if (exponent % 2LL) {
      ret = (ret * multiplier) % ivalue;
    }
		exponent /= 2LL;
		multiplier = (multiplier * multiplier) % ivalue;
  }
	return ret;
}

//works if modulo >= 2
ll MultiplicativeInverse(ll number, ll ivalue) {
	return Power(number, ivalue - 2LL, ivalue);
}

ll FastCombination(ll from, ll pick, ll ivalue, bool reset = false) {
  static vector<ll> fact, rfact;
  if (reset) fact = rfact = vector<ll>(0);
  if (SZ(fact) == 0LL) {
    fact.PB(1LL);
    rfact.PB(1LL);
  }
  if (pick > from) return 0LL;
  ll table_size = max(from, max(pick, from-pick));
  while (SZ(fact) <= table_size) {
    fact.PB((fact.back() * (ll)SZ(fact)) % ivalue);
    rfact.PB(MultiplicativeInverse(fact.back(), ivalue));
  }
	ll jahja = (fact[from] * rfact[pick]) % ivalue;
  return (jahja * rfact[from-pick]) % ivalue;
}
// O(max(from, pick)).
// Assumes that ivalue will always be the same. To reset, use the
// reset flag.

vector<ll> Factorial(ll number, ll ivalue) {
  vector<ll> factorial;
  factorial.PB(1LL);
  for (int i = 1; i <= number; ++i) {
    factorial.PB((factorial.back() * (ll)i) % ivalue);
  }
  return factorial;
}
// vector<ll> fact = Factorial(4, 20);
// fact[3] == 6 % 20 == 6
// fact[4] == 24 % 20 == 4

ll modu = 1000000007LL;

ll dp[1050][1050]; // rows, distinct colors



int main() {

  int row, col, colors;
  cin >> row >> col >> colors;
  if (col == 1) {
    cout << Power(colors, row, modu) << endl;
    return 0;
  }

  FORN(i, 1050) FORN(j, 1050) dp[i][j] = 0LL;
  dp[0][0] = 1LL;
  for (int i = 0; i < 1040; ++i) for (int j = 0; j < 1040; ++j) {
    if (dp[i][j] == 0LL) continue;
    // reuse
    dp[i+1][j] = (dp[i+1][j] + ((dp[i][j] * (ll)j) % modu)) % modu;
    // new
    dp[i+1][j+1] = (dp[i+1][j+1] + dp[i][j]) % modu;
  }

  if (col == 2) {
    ll ret = 0LL;
    ll mult = 1LL;
    for (ll i = 1; i <= min(row, colors); ++i) {
      mult *= (ll)(colors - i + 1);
      mult %= modu;
      ll sol = mult * dp[row][i];
      sol %= modu;
      sol *= sol;
      sol %= modu;
      ret += sol;
      ret %= modu;
    }
    cout << ret << endl;
    return 0;
  }

  vector<ll> fact = Factorial(1050, modu);

  ll midtot = row * (col-2);

  vector<ll> pangkat1000;
  FORN(i, 1050) {
    pangkat1000.push_back(Power(i, midtot, modu));
  }

  ll ret = 0;
  for (ll total = 1; total <= min(row, colors); ++total) {
    for (ll equal = 1; equal <= total; ++equal) {
      ll distinct = total - equal;
      if (distinct + distinct + equal > colors) continue;
      ll sol = 1LL;
      // ambil yg distinct, distinct, sama equal
      sol *= FastCombination(colors, distinct, modu);
      sol %= modu;
      sol *= FastCombination(colors-distinct, distinct, modu);
      sol %= modu;
      sol *= FastCombination(colors-distinct-distinct, equal, modu);
      sol %= modu;
      // urutan buat yg kiri sama kanan
      sol *= fact[distinct + equal];
      sol %= modu;
      sol *= fact[distinct + equal];
      sol %= modu;
      sol *= dp[row][distinct + equal];
      sol %= modu;
      sol *= dp[row][distinct + equal];
      sol %= modu;
      // yg tengah2
      sol *= pangkat1000[equal];
      sol %= modu;
      ret += sol;
      ret %= modu;
    }
  }
  cout << ret << endl;

  return 0;
}