#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int n,m;
int getFirstTime(int s,int t){
	s--;
	int val1 = s + (t/2/m)*2*m;
	while(val1<t) val1 += 2*m;
	while(val1-2*m>=t) val1-= 2*m;

	int val2 = 2*m-s + (t/2/m)*2*m;
	while(val2<t) val2 += 2*m;
	while(val2-2*m>=t) val2-= 2*m;

	return min(val1,val2);
}


int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif
	
	cin>>n>>m;m--;
	REP(i,n){
		int s,f,t;
		scanf(" %d %d %d",&s,&f,&t);
		if(s==f) printf("%d\n",t);
		else{
			int res = getFirstTime(s,t);
			res = getFirstTime(f, res);
			printf("%d\n",res);
		}
	}
	
#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}

----

#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int a,b,mod;

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif
	
	cin>>a>>b>>mod;
	int to = min(a+1,mod);
	REP(i,to){
		int val = i;
		REP(j,9) val*=10,val%=mod;
		int need = (mod-val)%mod;
		if(need>b){
			cout<<1<<' ';
			printf("%09d\n",i);
			return 0;
		}
	}
	puts("2");

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}

----

#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int n;
char s[5555][5555];

bool solve(vi v){
	if(v.size()<3) return 0;
	vi t1,t2;
	int ver = v[0];
	FOR(i,1,v.size()) if(s[v[i]][ver]=='1') t1.pb(v[i]);
	else t2.pb(v[i]);

	REP(i1,t1.size()) REP(i2,t2.size()) if(s[t2[i2]][t1[i1]]=='1'){
		cout<<ver+1<<' '<<t2[i2]+1<<' '<<t1[i1]+1<<endl;
		return true;
	}
	if(solve(t1)) return true;
	if(solve(t2)) return true;
	return false;
}

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif

	cin>>n;
	REP(i,n) scanf(" %s",s[i]);
	vi v;
	REP(i,n) v.pb(i);
	random_shuffle(v.begin(),v.end());
	if(!solve(v)) puts("-1");

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}

----

#pragma comment(linker, "/STACK:65777216")

#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;

#define FOR(i,a,b) for (int i(a); i < (b); i++) 
#define REP(i,n) FOR(i,0,n) 
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

ll n;
int m,mod;

int solve(ll l,ll r,ll u,ll v,ll n,ll start,ll step){
	u = max(u, start);
	v = min(v, start + step*(n-1));
	if(l>r || r<1 || l>n) return 0;
	if(l<=1 && r>=n){
		int ans = 0;
		if(start < u){
			start += ((u - start)/step)*step;
			while(start<u) start += step;
		}
		if(start > v) return 0;
		ll num = (v-start)/step+1;
		ll v1 = (start + start + step * (num-1));
		ll v2 = num;
		if(v1%2==0) v1/=2;
		else v2/=2;
		v1%=mod;
		v2%=mod;
		v1*=v2;
		v1%=mod;
		return v1;
	}
	int res = 0;
	res += solve(l,min(r,(n+1)/2),u,v,(n+1)/2,start,step*2);
	res += solve(max((n+1)/2+1,l)-(n+1)/2,r-(n+1)/2,u,v,n/2    ,start+step,step*2);
	if(res>=mod) res-=mod;
	return res;
}

vector<ll> f(vector<ll> q){
	if(q.size()<2) return q;
	vector<ll> t1;
	vector<ll> t2;
	REP(i,q.size()){
		if(i%2) t2.pb(q[i]);
		else t1.pb(q[i]);
	}
	t1 = f(t1);
	t2 = f(t2);
	REP(i,t2.size()) t1.pb(t2[i]);
	return t1;
}

int stupid(ll l, ll r, ll u, ll v,ll n){
	vector<ll> q;
	REP(i,n) q.pb(i+1);
	q = f(q);
	ll sum = 0;
	FOR(i,l-1,r)if(q[i]>=u && q[i]<=v){
		sum += q[i];
		sum %= mod;
	}
	return sum;
}

int main(){ 
#ifdef LocalHost
	freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif

	cin>>n>>m>>mod;
	REP(i,m){
		ll l,r,u,v;
		scanf("%I64d %I64d %I64d %I64d",&l,&r,&u,&v);
		//printf("%d %d\n",solve(l,r,u,v,n,1,1),stupid(l,r,u,v,n));
		printf("%d\n",solve(l,r,u,v,n,1,1));
	}

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
	return 0;
}