{$R+,S+,Q+,I+,O-}
{R-,S-,Q-,I-,O+}
var
  m1,m2,t1,t2,x1,x2,t0,y1,y2,z1,z2,max,a,b: int64;

procedure go(y1,y2:int64);
var
  d1,d2: int64;
begin
  d1:=t1*y1+t2*y2-t0*y1-t0*y2;
  d2:=y1+y2;
  if d1 < 0 then exit;
  if (d1*m2 < m1*d2) or (d1*m2 = m1*d2) and (y1+y2 > max) then
  begin
    m1:=d1;
    m2:=d2;
    max:=y1+y2;
    z1:=y1; z2:=y2;
  end;
end;

begin
//  assign(input,'in'); reset(input);
//  assign(output,'out'); rewrite(output);
  read(t1,t2,x1,x2,t0);
  m1:=1; m2:=0;
  max:=-1;
  z1:=0; z2:=0;
  go(0,x2);
  y1:=1;
  while y1 <= x1 do
  begin
    a:=t2-t0;
    b:=y1*(t0-t1);
    // a*y2 >= b
    if a > 0 then
    begin
      y2:=(b+a-1) div a;
      if y2 <= x2 then go(y1,y2);
    end
    else go(y1,x2);
    inc(y1);
  end;
  writeln(z1,' ',z2);
  close(input);
  close(output);
end.

----

{R+,S+,Q+,I+,O-}
{$R-,S-,Q-,I-,O+}
var
  n,i,k: longint;
  p: array [0..1000010] of longint;
  s: array [0..1000010] of char;
  was: array [0..1000010] of boolean;
begin
//  assign(input,'in'); reset(input);
//  assign(output,'out'); rewrite(output);
  n:=0;
  while True do
  begin
    inc(n);
    read(s[n]);
    if not (s[n] in ['a'..'z']) then
    begin
      dec(n);
      break;
    end;
  end;
  p[1]:=0; k:=0;
  for i:=2 to n do
  begin
    while (k > 0) and (s[i] <> s[k+1]) do k:=p[k];
    if s[i] = s[k+1] then inc(k);
    p[i]:=k;
  end;
  fillchar(was,sizeof(was),False);
  for i:=1 to n-1 do was[p[i]]:=True;
  while p[n] > 0 do
  begin
    if was[p[n]] then break;
    p[n]:=p[p[n]];
  end;
  if p[n] = 0 then writeln('Just a legend') else
  begin
    for i:=1 to p[n] do write(s[i]);
    writeln;
  end;
  close(input);
  close(output);
end.

----

{R+,S+,Q+,I+,O-}
{$R-,S-,Q-,I-,O+}
var
  n,i,j,ans: longint;
  a: array [0..2010,0..2010] of longint;
  ch: char;
  row,col: array [0..2010] of longint;
begin
//  assign(input,'in'); reset(input);
//  assign(output,'out'); rewrite(output);
  readln(n);
  for i:=1 to n do
  begin
    for j:=1 to n do
    begin
      read(ch);
      a[i,j]:=Ord(ch)-48;
    end;
    readln;
  end;
  fillchar(row,sizeof(row),0);
  fillchar(col,sizeof(col),0);
  ans:=0;
  for i:=1 to n do
    for j:=n downto i+1 do
    begin
      a[i,j]:=a[i,j] xor row[i] xor col[j];
      if a[i,j] = 1 then
      begin
        inc(ans);
        a[i,j]:=0;
        row[i]:=row[i] xor 1;
        col[j]:=col[j] xor 1;
      end;
    end;
  for i:=1 to n do a[i,i]:=a[i,i] xor row[i] xor col[i];
  fillchar(row,sizeof(row),0);
  fillchar(col,sizeof(col),0);
  for i:=n downto 1 do
    for j:=1 to i-1 do
    begin
      a[i,j]:=a[i,j] xor row[i] xor col[j];
      if a[i,j] = 1 then
      begin
        inc(ans);
        a[i,j]:=0;
        row[i]:=row[i] xor 1;
        col[j]:=col[j] xor 1;
      end;
    end;
  for i:=1 to n do inc(ans,a[i,i] xor row[i] xor col[i]);
  writeln(ans);
  close(input);
  close(output);
end.

----

{R+,S+,Q+,I+,O-}
{$R-,S-,Q-,I-,O+}
var
  tt,qqq,q,w,u,qq,ww,ee,m,i: longint;
  n: int64;
  ch: char;
  f: array [0..99] of int64;
  a: array [0..99] of longint;
  g: array [0..99,0..3,0..3] of int64;
begin
//  assign(input,'in'); reset(input);
//  assign(output,'out'); rewrite(output);
  read(tt);
  for qqq:=1 to tt do
  begin
    read(ch);
    while not (ch in ['0'..'9']) do read(ch);
    n:=0;
    while ch in ['0'..'9'] do
    begin
      n:=n*10+Ord(ch)-48;
      read(ch);
    end;
    f[0]:=1;
    f[1]:=1;
    i:=2;
    while f[i-1] <= n do
    begin
      f[i]:=f[i-1]+f[i-2];
      inc(i);
    end;
    m:=i-1;
    for i:=m downto 1 do
      if n >= f[i] then
      begin
        a[i]:=1;
        n:=n-f[i];
      end
      else a[i]:=0;
    fillchar(g,sizeof(g),0);
    g[m,0,0]:=1;
    for i:=m downto 1 do
      for q:=0 to 2 do
        for w:=0 to 2 do
          if g[i,q,w] > 0 then
          begin
            qq:=q+a[i];
            for u:=qq-1 to qq do
              if u >= 0 then
              begin
                ww:=w+u; ee:=u;
                if (ww <= 2) and (ee <= 2) then
                  g[i-1,ww,ee]:=g[i-1,ww,ee]+g[i,q,w];
              end;
          end;
    writeln(g[0,0,0]);
  end;
  close(input);
  close(output);
end.