#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <vector>
#include <cmath>
#include <map>
#include <set>

#define SIZE(A) ((int)A.size())
#define LENGTH(A) ((int)A.length())
#define MP(A,B) make_pair(A,B)
#define PB(A) push_back(A)

typedef long long ll;
typedef double ld;

using namespace std;

#define MAXN 2002

int n, m, res;
int w[MAXN];
bool a[MAXN][MAXN];
vector <int> ed[MAXN];
vector <int> q;

void dfs(int u)
{
 	w[u] = 1;
 	q.PB(u);

 	for (int i = 0; i < SIZE(ed[u]); i++)
 		if (!w[ed[u][i]])
 			dfs(ed[u][i]);
}

int main()
{
	#ifndef ONLINE_JUDGE
		freopen("input", "r", stdin);
		freopen("output", "w", stdout);
	#endif

	scanf("%d%d", &n, &m);

	for (int i = 0; i < m; i++)
	{
	 	int u, v;
	 	scanf("%d%d", &u, &v);
	 	ed[u].PB(v);
	 	ed[v].PB(u);
	}
	scanf("%d", &m);
	for (int i = 0; i < m; i++)
	{
	 	int u, v;
	 	scanf("%d%d", &u, &v);
	 	a[u][v] = a[v][u] = 1;
	}

	for (int i = 1; i <= n; i++)
		if (!w[i])
		{
			q.clear();
			dfs(i);

			bool ok = 1;
			for (int j = 0; j < SIZE(q) && ok; j++)
				for (int k = j+1; k < SIZE(q) && ok; k++)
					if (a[q[j]][q[k]])
						ok = 0;

			if (ok)
				res = max(res, SIZE(q));
		}

	cout << res << endl;

	return 0;
}