#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

int N;
ll a[200010];
ll M;

ll func(ll Amin, ll Bmax, ll mindiff, ll maxdiff){
    int i;
    
    Bmax = min(Bmax, a[N-1]);
    REP(i,N-1) Bmax = min(Bmax, a[i] - i * mindiff + maxdiff);
    
    ll ans = 0;
    ll x = Bmax;
    
    for(i=N-1;i>=0;i--){
        if(i != N-1) x -= mindiff;
        x = min(x,a[i]);
        if(x < Amin || Bmax - x > maxdiff) return -1;
        ans += x;
    }
    
    return ans;
}

int main(void){
    int c,i;
    
    cin >> N >> M;
    REP(i,N) cin >> a[i];
    
    ll ans = 0;
    
    for(c=1;c*N<=M;c++){
        ll tri = (ll)c * (c-1) / 2 * N;
        ll Amin = tri + c;
        ll Bmax = M * c - tri;
        ll mindiff = c;
        ll maxdiff = M - c;
        ll tmp = func(Amin, Bmax, mindiff, maxdiff);
        ans = max(ans,tmp);
    }
    
    cout << ans << endl;
    
    return 0;
}