#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <iostream>
#include <iterator>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cstring>
#pragma comment(linker, "/STACK:66777216")
using namespace std;
#define pb push_back
#define ppb pop_back
#define pi 3.1415926535897932384626433832795028841971
#define mp make_pair
#define x first
#define y second
#define pii pair<int,int>
#define pdd pair<double,double>
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define L(s) (int)((s).size())
#define C(a) memset((a),0,sizeof(a))
#define VI vector <int>
#define ll long long

int a,b,c,d,i,j,n,m,k,ans;
int mas[502][502], hor[502][502], ver[502][502], ac[3][502][502];
bool used[502][502];
const int di[] = {0, 1, 0, -1};
const int dj[] = {1, 0, -1, 0};
pair<pii, int> cur[100001];
inline bool nmove(int &ci, int &cj, int &d, int n) {
	int ni = ci + di[d], nj = cj + dj[d];
	bool turn = 0;
	if (ni < 0 || ni >= n || nj < 0 || nj >= n || used[ni][nj]) turn = 1; else {
		int nni = ni + di[d], nnj = nj + dj[d];
		if (nni >= 0 && nni < n && nnj >= 0 && nnj < n && used[nni][nnj]) turn = 1;
	}
	if (!turn) {
		ci = ni; cj = nj;
		return 1;
	}
	
	++d;
	if (d == 4) d = 0;

	ni = ci + di[d], nj = cj + dj[d];
	if (ni < 0 || ni >= n || nj < 0 || nj >= n || used[ni][nj]) return 0; else {
		int nni = ni + di[d], nnj = nj + dj[d];
		if (nni >= 0 && nni < n && nnj >= 0 && nnj < n && used[nni][nnj]) return 0;
	}
	ci = ni; cj = nj;
	return 1;
}
inline int fsum(pii t1, pii t2) {
	if (t1.x == t2.x) {
		if (t1.y <= t2.y) return hor[t1.x][t2.y] - hor[t1.x][t1.y]; else {
			int ans = hor[t1.x][t1.y - 1];
			if (t2.y) ans -= hor[t1.x][t2.y - 1];
			return ans;
		}
	} else {
		if (t1.x <= t2.x) return ver[t1.y][t2.x] - ver[t1.y][t1.x]; else {
			int ans = ver[t1.y][t1.x - 1];
			if (t2.x) ans -= ver[t1.y][t2.x - 1];
			return ans;
		}
	}
}
int main() {
	//freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
	
	scanf("%d%d", &n, &m);
	rept(i, n) {
		rept(j, m) {
			scanf("%d", &mas[i][j]);
			hor[i][j] = ver[j][i] = mas[i][j];
			if (j) hor[i][j] += hor[i][j - 1];
			if (i) ver[j][i] += ver[j][i - 1];
		}
	}

	ans = -INF;
	int now = 0, pr = 1, ppr = 2;
	for (int s = 3; s <= max(n, m); s += 2) {
		int tmp = ppr;
		ppr = pr; pr = now; now = tmp;
		C(ac[now]);
		rept(i, s) rept(j, s) used[i][j] = 0;
		int ci = 0, cj = 0, d = 0;
		used[ci][cj] = 1;
		k = 0;
		cur[k++] = mp(mp(ci, cj), 0);
		int mx = 0, my = 0;
		while (1) {
			int old = d;
			if (!nmove(ci, cj, d, s)) {
				cur[k++] = mp(mp(ci, cj), d);
				break;
			}
			if (d != old) cur[k++] = mp(mp(ci - di[d], cj - dj[d]), d);
			if (ci > mx) mx = ci;
			if (cj > my) my = cj;
			used[ci][cj] = 1;
		}

		rept(i, n) {
			if (i + mx >= n) break;
			rept(j, m) {
				if (j + my >= m) break;
				int sum = 0, ci = i, cj = j;
				sum = mas[i][j];
				rept(h, k - 1) {
					int ni = i + cur[h + 1].x.x;
					int nj = j + cur[h + 1].x.y;
					sum += fsum(mp(ci, cj), mp(ni, nj));
					ci = ni; cj = nj;
					if (h == 3 && h < k - 1 && s > 5) {
						d = cur[h + 1].y;
						ni = ci + di[d];
						nj = cj + dj[d];
						sum += mas[ni][nj];
						sum += ac[ppr][ni + di[d]][nj + dj[d]];
						break;
					}
				}
				ac[now][i][j] = sum;
				if (sum > ans) ans = sum;
			}
		}
	}

	//cerr << clock() << endl;

	printf("%d\n", ans);
}