/** ` Micro Mezzo Macro Flation -- Overheated Economy ., **/

#include <algorithm>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cstring>
#include <cstdio>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <cmath>
#include <ctime>
#include <list>
#include <set>
#include <map>

using namespace std;

#define REP(i, n) for (int i=0;i<int(n);++i)
#define FOR(i, a, b) for (int i=int(a);i<int(b);++i)
#define DWN(i, b, a) for (int i=int(b-1);i>=int(a);--i)
#define REP_1(i, n) for (int i=1;i<=int(n);++i)
#define FOR_1(i, a, b) for (int i=int(a);i<=int(b);++i)
#define DWN_1(i, b, a) for (int i=int(b);i>=int(a);--i)
#define REP_C(i, n) for (int n____=int(n),i=0;i<n____;++i)
#define FOR_C(i, a, b) for (int b____=int(b),i=a;i<b____;++i)
#define DWN_C(i, b, a) for (int a____=int(a),i=b-1;i>=a____;--i)
#define REP_N(i, n) for (i=0;i<int(n);++i)
#define FOR_N(i, a, b) for (i=int(a);i<int(b);++i)
#define DWN_N(i, b, a) for (i=int(b-1);i>=int(a);--i)
#define REP_1_C(i, n) for (int n____=int(n),i=1;i<=n____;++i)
#define FOR_1_C(i, a, b) for (int b____=int(b),i=a;i<=b____;++i)
#define DWN_1_C(i, b, a) for (int a____=int(a),i=b;i>=a____;--i)
#define REP_1_N(i, n) for (i=1;i<=int(n);++i)
#define FOR_1_N(i, a, b) for (i=int(a);i<=int(b);++i)
#define DWN_1_N(i, b, a) for (i=int(b);i>=int(a);--i)
#define REP_C_N(i, n) for (n____=int(n),i=0;i<n____;++i)
#define FOR_C_N(i, a, b) for (b____=int(b),i=a;i<b____;++i)
#define DWN_C_N(i, b, a) for (a____=int(a),i=b-1;i>=a____;--i)
#define REP_1_C_N(i, n) for (n____=int(n),i=1;i<=n____;++i)
#define FOR_1_C_N(i, a, b) for (b____=int(b),i=a;i<=b____;++i)
#define DWN_1_C_N(i, b, a) for (a____=int(a),i=b;i>=a____;--i)

#define DO(n) while(n--)
#define DO_C(n) int n____ = n; while(n____--)
#define TO(i, a, b) int s_=a<b?1:-1,b_=b+s_;for(int i=a;i!=b_;i+=s_)
#define TO_1(i, a, b) int s_=a<b?1:-1,b_=b;for(int i=a;i!=b_;i+=s_)
#define SQZ(i, j, a, b) for (int i=int(a),j=int(b)-1;i<j;++i,--j)
#define SQZ_1(i, j, a, b) for (int i=int(a),j=int(b);i<=j;++i,--j)
#define REP_2(i, j, n, m) REP(i, n) REP(j, m)
#define REP_2_1(i, j, n, m) REP_1(i, n) REP_1(j, m)

#define ALL(A) A.begin(), A.end()
#define LLA(A) A.rbegin(), A.rend()
#define CPY(A, B) memcpy(A, B, sizeof(A))
#define INS(A, P, B) A.insert(A.begin() + P, B)
#define ERS(A, P) A.erase(A.begin() + P)
#define BSC(A, X) find(ALL(A), X) // != A.end()
#define CTN(T, x) T.find(x) != T.end()
#define SZ(A) int(A.size())
#define PB push_back
#define MP(A, B) make_pair(A, B)

#define Rush int T____; RD(T____); DO(T____)
#pragma comment(linker, "/STACK:36777216")
#pragma GCC optimize ("O2")
#define Ruby system("ruby main.rb")
#define Haskell system("runghc main.hs")
#define Pascal system("fpc main.pas")

typedef long long LL;
typedef double DB;
typedef unsigned UINT;
typedef unsigned long long ULL;

typedef vector<int> VI;
typedef vector<char> VC;
typedef vector<string> VS;
typedef vector<LL> VL;
typedef vector<DB> VD;
typedef set<int> SI;
typedef set<string> SS;
typedef set<LL> SL;
typedef set<DB> SD;
typedef map<int, int> MII;
typedef map<string, int> MSI;
typedef map<LL, int> MLI;
typedef map<DB, int> MDI;
typedef map<int, bool> MIB;
typedef map<string, bool> MSB;
typedef map<LL, bool> MLB;
typedef map<DB, bool> MDB;
typedef pair<int, int> PII;
typedef pair<int, bool> PIB;
typedef vector<PII> VII;
typedef vector<VI> VVI;
typedef vector<VII> VVII;
typedef set<PII> SII;
typedef map<PII, int> MPIII;
typedef map<PII, bool> MPIIB;


/** I/O Accelerator **/

/* ... :" We are I/O Accelerator ... Use us at your own risk ;) ... " .. */

template<class T> inline void RD(T &);
template<class T> inline void OT(const T &);

template<class T> inline T& _RD(T &x){ RD(x); return x;}
inline int RD(){ int x; RD(x); return x;}
inline LL RD_LL(){ LL x; RD(x); return x;}
inline DB RD_DB(){ DB x; RD(x); return x;}

template<class T0, class T1> inline void RD(T0 &x0, T1 &x1){RD(x0), RD(x1);}
template<class T0, class T1, class T2> inline void RD(T0 &x0, T1 &x1, T2 &x2){RD(x0), RD(x1), RD(x2);}
template<class T0, class T1, class T2, class T3> inline void RD(T0 &x0, T1 &x1, T2 &x2, T3 &x3){RD(x0), RD(x1), RD(x2), RD(x3);}
template<class T0, class T1, class T2, class T3, class T4> inline void RD(T0 &x0, T1 &x1, T2 &x2, T3 &x3, T4 &x4){RD(x0), RD(x1), RD(x2), RD(x3), RD(x4);}
template<class T0, class T1, class T2, class T3, class T4, class T5> inline void RD(T0 &x0, T1 &x1, T2 &x2, T3 &x3, T4 &x4, T5 &x5){RD(x0), RD(x1), RD(x2), RD(x3), RD(x4), RD(x5);}
template<class T0, class T1, class T2, class T3, class T4, class T5, class T6> inline void RD(T0 &x0, T1 &x1, T2 &x2, T3 &x3, T4 &x4, T5 &x5, T6 &x6){RD(x0), RD(x1), RD(x2), RD(x3), RD(x4), RD(x5), RD(x6);}
template<class T0, class T1> inline void OT(T0 &x0, T1 &x1){OT(x0), OT(x1);}
template<class T0, class T1, class T2> inline void OT(T0 &x0, T1 &x1, T2 &x2){OT(x0), OT(x1), OT(x2);}
template<class T0, class T1, class T2, class T3> inline void OT(T0 &x0, T1 &x1, T2 &x2, T3 &x3){OT(x0), OT(x1), OT(x2), OT(x3);}
template<class T0, class T1, class T2, class T3, class T4> inline void OT(T0 &x0, T1 &x1, T2 &x2, T3 &x3, T4 &x4){OT(x0), OT(x1), OT(x2), OT(x3), OT(x4);}
template<class T0, class T1, class T2, class T3, class T4, class T5> inline void OT(T0 &x0, T1 &x1, T2 &x2, T3 &x3, T4 &x4, T5 &x5){OT(x0), OT(x1), OT(x2), OT(x3), OT(x4), OT(x5);}
template<class T0, class T1, class T2, class T3, class T4, class T5, class T6> inline void OT(T0 &x0, T1 &x1, T2 &x2, T3 &x3, T4 &x4, T5 &x5, T6 &x6){OT(x0), OT(x1), OT(x2), OT(x3), OT(x4), OT(x5), OT(x6);}

template<class T> inline void RST(T &A){memset(A, 0, sizeof(A));}
template<class T0, class T1> inline void RST(T0 &A0, T1 &A1){RST(A0), RST(A1);}
template<class T0, class T1, class T2> inline void RST(T0 &A0, T1 &A1, T2 &A2){RST(A0), RST(A1), RST(A2);}
template<class T0, class T1, class T2, class T3> inline void RST(T0 &A0, T1 &A1, T2 &A2, T3 &A3){RST(A0), RST(A1), RST(A2), RST(A3);}
template<class T0, class T1, class T2, class T3, class T4> inline void RST(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4){RST(A0), RST(A1), RST(A2), RST(A3), RST(A4);}
template<class T0, class T1, class T2, class T3, class T4, class T5> inline void RST(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4, T5 &A5){RST(A0), RST(A1), RST(A2), RST(A3), RST(A4), RST(A5);}
template<class T0, class T1, class T2, class T3, class T4, class T5, class T6> inline void RST(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4, T5 &A5, T6 &A6){RST(A0), RST(A1), RST(A2), RST(A3), RST(A4), RST(A5), RST(A6);}
template<class T> inline void CLR(T &A){A.clear();}
template<class T0, class T1> inline void CLR(T0 &A0, T1 &A1){CLR(A0), CLR(A1);}
template<class T0, class T1, class T2> inline void CLR(T0 &A0, T1 &A1, T2 &A2){CLR(A0), CLR(A1), CLR(A2);}
template<class T0, class T1, class T2, class T3> inline void CLR(T0 &A0, T1 &A1, T2 &A2, T3 &A3){CLR(A0), CLR(A1), CLR(A2), CLR(A3);}
template<class T0, class T1, class T2, class T3, class T4> inline void CLR(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4){CLR(A0), CLR(A1), CLR(A2), CLR(A3), CLR(A4);}
template<class T0, class T1, class T2, class T3, class T4, class T5> inline void CLR(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4, T5 &A5){CLR(A0), CLR(A1), CLR(A2), CLR(A3), CLR(A4), CLR(A5);}
template<class T0, class T1, class T2, class T3, class T4, class T5, class T6> inline void CLR(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4, T5 &A5, T6 &A6){CLR(A0), CLR(A1), CLR(A2), CLR(A3), CLR(A4), CLR(A5), CLR(A6);}
template<class T> inline void CLR(T &A, int n){REP(i, n) CLR(A[i]);}
template<class T> inline void FLC(T &A, int x){memset(A, x, sizeof(A));}
template<class T0, class T1> inline void FLC(T0 &A0, T1 &A1, int x){FLC(A0, x), FLC(A1, x);}
template<class T0, class T1, class T2> inline void FLC(T0 &A0, T1 &A1, T2 &A2){FLC(A0), FLC(A1), FLC(A2);}
template<class T0, class T1, class T2, class T3> inline void FLC(T0 &A0, T1 &A1, T2 &A2, T3 &A3){FLC(A0), FLC(A1), FLC(A2), FLC(A3);}
template<class T0, class T1, class T2, class T3, class T4> inline void FLC(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4){FLC(A0), FLC(A1), FLC(A2), FLC(A3), FLC(A4);}
template<class T0, class T1, class T2, class T3, class T4, class T5> inline void FLC(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4, T5 &A5){FLC(A0), FLC(A1), FLC(A2), FLC(A3), FLC(A4), FLC(A5);}
template<class T0, class T1, class T2, class T3, class T4, class T5, class T6> inline void FLC(T0 &A0, T1 &A1, T2 &A2, T3 &A3, T4 &A4, T5 &A5, T6 &A6){FLC(A0), FLC(A1), FLC(A2), FLC(A3), FLC(A4), FLC(A5), FLC(A6);}

template<class T> inline void SRT(T &A){sort(ALL(A));}
template<class T, class C> inline void SRT(T &A, C B){sort(ALL(A), B);}


/** Add - On **/

const int MOD = 1000000007;
const int INF = 0x7fffffff;
const DB PI = acos(-1.0);
const DB EPS = 1e-6;
const DB OO = 1e15;

// <<= ` 0. Daily Use .,

template<class T> inline void checkMin(T &a,const T b){if (b<a) a=b;}
template<class T> inline void checkMax(T &a,const T b){if (b>a) a=b;}
template <class T, class C> inline void checkMin(T& a, const T b, C c){if (c(b,a)) a = b;}
template <class T, class C> inline void checkMax(T& a, const T b, C c){if (c(a,b)) a = b;}
template<class T> inline T min(T a, T b, T c){return min(min(a, b), c);}
template<class T> inline T max(T a, T b, T c){return max(max(a, b), c);}
template<class T> inline T sqr(T a){return a*a;}
template<class T> inline T cub(T a){return a*a*a;}
int Ceil(int x, int y){return (x - 1) / y + 1;}

// <<= ` 1. Bitwise Operation .,

inline bool _1(int x, int i){return x & 1<<i;}
inline int _1(int i){return 1<<i;}
inline int _U(int i){return _1(i) - 1;};

inline int count_bits(int x){
    x = (x & 0x55555555) + ((x & 0xaaaaaaaa) >> 1);
    x = (x & 0x33333333) + ((x & 0xcccccccc) >> 2);
    x = (x & 0x0f0f0f0f) + ((x & 0xf0f0f0f0) >> 4);
    x = (x & 0x00ff00ff) + ((x & 0xff00ff00) >> 8);
    x = (x & 0x0000ffff) + ((x & 0xffff0000) >> 16);
    return x;
}

template<class T> inline T low_bit(T x) {
    return x & -x;
}

template<class T> inline T high_bit(T x) {
    T p = low_bit(x);
    while (p != x) x -= p, p = low_bit(x);
    return p;
}

// <<= ` 2. Modular Arithmetic Basic .,

inline void INC(int &a, int b){a += b; if (a >= MOD) a -= MOD;}
inline int sum(int a, int b){a += b; if (a >= MOD) a -= MOD; return a;}
inline void DEC(int &a, int b){a -= b; if (a < 0) a += MOD;}
inline int dff(int a, int b){a -= b; if (a < 0) a  += MOD; return a;}
inline void MUL(int &a, int b){a = (LL)a * b % MOD;}
inline int pdt(int a, int b){return (LL)a * b % MOD;}


// <<= ' 9. Computational Geometry .,


// <<= ' 0. I/O Accelerator interface .,

template<class T> inline void RD(T &x){
    cin >> x;
    //scanf("%d", &x);
    //char c; for (c = getchar(); c < '0'; c = getchar()); x = c - '0'; for (c = getchar(); c >= '0'; c = getchar()) x = x * 10 + c - '0';
    //char c; c = getchar(); x = c - '0'; for (c = getchar(); c >= '0'; c = getchar()) x = x * 10 + c - '0';

}

int ____Case;
template<class T> inline void OT(const T &x){
    cout << x << endl;
    //printf("%d\n", x);
    //printf("%.9lf\n", x);
    //printf("Case %d: %d\n", ++____Case, x);
}


#define For_each(it, A) for (SII::iterator it = A.begin(); it != A.end(); ++it)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

/* .................................................................................................................................. */

#define fi first
#define se second
#define pb push_back
#define mp make_pair

typedef pair<int,double> PIF;



    struct Po{

        DB x,y;
            Po(){}
            Po(DB _x, DB _y):x(_x),y(_y){}
            bool operator < (const Po&a) const {return x<a.x-EPS||fabs(x-a.x)<EPS&&y<a.y-EPS;}
            bool operator ==(const Po&a) const {return fabs(x-a.x)<EPS&&fabs(y-a.y)<EPS;}
            bool operator !=(const Po&a) const {return !(*this==a);}
            void get(){scanf("%lf%lf",&x,&y);}
    };
    struct line
    {
            Po x,y;
            line(){}
            line(Po _x,Po _y):x(_x),y(_y){}
            void get(){x.get(),y.get();}
    };
    struct node
    {
            string c;vector<int> a;double sz;
            node(string _c,double _sz=0):c(_c),sz(_sz){}
            void add(int x){a.pb(x);}
    };
    Po med(Po a,Po b,Po c)
    {
            if(a<b)if(b<c)return b;else if(a<c)return c;else return a;
            else if(a<c)return a;else if(b<c)return c;else return b;
    }
    int getcrs(line a,line b,Po&c)
    {
            double A=a.y.y-a.x.y,B=a.x.x-a.y.x,C=a.x.x*A+a.x.y*B;
            double D=b.y.y-b.x.y,E=b.x.x-b.y.x,F=b.x.x*D+b.x.y*E;
            if(fabs(A*E-B*D)<EPS)return -1;
            c=Po((C*E-F*B)/(A*E-D*B),(C*D-F*A)/(B*D-E*A));
            if(med(a.x,a.y,c)!=c||med(b.x,b.y,c)!=c)return -1;
            return 0;
    }
    bool online(Po p,line a)
    {
            if(med(a.x,a.y,p)!=p)return 0;
            double A=a.y.y-a.x.y,B=a.x.x-a.y.x,C=a.x.x*A+a.x.y*B;
            return abs(A*p.x+B*p.y-C)<EPS;
    }
    double ang(Po a,Po b)
    {
            double S=atan2(b.y-a.y,b.x-a.x)*180/M_PI;
            if(S<EPS)S+=360;
            return S;
    }
    bool cmpid(const PIF&a,const PIF&b){return a.fi<b.fi;}
    bool equid(const PIF&a,const PIF&b){return a.fi==b.fi;}
    bool cmpang(const PIF&a,const PIF&b){return a.se<b.se;}
    double getsz(vector<Po> p)
    {
            double S=0;
            for(int i=0;i<(int)p.size();i++)
            {
                    int j=(i+1)%(int)p.size();
                    S+=p[i].x*p[j].y-p[j].x*p[i].y;
            }
            return -S/2;
    }
    double crs(Po a,Po b,Po c)
    {
            return (b.y-a.y)*(c.x-a.x)-(b.x-a.x)*(c.y-a.y);
    }
    int inpoly(Po p,vector<Po> a)
    {
            int n=(int)a.size();a.pb(a[0]);
            for(int i=0;i<n;i++)
                    if(online(p,line(a[i],a[i+1])))return 0;
            int w=0;
            for(int i=0;i<n;i++)
                    if(a[i].y<=p.y&&a[i+1].y>p.y&&crs(a[i],a[i+1],p)<0)++w;else
                    if(a[i].y>p.y&&a[i+1].y<=p.y&&crs(a[i],a[i+1],p)>0)--w;
            return w;
    }
    int w,h,n,m,p;
    vector<Po> po;
    vector<vector<PIF> > pa;
    vector<node> gr;
    vector<int> bl;
    vector<Po> fl;
    vector<vector<Po> > pl;
    void bfs(int x,string c)
    {
            string d=gr[x].c;
            queue<int> q;vector<bool> v((int)gr.size(),0);
            v[x]=1,q.push(x);
            while(!q.empty())
            {
                    int x=q.front();q.pop();
                    gr[x].c=c;
                    for(int i=0;i<(int)gr[x].a.size();i++)
                            if(!v[gr[x].a[i]]&&gr[gr[x].a[i]].c==d)
                                    q.push(gr[x].a[i]),v[gr[x].a[i]]=1;
            }
    }
    int main()
    {
            //scanf("%d%d%d",&w,&h,&n);

            RD(w, h, n);

            vector<line> l0(n);

            REP(i, n) l0[i].get();

            //for(int i=0;i<n;i++)l0[i].get();
            for(int i=0;i<n;i++)po.pb(l0[i].x),po.pb(l0[i].y);
            for(int i=0;i<n;i++)
                    for(int j=i+1;j<n;j++)
                    {
                            Po p;
                            if(getcrs(l0[i],l0[j],p)!=-1)po.pb(p);
                    }
            sort(po.begin(),po.end()),
            po.erase(unique(po.begin(),po.end()),po.end());
            m=(int)po.size();
            pa.resize(m);
            for(int i=0;i<n;i++)
            {
                    vector<int> vp;
                    for(int j=0;j<m;j++)
                            if(online(po[j],l0[i]))vp.pb(j);
                    for(int j=1;j<(int)vp.size();j++)
                            pa[vp[j-1]].pb(mp(vp[j],ang(po[vp[j-1]],po[vp[j]]))),
                            pa[vp[j]].pb(mp(vp[j-1],ang(po[vp[j]],po[vp[j-1]])));
            }
            for(int i=0;i<m;i++)
                    sort(pa[i].begin(),pa[i].end(),cmpid),
                    pa[i].erase(unique(pa[i].begin(),pa[i].end(),equid),pa[i].end()),
                    sort(pa[i].begin(),pa[i].end(),cmpang);
            gr.pb(node("white",w*h));
            fl.pb(Po(0.0,0.0));
            bl.resize(m,-1);
            for(int i=0;i<m;i++)if(bl[i]==-1)
            {
                    queue<int> q;
                    q.push(i);
                    gr.pb(node("black",0.0));
                    bl[i]=++p,fl.pb(po[i]);
                    while(!q.empty())
                    {
                            int x=q.front();q.pop();
                            for(int j=0;j<(int)pa[x].size();j++)
                                    if(bl[pa[x][j].fi]==-1)
                                            q.push(pa[x][j].fi),
                                            bl[pa[x][j].fi]=p;
                    }
            }
            pl.resize(p+1);
            vector<vector<bool> > chk(m);
            for(int i=0;i<m;i++)chk[i].resize((int)pa[i].size(),0);
            for(int i=0;i<m;i++)
                    for(int j=0;j<(int)pa[i].size();j++)
                    {
                            if(chk[i][j])continue;
                            vector<Po> vp;
                            int i0=i,j0=j;
                            while(!chk[i0][j0])
                            {
                                    vp.pb(po[i0]);
                                    chk[i0][j0]=1;
                                    int i1=pa[i0][j0].fi,j1=-1;
                                    for(int j=0;j<(int)pa[i1].size();j++)
                                            if(pa[i1][j].fi==i0){j1=(j+1)%(int)pa[i1].size();break;}
                                    i0=i1,j0=j1;
                            }
                            double sz=getsz(vp);
                            if(sz>0)
                            {
                                    pl.pb(vp);
                                    gr.pb(node("white",sz));
                                    int r=bl[i];
                                    gr[r].add((int)gr.size()-1),
                                    gr[(int)gr.size()-1].add(r);
                                    gr[r].sz-=sz;
                            }
                    }
            for(int i=1;i<=p;i++)
            {
                    int fa=0;
                    for(int j=(int)pl.size()-1;j>p;j--)
                            if(inpoly(fl[i],pl[j])){fa=j;break;}
                    gr[fa].add(i),gr[i].add(fa),gr[fa].sz+=gr[i].sz,gr[i].sz=0;
            }
            int _;scanf("%d",&_);
            while(_--)
            {
                    Po x;x.get();string c;char s[100];scanf("%s",s),c=s;
                    for(int i=0;i<m;i++)
                            for(int j=0;j<(int)pa[i].size();j++)
                                    if(online(x,line(po[i],po[pa[i][j].fi]))){bfs(bl[i],c);goto end;}
                    for(int i=(int)pl.size()-1;i>p;i--)
                            if(inpoly(x,pl[i])){bfs(i,c);goto end;}
                    bfs(0,c);
                    end:;
            }
            map<string,double> S;
            for(int i=0;i<(int)gr.size();i++)
                    S[gr[i].c]+=gr[i].sz;
            for(map<string,double>::iterator i=S.begin();i!=S.end();i++)
                    printf("%s %.9lf\n",i->first.c_str(),i->second);
            return 0;
    }