#include <map>
#include <set>
#include <cmath>
#include <stack>
#include <queue>
#include <string>
#include <vector>
#include <bitset>
#include <fstream>
#include <sstream>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <iostream>
#include <algorithm>
using namespace std;
#define li        int
#define rep(i,to) for(int i=0;i<((int)(to));++i)
#define pb        push_back
#define sz(v)     ((int)(v).size())
#define bit(n)    (1ll<<(int)(n))
#define all(vec)  (vec).begin(),(vec).end()
#define each(i,c) for(__typeof((c).begin()) i=(c).begin();i!=(c).end();i++)
#define MP        make_pair
#define F         first
#define S         second


#define MAX 200500
#define INF 1005005005
li l[MAX];
li r[MAX];
li t[MAX];
pair<li, li> st[MAX * 4];
li margin[MAX * 4];
li move[MAX * 4];
li N;

void setSt(li pos, li a)
{
	pos += N;
	st[pos] = MP(a, pos - N);
	while(1 < pos){
		pos /= 2;
		st[pos] = max(st[pos * 2], st[pos * 2 + 1]);
	}
}

void setLeft(li pos, li a)
{
	pos += N;
	margin[pos] = a;
	while(1 < pos){
		pos /= 2;
		li t0 = margin[pos * 2 + 0] - move[pos * 2 + 0];
		li t1 = margin[pos * 2 + 1] - move[pos * 2 + 1];
		margin[pos] = min(t0, t1);
	}
}

pair<li, li> getSt(li v, li left, li right, li l, li r)
{
	if(r <= left || right <= l) return MP(-1, -1);
	if(l <= left && right <= r) return st[v];
	li mid = (left + right) / 2;
	pair<li, li> res0 = getSt(v * 2 + 0, left , mid, l, r);
	pair<li, li> res1 = getSt(v * 2 + 1, mid, right, l, r);
	return max(res0, res1);
}

li getLeft(li v, li left, li right, li l, li r)
{
	if(r <= left || right <= l) return INF;
	if(l <= left && right <= r) return margin[v] - move[v];
	li mid = (left + right) / 2;
	li res0 = getLeft(v * 2 + 0, left , mid, l, r);
	li res1 = getLeft(v * 2 + 1, mid, right, l, r);
	return min(res0, res1) - move[v];
}

void moveLeft(li v, li left, li right, li l, li r, li len)
{
	if(r <= left || right <= l) return;
	if(l <= left && right <= r){ move[v] += len; return; }
	li mid = (left + right) / 2;
	moveLeft(v * 2 + 0, left , mid, l, r, len);
	moveLeft(v * 2 + 1, mid, right, l, r, len);
	li res0 = margin[v * 2 + 0] - move[v * 2 + 0];
	li res1 = margin[v * 2 + 1] - move[v * 2 + 1];
	margin[v] = min(res0, res1);
}

int main()
{
	int _n;
	li n;
	li ans = 0;
	scanf("%d", &_n);
	n = _n;
	rep(i, n){
		int _a, _b, _c;
		scanf("%d%d%d", &_a, &_b, &_c);
		l[i] = _a;
		r[i] = _b;
		t[i] = _c;
	}
	for(N = 1; N <= n; N *= 2);
	


	
	rep(cur, n){
		stringstream ss;
		li s = max(ans + 1, l[cur]);
		if(s + t[cur] - 1 <= r[cur]){
			setLeft(cur, s - l[cur]);
			setSt(cur, t[cur]);
			ans = s + t[cur] - 1;
			ss << "0 ";
		}else{
			li maxi = s - l[cur];
			li low = 0, high = cur;
			pair<li, li> best = MP(-1, -1);
			while(low + 1 < high){
				li mid = (low + high) / 2;
				li upper = min(maxi, getLeft(1, 0, N, mid + 1, cur));
				pair<li, li> longest = getSt(1, 0, N, mid, cur);
				if(upper <= longest.F	){
					low = mid;
				}else{
					high = mid;
					best = max(best, longest);
				}
			}
			li upper = min(maxi, getLeft(1, 0, N, low + 1, cur));
			pair<li, li> longest = getSt(1, 0, N, low, low + 1);
			best = max(best, MP(min(upper, longest.F), longest.S));
			li pos = best.S;
			li move_length = min(getLeft(1, 0, N, pos + 1, cur), getSt(1, 0, N, pos, pos + 1).F);
			s = max(l[cur], s - move_length);
			if(s + t[cur] - 1 <= r[cur] && s + t[cur] <= ans){
				setSt(pos, 0);
				moveLeft(1, 0, N, pos + 1, cur, move_length);
				setLeft(cur, s - l[cur]);
				setSt(cur, t[cur]);
				ans = s + t[cur] - 1;
				ss << pos + 1 << " ";
			}else{
				setSt(cur, 0);
				setLeft(cur, INF);
				ss << "-1 ";
			}
		}
		printf("%s", ss.str().c_str());
	}
	printf("\n");
	
}



/*


54
10 10 1
11 18 2
17 23 4
24 25 2
27 32 4
33 37 5
36 42 7
38 50 8
45 52 3
48 55 7
54 62 4
60 72 2
61 77 2
64 84 14
74 90 14
78 99 20
86 107 14
92 115 22
99 125 1
109 132 2
115 141 16
118 145 12
125 155 7
129 158 26
135 163 24
139 167 24
149 174 4
153 181 6
157 188 2
159 190 20
164 191 6
172 192 17
173 197 18
177 207 1
187 208 15
191 218 16
197 228 30
206 236 3
213 241 20
222 244 14
226 246 7
235 250 4
244 255 10
250 260 10
253 270 13
256 276 12
262 285 24
265 295 19
268 299 24
272 303 27
281 310 21
283 320 4
291 321 12
295 329 16




305 337 33
313 347 6
322 351 23
325 356 13
333 364 15
335 373 12




*/