#include <stdio.h>
#include <string.h>

#define LMAX 1000
char line[LMAX];
int pozline = 0, lenline = 0;
 
inline void ReadInt(int *x) {
    while (pozline < lenline && (line[pozline] < '0' || line[pozline] > '9'))
        pozline++;
 
    if (pozline == lenline) {
        fgets(line, LMAX - 3, stdin);
        pozline = 0;
        lenline = strlen(line);
        while (pozline < lenline && line[pozline] < '1' && line[pozline] > '9' && line[pozline] != '-')
            pozline++;
    }
     
    *x = 0;
    while (line[pozline] >= '0' && line[pozline] <= '9') {
        *x = (*x) * 10 + (line[pozline] - '0');
        pozline++;
    }   
}

#define NMAX 100100
#define LOGMAX 6

int bit[LOGMAX], Anc[NMAX][LOGMAX];
int N, M, A, B, X, Y, tip, i, current = 0;

void ComputeBits() {
	int i;
	bit[0] = 1;
	for (i = 1; i < LOGMAX; i++)
		bit[i] = bit[i - 1] * 2;
}

int main() {
	ComputeBits();
	
	freopen("citylog.in", "r", stdin);
	freopen("citylog.out", "w", stdout);

	ReadInt(&N);
	ReadInt(&M);
	
	while (M--) {
		ReadInt(&tip); ReadInt(&A); ReadInt(&B);
		X = A ^ current; Y = B ^ current;

		if (tip == 0) {
			Anc[X][0] = Y;
			for (i = 1; i < LOGMAX; i++) {
				Anc[X][i] = Anc[Anc[X][i - 1]][i - 1];
			}
		} else {
			while (Y > bit[LOGMAX - 1] && X > 0) {
				X = Anc[X][LOGMAX - 1];
				Y -= bit[LOGMAX - 1];
			}
			
			i = LOGMAX - 1;
			while (X > 0 && Y > 0) {
				if (Y >= bit[i]) {
					X = Anc[X][i];
					Y -= bit[i];
				} else
					i--;
			}

			printf("%d\n", X);
			current = X;
		}
	}
	
	return 0;
}
