#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

vector<int> v, vv;
int N, i, j, k, nneed, nextra, li, ls, mid, answer;

int ok(int M) {
	j = nneed = M;

	//fprintf(stderr, "Testing %d\n", M);
	
	for (i = N - 1; i >= 0; i--) {
		//fprintf(stderr, "  before i=%d (%d): j=%d nneed=%d\n", i, v[i], j, nneed);

		if (v[i] < nneed)
			nneed -= v[i];
		else {
			nextra = v[i] - nneed;
			if (nextra > (j - nneed))
				nextra = j - nneed;
			j--;
			if (j == 0)
				break;
			
			nneed = j - nextra;
			if (nneed == 0) {
				j--;
				if (j == 0)
					break;
				nneed = j;
			}
		}
	}

	fprintf(stderr, " Testing %d: %d\n", M, (j == 0));
	return (j == 0);
}

#define NMAX 200111
int cnt[NMAX], cnt2[NMAX];

int slowok(int M) {
	long long SUM, SUM2;
	memset(cnt, 0, sizeof(cnt));

	for (i = 0; i < v.size(); i++)
		if (v[i] < M)
			cnt[v[i]]++;
		else
			cnt[M]++;

	fprintf(stderr, "Testing %d\n", M);

	memcpy(cnt2, cnt, sizeof(cnt));
	
	for (j = M; j >= 1; j--) {
		for (k = j, i = M; i >= 1 && k > 0; i--) {
			if (k > cnt[i]) {
				k -= cnt[i];
				cnt2[i - 1] += cnt[i];
				cnt2[i] -= cnt[i];
			} else {
				cnt2[i - 1] += k;
				cnt2[i] -= k;
				k = 0;
			}
		}

		if (k > 0) {
			fprintf(stderr, "  bad (j=%d k=%d)\n", k, j);
			return 0;
		}

		/*
		SUM = 0;
		for (i = 1; i <= M; i++)
			SUM += (long long) cnt[i] * (long long) i;

		SUM2 = 0;
		for (i = 1; i <= M; i++)
			SUM2 += (long long) cnt2[i] * (long long) i;
		
		if (SUM2 + j != SUM) {
			fprintf(stderr, "??? %lld %lld: %lld %d\n", SUM2, SUM, SUM - SUM2, j);
			exit(1);
		}
		*/
	
		memcpy(cnt, cnt2, sizeof(cnt));

		if (j % 1000 == 0)
			fprintf(stderr, "   j=%d done\n", j);
	}

	fprintf(stderr, "  good\n");	
	return 1;
}

int main() {
	freopen("lumanari.in", "r", stdin);
	scanf("%d", &N);
	v.resize(N);
	for (i = 0; i < N; i++)
		scanf("%d", &(v[i]));

	sort(v.begin(), v.end());
	vv.resize(N);
	
	li = 1; ls = N; answer = 0;
	while (li <= ls) {
		mid = (li + ls) / 2;
		if (slowok(mid)) {
			answer = mid;
			li = mid + 1;
		} else
			ls = mid - 1;
	}
	
	freopen("lumanari.out", "w", stdout);
	printf("%d\n", answer);
	
	return 0;
}
