#include <stdio.h>

#define NMAX 1000111
#define LEVMAX 30
#define MOD 1000003

int rfact[NMAX], L[LEVMAX];
int N, i, ans, niv;

void MergeSort(int left, int right) {
	if (niv > 0) {
		ans = (ans + rfact[1] - rfact[L[niv - 1] + 1] + MOD) % MOD;
	} else {
		ans = rfact[1];
	}

	if (left == right)
		return;
	
	int middle = (left + right) / 2;
	niv++;
	L[niv] = middle - left + 1;
	MergeSort(left, middle);
	L[niv] = right - middle;
	MergeSort(middle + 1, right);
	niv--;
}

int main() {
	freopen("mergesort.in", "r", stdin);
	scanf("%d", &N);
	
	rfact[N + 1] = 1;
	for (i = N; i >= 1; i--) {
		rfact[i] = ((long long) rfact[i + 1] * (long long) i) % MOD;
	}

	ans = 0;
	niv = 0;
	L[0] = N;
	MergeSort(1, N);

	freopen("mergesort.out", "w", stdout);
	printf("%d\n", ans);
	
	return 0;
}
