//  " "
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class language_ft implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "language";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               

	public void solve() {
		int n = in.nextInt();
		int c = in.nextInt();
		int C = in.nextInt();
		String S = in.next();
		char[] s = S.toCharArray();
		int[] a = new int[n + 1];
		Arrays.fill(a, Integer.MIN_VALUE);
		int[] pi = new int[n + 1];
		Arrays.fill(pi, -1);
		a[0] = 0;

		for (int i = 0; i < n; i++) {
			if (a[i] == Integer.MIN_VALUE) {
				continue;
			}
			int min = Integer.MAX_VALUE;
			int max = Integer.MIN_VALUE;
			for (int j = i; j < n; j++) {
				if (j - i + 1 > C) {
					break;
				}
				min = Math.min(min, s[j]);
				max = Math.max(max, s[j]);
				if (j - i + 1 >= c) {
					if (a[j + 1] < a[i] + max - min) {
						a[j + 1] = a[i] + max - min;
						pi[j + 1] = i;
					}
				}
			}
		}

//		System.out.println(Arrays.toString(a));

		if (pi[n] == -1) {
			out.println("NO SOLUTION");
			return;
		}
		                                                           
		out.println(a[n]);
		int cp = n;
		ArrayList<String> list = new ArrayList<String>();
		while (true) {
			int pp = pi[cp];                                       
			if (pp == -1) {
				break;
			}
			list.add(S.substring(pp, cp));
			cp = pp;
		}

		Collections.reverse(list);
		out.println(list.size());
		for (String t : list) {
			out.println(t);
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public language_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new language_ft()).start();
	}

}                       