import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class coffin_dg_wrong1 {

	public static void main(String[] args) throws IOException {
		new coffin_dg_wrong1().run();
	}
	
	private void run() throws IOException {
		Scanner sc = new Scanner(new File("coffin.in"));
		PrintWriter pw = new PrintWriter("coffin.out");
		
		long t = sc.nextInt();
		long c1 = sc.nextInt();
		long c2 = sc.nextInt();
		int a1 = sc.nextInt();
		int a2 = sc.nextInt();
		long r = solve(a1, a2, c1, c2, t);
		
		pw.println(r);
		
		sc.close();
		pw.close();
	}

	private long solve(int p, int q, long c1, long c2, long t) {
		int n = p + q;
		if (n == 0)
			return 0;
		if (p == 0)
			return c2 >= t ? 2 * t + c2 * q : c2 + t * (q + 1);
		if (q == 0)
			return c1 >= t ? 2 * t + c1 * p : c1 + t * (p + 1);
		if (c1 >= t && c2 >= t)
			return (p * c1 + q * c2) + 2 * t;
		if (c1 <= t && c2 <= t)	
			return t * (p + q) + (p > 0 ? c1 : c2) + t;
		if (p == 1)
			return c2 * q + t * 3;
		if (q == 1)
			return t * (p + 1) + t + c2;
		
		if (q > n / 2) {
			int r = n - q + 1;
			int b = (q + r - 1) / r;
			int xb = n - r * b + 1;
			int xb1 = r * b - q;
			long nc1 = c2 * (b - 1) + c1    - b * t + t;
			long nc2 = c2 * b + c1     - (b+1) * t + t;
			return solve(xb1, xb, nc1, nc2, t)    * b + t;
		} else {
			int r = q - 1;
			int b = (n - q + r - 1) / r;
			int yb = n - r * b - 1;
			int yb1 = r * b + q - n;
			long nc1 = c1 * b + c2    - (b + 1) * t + t;
			long nc2 = c1 * (b - 1) + c2   - b * t + t;
			return solve(yb, yb1, nc1, nc2, t)    * b + t;
		}
	}

}
