//  ""
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class palindr_ft implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "palindr";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}

    int tenPower(int k) {
    	int res = 1;
    	for (int i = 0; i < k; i++) {
    		res *= 10;
    	}
    	return res;
    }               

	public void solve() {
		int n = in.nextInt();
		myAssert(1 <= n && n <= (int) 1e9, "");
		n--;
		int l = 1;
		while (true) {
			int cnt = 0;
			int hl = l / 2;
			if (l % 2 == 0) {
				cnt = tenPower(hl) - tenPower(hl - 1);
			} else {
				cnt = tenPower(hl + 1) - tenPower(hl);
			}
			if (n < cnt) {
				int base = tenPower((l - 1) / 2);
				String s = Integer.toString(base + n);
				String mid = "";
				if (l % 2 == 1) {
					mid = "" + s.charAt(s.length() - 1);
					s = s.substring(0, s.length() - 1);
				}
				out.println(s + mid + (new StringBuilder(s).reverse()));
				return;
			} else {
				n -= cnt;
				l++;
			}
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public palindr_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new palindr_ft()).start();
	}

}                       