//  ""
// 8-  -  2007-2008
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru
//    1  p-1     

import java.io.*;
import java.util.*;

public class root_sp_slow implements Runnable {

	public static void main(String[] args) {
		new Thread(new root_sp_slow()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "root";
	
	int pow(long a, int b, int p) {
		long res = 1;
		while (b-- > 0) {
			res = (res * a) % p;
		}
		return (int) res;
	}
	

	public void solve() throws IOException {
		int p = nextInt();
		int k = nextInt();
		ArrayList<Integer> ans = new ArrayList<Integer>();
		for (int i = 1; i < p; i++) {
			if (pow(i, k, p) == 1) {
				ans.add(i);
			}
		}
		out.println(ans.size());
		for (int i : ans) {
			out.print(i + " ");
		}
	}
}
