import java.io.*;
import java.util.*;

public class minima_as implements Runnable {

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("minima.in"));
        PrintWriter out = new PrintWriter(new File("minima.out"));

        int n = in.nextInt();
        int m = in.nextInt();
        int k = in.nextInt();
        int a = in.nextInt();
        int b = in.nextInt();
        int c = in.nextInt();
        int[] x = new int[n];

        for (int i = 0; i < k; i++) {
            x[i] = in.nextInt();
        }

        long time = System.currentTimeMillis();
        for (int i = k; i < n; i++) {
            x[i] = a * x[i - 2] + b * x[i - 1] + c;
        }

        System.out.println(System.currentTimeMillis() - time);

        int[] p = new int[n];
        int h = 0;
        int t = 0;
        p[0] = 0;

        long z = 0;
        if (m == 1) {
            z += x[0];
        }
        for (int i = 1; i < n; i++) {
            while (t >= h && x[p[t]] >= x[i]) {
                t--;
            }
            p[++t] = i;
            if (i >= m - 1) {
                if (i - m == p[h]) {
                    h++;
                }
                z += x[p[h]];
            }
        }
        System.out.println(System.currentTimeMillis() - time);

        out.println(z);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new minima_as()).start();
    }
}
