//  "-"
// 13-  -  2007-2008
//  :  , tsarev@rain.ifmo.ru
//  :  , argentony@gmail.com

import java.io.*;
import java.math.*;
import java.util.*;

public class numperm_af implements Runnable {
  public static void main(String[] args) {
    new Thread(new numperm_af()).start();
  }

  public void run() {
    try {
      in = new Scanner(new File("numperm.in"));
      out = new PrintWriter("numperm.out");
      solve();
    } catch (Throwable e) {
      e.printStackTrace();
      System.exit(-1);
    } finally {
      out.close();
    }
  }

  Scanner in;
  PrintWriter out;

  public void solve() throws IOException {
    long n = in.nextLong();
    if (!(1 <= n && n <= 1000000000)) {
      throw new Error("n is out of bounds!!!");
    }
    long sum = 1;
    int k = 2;
    long m = 1;
    while (n >= sum) {
      m *= k++;
      sum += m;
    }
    k--;
    sum -= m;
    n -= sum;
    long[] fac = new long[k];
    fac[0] = 1;
    for (int i = 1; i < k; i++) {
      fac[i] = fac[i - 1] * i;
    }
    long ans = 0;
    ArrayList<Integer> free = new ArrayList<Integer>();
    for (int i = 0; i < k; i++) {
      free.add(i);
    }
    for (int i = 0; i < k; i++) {
      int j = 0;
      while (n >= fac[k - i - 1]) {
        n -= fac[k - i - 1];
        j++;
      }
      ans = ans * k + free.get(j);
      free.remove(j);
    }
    out.println(ans);
  }

}
