#include <stdio.h>

#define MAXH 500

int min (int a, int b) {
	return (a < b) ? a : b;
}

int max (int a, int b) {
	return (a > b) ? a : b;
}

int n, h, w;
int a[MAXH + 1][MAXH + 1];
int x0, y0, xpred, ypred, x, y;

int main() {
	freopen("pixel.in","r",stdin);
	freopen("pixel.out","w",stdout);
	
	scanf("%d %d %d",&n, &h, &w);
	scanf("%d %d", &x0, &y0);
	xpred = x0;
	ypred = y0;
	for (int i = 1; i < n; ++i) {
		scanf("%d %d", &x, &y);
		
		if (y == ypred) {
			for (int j = min(xpred, x); j <= max(xpred, x); ++j) {
				a[j][y] = 1;
			}
		}

		xpred = x;
		ypred = y;
	}
	if (y == y0) {
		for (int j = min(x0, x); j <= max(x0, x); ++j) {
			a[j][y] = 1;
		}
	}

	for (int i = 0; i <= h; ++i) {
		int cnt = 0;
		for (int j = 0; j <= w; ++j) {
			if (a[i][j] == 1) {
				cnt++;
			}
			if ((cnt % 2) == 1 || a[i][j] == 1) {
				printf("1");
			} else {
				printf("0");
			}
		}
		printf("\n");
	}

	return 0;
}
