import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class dinner_as implements Runnable {

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("dinner.in"));
        PrintWriter out = new PrintWriter(new File("dinner.out"));

        int k = in.nextInt();
        int n = in.nextInt();

        BigInteger[][] a = new BigInteger[n + 1][k + 1];
        for (int i = 0; i < n + 1; i++) {
            Arrays.fill(a[i], BigInteger.ZERO);
        }
        a[0][0] = BigInteger.ONE;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= k; j++) {
                a[i + 1][j] = a[i + 1][j].add(a[i][j].multiply(BigInteger.valueOf(j)));
                if (j < k) {
                    a[i + 1][j + 1] = a[i + 1][j + 1].add(a[i][j].multiply(BigInteger.valueOf(k - j)));
                }
            }
        }

        out.println(a[n][k]);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new dinner_as()).start();
    }
}
