import java.io.*;
import java.util.*;

public class kth_as implements Runnable {

    int[] x;

    int kth(int l, int r, int k) {
        if (l == r) {
            return x[k];
        }

        int i = l;
        int j = r;
        int v = x[(i + j) / 2];
        while (i <= j) {
            while (x[i] < v) {
                i++;
            }
            while (x[j] > v) {
                j--;
            }
            if (i <= j) {
                int t = x[i]; x[i] = x[j]; x[j] = t;
                i++;
                j--;
            }
        }

        if (k <= j) {
            return kth(l, j, k);
        } else if (i <= k) {
            return kth(i, r, k);
        } else {
            return x[k];
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("kth.in"));
        PrintWriter out = new PrintWriter(new File("kth.out"));

        int n = in.nextInt();
        int m = in.nextInt();
        int k = in.nextInt();
        int a = in.nextInt();
        int b = in.nextInt();
        int c = in.nextInt();
        x = new int[n];

        for (int i = 0; i < k; i++) {
            x[i] = in.nextInt();
        }

        long time = System.currentTimeMillis();
        for (int i = k; i < n; i++) {
            x[i] = a * x[i - 2] + b * x[i - 1] + c;
        }

        System.out.println(System.currentTimeMillis() - time);

        int z = kth(0, n - 1, m - 1);

        out.println(z);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new kth_as()).start();
    }
}
