import java.io.*;
import java.util.*;

public class kth_as_sort implements Runnable {

    int[] x;

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("kth.in"));
        PrintWriter out = new PrintWriter(new File("kth.out"));

        int n = in.nextInt();
        int m = in.nextInt();
        int k = in.nextInt();
        int a = in.nextInt();
        int b = in.nextInt();
        int c = in.nextInt();
        x = new int[n];

        for (int i = 0; i < k; i++) {
            x[i] = in.nextInt();
        }

        long time = System.currentTimeMillis();
        for (int i = k; i < n; i++) {
            x[i] = a * x[i - 2] + b * x[i - 1] + c;
        }

        System.out.println(System.currentTimeMillis() - time);

        Arrays.sort(x);
        int z = x[m - 1];

        out.println(z);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new kth_as_sort()).start();
    }
}