import java.util.*;
import java.io.*;

public class substring_as implements Runnable {
    public void solve() throws IOException {
        Scanner in = new Scanner(new File("substring.in"));
        PrintWriter out = new PrintWriter("substring.out");

        String t = in.next();
        String p = in.next();

        int n = t.length();
        int m = p.length();


        int[] last = new int[128];
        Arrays.fill(last, -1);
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            char c = t.charAt(i);
            assert 33 <= c && c <= 126;
            a[i] = i - last[c];
            last[c] = i;
        }

        Arrays.fill(last, -1);
        int[] b = new int[n];
        for (int i = 0; i < m; i++) {
            char c = p.charAt(i);
            assert 33 <= c && c <= 126;
            if (last[c] == -1) {
                b[i] = -i - 1;
            } else {
                b[i] = i - last[c];
            }
            last[c] = i;
        }

        int[] f = new int[m];
        f[0] = 0;
        int k = 0;
        for (int i = 1; i < m; i++) {
            while (k > 0 && !(b[k] == b[i] || (b[k] < 0 && b[i] < 0) || (b[k] < 0 && b[i] >= -b[k]))) {
                k = f[k - 1];
            }
            if (b[k] == b[i] || (b[k] < 0 && b[i] < 0) || (b[k] < 0 && b[i] >= -b[k])) {
                k++;
            }
            f[i] = k;
        }

        ArrayList<Integer> answer = new ArrayList<Integer>();
        k = 0;
        for (int i = 0; i < n; i++) {
            while (k > 0 && !(b[k] == a[i] || (b[k] < 0 && a[i] >= (-b[k])))) {
                k = f[k - 1];
            }
            if (b[k] == a[i] || (b[k] < 0 && a[i] >= (-b[k]))) {
                k++;
            }
            if (k == m) {
                answer.add(i - m + 2);
                k = f[k - 1];
            }
        }

        out.println(answer.size());
        for (int x : answer) {
            out.print(x + " ");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new substring_as()).start();
    }
}