//  " "
// 12- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , akhi@rain.ifmo.ruimport java.io.*;
import java.util.*;
import java.math.*;
import java.io.*;

public class cipher_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new cipher_aa()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	private void bounds(int x, int l, int r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x);
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "cipher";

	void solve() throws IOException {
		int k = nextInt();
		bounds(k, 1, 26, "k");
		char[] a = nextToken().toCharArray();
		char[] b = nextToken().toCharArray();
		char[] c = new char[k];
		for (int i = 0; i < a.length; i++) {
			bounds(a[i], 'a', 'a' + k - 1, "a[" + i + ']');
			bounds(b[i], 'a', 'a' + k - 1, "b[" + i + ']');
			if (c[a[i] - 'a'] == 0 || c[a[i] - 'a'] == b[i]) {
				c[a[i] - 'a'] = b[i];
			} else {
				out.println("IMPOSSIBLE");
				return;
			}
		}
		boolean[] d = new boolean[k];
		for (int i = 0; i < c.length; i++) {
			if (c[i] != 0) {
				d[c[i] - 'a'] = true;
			}
		}
		int q = 0;
		for (int i = 0; i < d.length; i++) {
			if (c[i] == 0) {
				while (q < d.length && d[q]) {
					q++;
				}
				c[i] = (char) ('a' + q);
				d[q] = true;
			}
		}
		for (int i = 0; i < c.length; i++) {
			for (int j = i + 1; j < c.length; j++) {
				if (c[i] == c[j]) {
					out.println("IMPOSSIBLE");
					return;
				}
			}
		}
		out.println("POSSIBLE");
		for (int i = 0; i < c.length; i++) {
			out.println((char) ('a' + i) + " -> " + c[i]);
		}
	}
}
