//Problem "Ineq"
//12th Internet Olympiad, season 2007-2008
//Problem Author:  Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Vladimir Ulyantsev, ulyantsev@rain.ifmo.ru

#include <stdio.h>
#include <stdlib.h>

#define MAXX 100

int n;

int main() {
	freopen("ineq.in", "r", stdin);
	freopen("ineq.out", "w", stdout);

	scanf("%d\n", &n);
	char left[n];
	char sg[n];
	char right[n];
	int num[n];
	char temp[10];

	for (int i = 0; i < n; ++i) {
		right[i] = 'q';
		num[i] = 0;
	}

	for (int i = 0; i < n; ++i) {
		scanf("%c %c ", &left[i], &sg[i]);
		gets(temp);
		if ('0' <= temp[0] && temp[0] <= '9') {
			num[i] = atoi(temp);	
		} else {
			right[i] = temp[0];
		}
	}

	int ans = 0;
	for (int x = 0; x <= MAXX; ++x) {
		for (int y = 0; y <= MAXX; ++y) {
			for (int z = 0; z <= MAXX; ++z) {
				bool tobe = true;
				for (int i = 0; i < n; ++i) {
				
					if (left[i] == 'x') {
						if ((right[i] == 'y') && (x <= y)) {
							tobe = false;
						} 
						if ((right[i] == 'z') && (x <= z)) {
							tobe = false;
						}
						if (right[i] == 'x') {
							tobe = false;
						} 
						if ((right[i] == 'q')) {
							if ((sg[i] == '<') && (x >= num[i])) {
								tobe = false;
							}
							if ((sg[i] == '>') && (x <= num[i])) {
								tobe = false;
							}	
						}
					}

					if (left[i] == 'y') {
					    if ((right[i] == 'x') && (y <= x)) {
							tobe = false;
						} 
						if ((right[i] == 'z') && (y <= z)) {
							tobe = false;
						}
						if (right[i] == 'y') {
							tobe = false;
						} 
						if ((right[i] == 'q')) {
							if ((sg[i] == '<') && (y >= num[i])) {
								tobe = false;
							}
							if ((sg[i] == '>') && (y <= num[i])) {
								tobe = false;
							}	
						}
					}

					if (left[i] == 'z') {
						if ((right[i] == 'y') && (z <= y)) {
							tobe = false;
						} 
						if ((right[i] == 'x') && (z <= x)) {
							tobe = false;
						}
						if (right[i] == 'z') {
							tobe = false;
						} 
						if ((right[i] == 'q')) {
							if ((sg[i] == '<') && (z >= num[i])) {
								tobe = false;
							}
							if ((sg[i] == '>') && (z <= num[i])) {
								tobe = false;
							}	
						}
					}

				}
				if (tobe) ans++;
			}
		}
	}


	printf("%d\n", ans);

	return 0;
}
