//  "k- "
// 12- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , akhi@rain.ifmo.ru
import java.io.*;
import java.util.*;
import java.math.*;

public class kmin_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new kmin_aa()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	private void bounds(int x, int l, int r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x);
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "kmin";

	void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		TreeSet<Integer> ts = new TreeSet<Integer>();
		for (int i = 0; i < n; i++) {
			ts.add(nextInt());
			while (ts.size() > k) {
				ts.pollLast();
			}
		}
		out.println(ts.pollLast());
	}
}
