import java.io.*;
import java.util.*;

public class pac_af_wrong implements Runnable {
	public static void main(String[] args) {
		new Thread(new pac_af_wrong()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new Scanner(new File("pac.in"));
			out = new PrintWriter("pac.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	Scanner in;
	PrintWriter out;

	void solve() throws IOException {
		int n = in.nextInt();
		long[] x = new long[n];
		long[] y = new long[n];
		long[] r = new long[n];

		for (int i = 0; i < n; i++) {
			x[i] = in.nextInt();
			y[i] = in.nextInt();
			r[i] = in.nextInt();
		}
		double ans = Double.POSITIVE_INFINITY;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				long cd = (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
				if (cd <= (r[i] + r[j]) * (r[i] + r[j])) {
					ans = Math.min(ans, (r[i] - r[j]) * (r[i] - r[j]) - cd);
				} else {
					ans = Math.min(ans, cd - (r[i] + r[j]) * (r[i] + r[j]));
				}
			}
		}
		out.println(Math.sqrt(Math.max(0, ans)));
	}
}
