import java.util.*;
import java.io.*;

public class show_as_wrong implements Runnable {
    PrintWriter out;

    public void quitNo() {
        out.println("NO");
        out.close();
        System.exit(0);
    }

    int n;
    int[] which;
    int[] other;
    int[] answer;
    int[] cnt;
    int[][] then;
    boolean[] used;
    int now;
    int[] when;

    boolean tryPut(int i, int z) {
        if (answer[i] != -1 && answer[i] != z) {
            return false;
        }
        if (answer[i] == -1 && used[z]) {
            return false;
        }
        if (answer[i] == z) {
            return true;
        }

        answer[i] = z;
        when[i] = now;
        used[z] = true;

        for (int j = 0; j < n; j++) {
            if (then[z][j] != 0) {
                int k;
                if (then[z][j] == 1) {
                    k = which[j];
                } else{
                    k = other[j];
                }
                if (!tryPut(j, k)) {
                    return false;
                }
            }
        }
        return true;
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("show.in"));
        out = new PrintWriter("show.out");

        n = in.nextInt();
        int[] d = new int[n];
        for (int i = 0; i < n; i++) {
            d[i] = in.nextInt();
        }
        cnt = new int[n];
        which = new int[n];
        other = new int[n];
        Arrays.fill(which, -1);

        int m = in.nextInt();
        int[][] w = new int[m][n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                w[i][j] = in.nextInt();
                if (w[i][j] == d[j]) {
                    cnt[j]++;
                    if (cnt[j] == 1) {
                        which[j] = i;
                    } else {
                        other[j] = i;
                    }
                }
            }
        }

        for (int i = 0; i < n; i++) {
            assert cnt[i] <= 2;
            if (cnt[i] == 0) {
                quitNo();
            }
        }

        boolean[][] inc = new boolean[m][m];
        for (int i = 0; i < m; i++) {
            for (int j = i + 1; j < m; j++) {
                for (int k = 0; k < n; k++) {
                    if (w[i][k] == w[j][k]) {
                        inc[i][j] = true;
                        inc[j][i] = true;
                    }
                }
            }
        }

        then = new int[m][n];
        used = new boolean[m];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (inc[i][which[j]]) {
                    if (cnt[j] == 1) {
                        used[i] = true;
                    }
                    then[i][j] = 2;

                }
                if (cnt[j] > 1 && inc[i][other[j]]) {
                    if (then[i][j] == 2) {
                        used[i] = true;
                    }
                    then[i][j] = 1;
                }
            }
        }

        answer = new int[n];
        when = new int[n];
        Arrays.fill(answer, -1);
        for (int i = 0; i < n; i++) {
            if (cnt[i] == 1) {
                if (!tryPut(i, which[i])) {
                    quitNo();
                }
            }
        }

        now = 1;
        for (int i = 0; i < n; i++) {
            if (answer[i] == -1) {
                assert cnt[i] == 2;
                now++;
                if (!tryPut(i, which[i])) {
                    quitNo();
                }
            }
        }

        out.println("YES");
        for (int i = 0; i < n; i++) {
            out.print(answer[i] + 1);
            if (i < n - 1) {
                out.print(" ");
            }
        }
        out.println();

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new show_as_wrong()).start();
    }
}