import java.io.*;
import java.util.*;
import java.math.*;

public class amfi_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new amfi_aa()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	private void bounds(double r2, int l, int r, String name) {
		MyAssert(l <= r2 && r2 <= r, name + " is not in bounds!!! " + r2);
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "amfi";

	void solve() throws IOException {
		double R = nextInt();
		double r = nextInt();
		double l = nextInt();
		double d = nextInt();
		bounds(R, 1, 1000, "R");
		bounds(r, 1, 1000, "r");
		bounds(l, 1, 1000, "l");
		bounds(d, 1, 1000, "d");
		l /= 100;
		d /= 100;
		BigInteger n = BigInteger.ZERO;
		while (r + l <= R) {
			n = n.add(BigInteger.valueOf((long) Math.floor(Math.PI * r / d)));
			r += l;
		}
		out.println(n);
	}
}
