import java.io.*;
import java.util.*;
import java.math.*;

public class amfi_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new amfi_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("amfi.in"));
			out = new PrintWriter("amfi.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	String IOB = " is out of bounds!";

	void solve() throws IOException {
		int R = nextInt();
		myAssert(1 <= R && R <= 1000, "R" + IOB);
		int r = nextInt();
		myAssert(1 <= r && r <= 1000, "r" + IOB);
		int l = nextInt();
		myAssert(1 <= l && l <= 1000, "l" + IOB);
		int d = nextInt();
		myAssert(1 <= d && d <= 1000, "d" + IOB);
		
		long ans = 0;
		R *= 100;
		r *= 100;
		while (r + l <= R) {
			ans += Math.floor((Math.PI * r) / d);
			r += l;
		}
		out.println(ans);
	}
}
