//  ""
// 13- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class lines_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new lines_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "lines";

	public void solve() throws IOException {
		int n = nextInt();
		myAssert(n >= 1 && n <= 1e5, "Wrong n");
		long vcnt = 0;
		long hcnt = 0;
		HashSet<Integer> vlines = new HashSet<Integer>();
		HashSet<Integer> hlines = new HashSet<Integer>();
		for (int i = 0; i < n; i++) {
			int[] f = new int[4];
			for (int j = 0; j < 4; j++) {
				f[j] = nextInt();
				myAssert(Math.abs(f[j]) <= 1e9, "Wrong coordinate");
			}
			myAssert(f[0] != f[2] || f[1] != f[3], "Not different points");
			boolean fl = false;
			if (f[0] == f[2]) {
				vcnt++;
				fl ^= true;
				myAssert(!vlines.contains(f[0]), "Equal lines");
				vlines.add(f[0]);
			}
			if (f[1] == f[3]) {
				hcnt++;
				fl ^= true;
				myAssert(!hlines.contains(f[1]), "Equal lines");
				hlines.add(f[1]);
			}
			myAssert(fl, "Wrong line #" + (i + 1));
		}
		out.print(vcnt * hcnt);
	}
}
