//Problem "Numbers"
//13th Internet Olympiad, season 2007-2008
//Problem Author:  Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Vladimir Ulyantsev, ulyantsev@rain.ifmo.ru

#include <stdio.h>

#define MAXN 100000

int n, a[MAXN], ans;
bool e[3], was[MAXN];
long long sum = 0;

int main() {
	freopen("numbers.in", "r", stdin);
	freopen("numbers.out", "w", stdout);
	
	for (int i = 0; i < 3; ++i) {
		e[3] = 0;
	}

	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		was[i] = 1;
		scanf("%d", &a[i]);
		e[a[i] % 3] = 1;
		sum += a[i];
	}       

	ans = n;
	if (sum % 3 == 1) {
		if (e[1] == 1) {
			for (int i = 0; i < n; ++i) {
				if (a[i] % 3 == 1) {
					was[i] = 0;
					break;
				}
			}
			ans = n - 1;
		} else {
			for (int i = 0; i < n; ++i) {
				if (a[i] % 3 == 2 && ans > n - 2) {
					was[i] = 0;
					--ans;
				}
			}
		}
	}
	if (sum % 3 == 2) {
		if (e[2] == 1) {
			for (int i = 0; i < n; ++i) {
				if (a[i] % 3 == 2) {
					was[i] = 0;
					break;
				}
			}
			ans = n - 1;
		} else {
			for (int i = 0; i < n; ++i) {
				if (a[i] % 3 == 1 && ans > n - 2) {
					was[i] = 0;
					--ans;
				}
			}
		}
	}

	printf("%d\n", ans);
	for (int i = 0; i < n; ++i) {
		if (was[i]) {
			printf("%d ", i + 1);
		}
	}

	return 0;
}

