//  ""
// 13- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class seq_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new seq_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "seq";

	int sum(long n) {
		int ans = 0;
		while (n != 0) {
			ans += n % 10;
			n /= 10;
		}
		return ans;
	}

	int s_function(int n) {
		int ans = 0;
		for (long i = 1; i * i <= n; i++) {
			if (n % i == 0) {
				ans += sum(i * i);
				if (n / i != i) {
					ans += sum((n / i) * (n / i));
				}
			}
		}
		return ans;
	}

	public void solve() throws IOException {
		int x = nextInt();
		myAssert(x >= 1 && x <= 1e9, "Wrong number");
		HashMap<Integer, Integer> hm = new HashMap<Integer, Integer>();
		int i = 0;
		while (!hm.containsKey(x)) {
			hm.put(x, i);
			x = s_function(x);
			i++;
		}
		out.println(hm.get(x) + " " + (i - hm.get(x)));
	}
}
