import java.io.*;
import java.util.*;
import java.math.*;

public class sum_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new sum_aa()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	private void bounds(long m, int l, int r, String name) {
		MyAssert(l <= m && m <= r, name + " is not in bounds!!! " + m);
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "sum";

	void solve() throws IOException {
		int n = nextInt();
		bounds(n, 1, 1000, "n");
		long[] a = new long[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = nextInt();
			bounds(a[i], -1000000000, 1000000000, "a[" + i + "]");
		}
		long x = nextInt();
		bounds(x, -1000000000, 1000000000, "x");
		long[] s = new long[n];
		s[0] = a[0];
		for (int i = 1; i < s.length; i++) {
			s[i] = s[i - 1] + a[i];
		}
		for (int i = 0; i < s.length; i++) {
			for (int j = i; j < s.length; j++) {
				long q = s[j] - s[i] + a[i];
				if (q == x) {
					out.println((i + 1) + " " + (j + 1));
					return;
				}
			}
		}
		out.println("-1 -1");
	}
}
