//Problem "Sum"
//13th Internet Olympiad, season 2007-2008
//Problem Author:  Serge Poromov, poromov@rain.ifmo.ru
//Solution Author: Vladimir Ulyantsev, ulyantsev@rain.ifmo.ru

#include <stdio.h>

#define MAXN 1000

int n, x, l = -1, r = -1;
int a[MAXN]; 
long long sum[MAXN];

int main() {
	freopen("sum.in", "r", stdin);
	freopen("sum.out", "w", stdout);
	
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	scanf("%d", &x);

	for (int i = 0; i < n; ++i) {
		sum[i] = (i == 0) ? a[0] : sum[i - 1] + a[i];
		if (sum[i] == x) {
			printf("1 %d", (i + 1));
			return 0;
		}
	}

	for (int i = 1; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			if (sum[j] - sum[i - 1] == x) {
				l = i + 1;
				r = j + 1;
			}
		}
	}

	printf("%d %d", l, r);

	return 0;
}
