import java.io.*;
import java.util.*;

// "  "
//1- -  2008-2009,  .
// :   , tsarev@rain.ifmo.ru
// :  , buzdalov@rain.ifmo.ru

public class approach_mb {
    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("approach.in"));
        long x0 = in.nextLong();
        long y0 = in.nextLong();
        long vx = in.nextLong();
        long vy = in.nextLong();
        long v = in.nextLong();
        long t = in.nextLong();
        long d = in.nextLong();
        in.close();
        
        assert Math.abs(x0) <= 1000000000 : "x0 is out of bounds";
        assert Math.abs(y0) <= 1000000000 : "y0 is out of bounds";
        assert Math.abs(vx) <= 1000000 : "vx is out of bounds";
        assert Math.abs(vy) <= 1000000 : "vy is out of bounds";
        assert 1 <= v && v <= 1000000 : "v is out of bounds";
        assert 1 <= t && t <= 1000 : "t is out of bounds";
        assert 1 <= d && d <= 1000000000 : "d is out of bounds";
        
        PrintWriter out = new PrintWriter("approach.out");
        long x1 = x0 + vx * t;
        long y1 = y0 + vy * t;
        long r = v * t + d;
        long r2 = v * t - d;
        boolean externallyDisjoint = x1 * x1 + y1 * y1 > r * r;
        boolean internallyDisjoint = v * t < d && x1 * x1 + y1 * y1 < r2 * r2;
        out.println(externallyDisjoint || internallyDisjoint ? "NO" : "YES");
        out.close();
    }
}
