// "  - 2"
//1- -  2008-2009,  
// :  , toropov@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class battle2_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new battle2_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "battle2_aa".substring(0, "battle2_aa".length() - 3);

	private void solve() throws IOException {
		int n = nextInt();
		inBounds(n, 1, 100, "N");
		int m = nextInt();
		inBounds(m, 1, 100, "M");
		char[][] a = new char[n][];
		for (int i = 0; i < a.length; i++) {
			a[i] = nextToken().toCharArray();
			for (int j = 0; j < a[i].length; j++) {
				MyAssert(a[i][j] == '.' || a[i][j] == '*', "a[" + i + "][" + j
						+ "] is not right symbol: " + a[i][j]);
			}
		}
		int ans = 0;
		for (int i = 0; i < a.length; i++) {
			for (int j = 0; j < a[i].length; j++) {
				boolean good = true;
				for (int k = -1; k < 2; k++) {
					for (int l = -1; l < 2; l++) {
						if (Math.abs(k) + Math.abs(l) < 2) {
							good &= (i + k < 0) || (i + k >= a.length)
									|| (j + l < 0) || (j + l >= a[i].length)
									|| (a[i + k][j + l] == '.');
						}
					}
				}
				if (good) {
					ans++;
				}
			}
		}
		out.println(ans);
	}
}
