//  "  "
// 1- -  2007-2008,  
//  :  , ulyantsev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru
//  -     -    

import java.io.*;
import java.util.*;

public class circles_sp_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new circles_sp_wrong()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "circles";

	public void solve() throws IOException {
		int x1 = nextInt();
		int y1 = nextInt();
		int x2 = nextInt();
		int y2 = nextInt();
		int d1 = (int) Math.round(Math.floor(Math.sqrt(x1 * x1 + y1 * y1)));
		int d2 = (int) Math.round(Math.floor(Math.sqrt(x2 * x2 + y2 * y2)));
		out.println(Math.abs(d1 - d2));
	}
}
