// "⢥ "
//1- ୥- ᥧ 2008-2009,  ஢
// :  ॢ, tsarev@rain.ifmo.ru
// 襭: ⮭ 쪮, feskov@rain.ifmo.ru

import java.io.*;
import java.math.*;
import java.util.*;

public class dual_af implements Runnable {
    public static void main(String[] args) {
        new Thread(new dual_af()).start();
    }
    
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    
    public void run() {
        try {
            br = new BufferedReader(new FileReader("dual.in"));
            out = new PrintWriter("dual.out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                throw new Error("Enexpected end of file");
            }
        }
        return st.nextToken();
    }
    
    void myAssert(boolean e, String msg) {
        if (!e) {
            throw new Error(msg);
        }
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    final int MAXC = 100000;
    final int MAXN = 100;
    final int MAXK = 10;
    
    void solve() {
        int n = nextInt();
        myAssert(3 <= n && n <= MAXN, "n out of bounds");
        double[][] C = new double[n][2];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 2; j++) {
                C[i][j] = nextDouble();
                myAssert(-MAXC <= C[i][j] && C[i][j] <= MAXC, "Coordinates of point " + (i + 1) + " are out of bounds");
            }
        }
        int k = nextInt();
        myAssert(0 <= k && k <= MAXK, "k out of bounds");
        for (int i = 0; i < k; i++) {
            double[][] tC = new double[n][2];
            for (int j = 0; j < n; j++) {
                for (int q = 0; q < 2; q++) {
                    tC[j][q] = (C[j][q] + C[(j + 1)  % n][q]) / 2;
                }
            }
            C = tC;
        }
        double ans = 0;
        for (int i = 0; i < C.length; i++) {
            ans += Math.hypot(C[i][0] - C[(i + 1) % n][0], C[i][1] - C[(i + 1) % n][1]);
        }
        out.println(ans);
    }
}
