#include <fstream>
#include <cmath>
#include <vector>
#include <iomanip>

// " "
//1- -  2008-2009,  
// :   , tsarev@rain.ifmo.ru
// :  , buzdalov@rain.ifmo.ru

//  64-  .

typedef double floating;

int main()
{
    std::ifstream in("dual.in");
    std::ofstream out("dual.out");
    
    int n;
    in >> n;
    
    std::vector<floating> x(n), y(n), xt(n), yt(n);
    
    for (int i = 0; i < n; ++i)
    {
        in >> x[i] >> y[i];
    }
    
    int k;
    in >> k;
    
    for (int t = 0; t < k; ++t) 
    {
        for (int i = 0; i < n; ++i)
        {
            int j = (i + 1) % n;
            xt[i] = (x[i] + x[j]) / 2.0;
            yt[i] = (y[i] + y[j]) / 2.0;
        }
        
        for (int i = 0; i < n; ++i)
        {
            x[i] = xt[i];
            y[i] = yt[i];
        }
    }
    
    floating perim = 0;
    
    for (int i = 0; i < n; ++i)
    {
        int j = (i + 1) % n;
        
        perim += sqrt((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]));
    }
    
    out << std::setprecision(32) << perim << std::endl;
    
    return 0;
}
