//  " "
// 1- -  2007-2008,  
//  :  , toropov@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class harvest_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new harvest_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "harvest";

	public void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[n + 2];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
		}
		a[n] = a[0];
		a[n + 1] = a[1];
		int max = 0;
		for (int i = 0; i < n; i++) {
			max = Math.max(max, a[i] + a[i + 1] + a[i + 2]);
		}
		out.println(max);
	}
}
