//  ""
// 2- -  2008-2009,  .
//  :   , buzdalov@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//  :  10000 -  30 
// -    9    
import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class digits_vu_slow {

	final static BigInteger TEN = BigInteger.valueOf(10);
	final static BigInteger ZERO = BigInteger.ZERO;

	static BigInteger s(BigInteger x) {
		BigInteger ans = ZERO;
		while (x.compareTo(ZERO) > 0) {
			ans = ans.add(x.mod(TEN));
			x = x.divide(TEN);
		}
		return ans;
	}

	static int d(BigInteger x) {
		if (x.compareTo(TEN) < 0) 
			return x.intValue();
		else
			return d(s(x));
	}

	static BigInteger f(int n) {
		BigInteger ans = BigInteger.ONE;
		for (int i = 1; i <= n; i++) {
			ans = ans.multiply(BigInteger.valueOf(i));
		}
		return ans;
	}

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new File("digits.in"));
		PrintWriter out = new PrintWriter(new File("digits.out"));
		
		out.println(d(f(in.nextInt())));

		in.close();
		out.close();
	}

}
