// " "
//2- -  2008-2009,  
// :  , feskov@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class lazy_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new lazy_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "lazy_aa".substring(0, "lazy_aa".indexOf('_'));

	private void solve() throws IOException {
		String p = "qeopadgb";
		char[] s = br.readLine().toCharArray();
		inBounds(s.length, 0, 100000, "length");
		int ans = 0;
		for (int i = 0; i < s.length; i++) {
			MyAssert('a' <= s[i] && s[i] <= 'z' || s[i] == ' ', "s[" + i
					+ "] is not in ['a'..'z']!!! " + s[i]);
			if (p.indexOf(s[i]) >= 0) {
				ans++;
			}
		}
		out.println(ans);
	}

}
