// " "
//2- -  2008-2009,  .
// :   , feskov@rain.ifmo.ru
// :  , feskov@rain.ifmo.ru


import java.io.*;
import java.math.*;
import java.util.*;

public class lazy_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new lazy_af()).start();
	}
	
	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	
	public void run() {
		try {
			br = new BufferedReader(new FileReader("lazy.in"));
			out = new PrintWriter("lazy.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}
	
	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}
	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	final String gs = "qeopadgb";
	
	void solve() throws IOException {
		String s = br.readLine();
		int ans = 0;
		for (int i = 0; i < s.length(); i++) {
			myAssert(s.charAt(i) == ' ' || 'a' <= s.charAt(i) && s.charAt(i) <= 'z', "Invalid symbol at position " + i);
			if (gs.indexOf(s.charAt(i)) >= 0) {
				ans++;
			}
		}
		out.println(ans);
	}
}
