// "  "
//2- -  2008-2009,  
// :  , tsarev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class point_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new point_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "point_aa".substring(0, "point_aa".indexOf('_'));

	private void solve() throws IOException {
		long x = nextInt();
		long y = nextInt();
		long x1 = nextInt();
		long y1 = nextInt();
		long x2 = nextInt();
		long y2 = nextInt();
		inBounds(x, -1000000000, 1000000000, "x");
		inBounds(y, -1000000000, 1000000000, "y");
		inBounds(x1, -1000000000, 1000000000, "x1");
		inBounds(y1, -1000000000, 1000000000, "y1");
		inBounds(x2, -1000000000, 1000000000, "x2");
		inBounds(y2, -1000000000, 1000000000, "y2");
		if (x1 == x2) {
			if (Math.min(y1, y2) <= y && y <= Math.max(y1, y2)) {
				out.println(Math.abs(x - x1));
			} else {
				out.println(Math.abs(x - x1)
						+ Math.min(Math.abs(y - y1), Math.abs(y - y2)));
			}
		} else {
			if (Math.min(x1, x2) <= x && x <= Math.max(x1, x2)) {
				out.println(Math.abs(y - y1));
			} else {
				out.println(Math.abs(y - y1)
						+ Math.min(Math.abs(x - x1), Math.abs(x - x2)));
			}
		}
	}

}
