//  " "
// 1-  -  2007-2008,  
//  :  , ulyantsev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class gentest3_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new gentest3_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "gentest3";

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		myAssert(1 <= k && k < n && n <= (int)1e6, "Out of bounds");
		if (n == 2 && k == 1) {
			out.println(-1);
			return;
		}
		n = n - k;
		boolean fl = false;
		if (n < k) {
			int t = n;
			n = k;
			k = t;
			fl = true;
		}
		long[] a1 = new long[k];
		long[] a2 = new long[n];
		long s1 = 0;
		long s2 = 0;
		for (int i = 1; i <= n - k; i++) {
			a2[k + i - 1] = i;
			s2 += i;
		}
		int j = n - k + 1;
		for (int i = 0; i < k - 1; i++) {
			if (i % 2 == 0) {
				a1[i] = j;
				s1 += j++;
				a2[i] = j;
				s2 += j++;
			} else {
				a2[i] = j;
				s2 += j++;
				a1[i] = j;
				s1 += j++;
			}
		}
		a2[k - 1] = j;
		s2 += j++;
		a1[k - 1] = s2 - s1;
		if (a1[k - 1] == a2[k - 1]) {
			a1[k - 2] += 1;
			a2[k - 2] += 3;
			a2[k - 1] += 4;
			a1[k - 1] += 6;
		}
		if (fl) {
			for (int i = 0; i < n; i++) {
				out.print(a2[i] + " ");
			}
			for (int i = 0; i < k; i++) {
				out.print(a1[i] + " ");
			}
		} else {
			for (int i = 0; i < k; i++) {
				out.print(a1[i] + " ");
			}
			for (int i = 0; i < n; i++) {
				out.print(a2[i] + " ");
			}
		}
	}
}
