import java.io.*;
import java.util.*;

public class merge_as implements Runnable {

    int m;
    int n;
    int[] x;
    int[] y;
    int nc;

    void build(int s, int d) {
        if (d > m + n) {
            return;
        }
        build(s, 2 * d);
        build(s + d, 2 * d);
        for (int i = s; i + d < m + n; i += 2 * d) {
            x[nc] = i;
            y[nc] = i + d;
            nc++;
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("merge.in"));
        PrintWriter out = new PrintWriter(new File("merge.out"));

        m = in.nextInt();
        n = in.nextInt();

        x = new int[(n + m) * (n + m)];
        y = new int[(n + m) * (n + m)];
        nc = 0;
        build(0, 1);

        String[] v = new String[m + n];
        for (int i = 0; i < m; i++) {
            v[i] = "x" + (m - i);
        }
        for (int i = 0; i < n; i++) {
            v[m + i] = "y" + (i + 1);
        }
        for (int i = 0; i < nc; i++) {
            String s1 = "(" + v[x[i]] + "&" + v[y[i]] + ")";
            String s2 = "(" + v[x[i]] + "|" + v[y[i]] + ")";
            v[x[i]] = s1;
            v[y[i]] = s2;
        }

        for (int i = 0; i < m + n; i++) {
            out.println(v[i]);
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new merge_as()).start();
    }
}
