//  " "
// 1-  -  2008-2009
//  :  , akhi@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru
//   -  

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class prefrev_sm_slow_bruteforce extends Thread {

	String reverse(String s) {
		return new StringBuffer(s).reverse().toString();
	}
	String brute(String s) {		
		if (s.length()<=1)return s;
		String a = brute(s.substring(0, s.length()-1))+s.charAt(s.length()-1);
		String b = brute(reverse(s.substring(1, s.length())))+s.charAt(0);
		if (a.compareTo(b)<0) {
			return a;
		}else {
			return b;
		}		
	}
	
	void solve() throws IOException {
		String s = in.readLine();		
		out.println(brute(s));
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	BufferedReader in;
	PrintWriter out;

	public void run() {
		try {
			in = new BufferedReader(new FileReader("prefrev.in"));
			out = new PrintWriter(new File("prefrev.out"));
			solve();
			out.flush();
			out.close();
			// new FilePrinter("prefrev.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new prefrev_sm_slow_bruteforce().start();
	}

}
