import java.util.*;
import java.io.*;

public class chip_as implements Runnable {
    public void solve() throws IOException {
        Scanner in = new Scanner(new File("chip.in"));
        PrintWriter out = new PrintWriter("chip.out");

        int m = in.nextInt();
        int n = in.nextInt();
        int h = in.nextInt();

        int[] a = new int[m];
        for (int i = 0; i < m; i++) {
            a[i] = in.nextInt();
            assert (a[i] <= n);
        }
        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            b[i] = in.nextInt();
            assert (b[i] * h <= m);
        }

        int[] c = new int[m];
        for (int i = 0; i < m; i++) {
            c[i] = n;
        }
        int[] d = new int[n];

        int[][] z = new int[m][n];

        boolean possible = true;
        fill:
        for (int i = 0; i < m; i++) {
            if (c[i] < a[i]) {
                possible = false;
                break;
            }

            while (c[i] > a[i]) {
                int best = 0;
                int k = -1;
                for (int j = 0; j < n; j++) {
                    if (d[j] == i && b[j] > best && i + h <= m) {
                        best = b[j];
                        k = j;
                    }
                }
                if (k == -1) {
                    possible = false;
                    break fill;
                }
                b[k]--;

                d[k] += h;
                z[i][k] = 1;
                for (int j = 1; j < h - 1; j++) {
                    z[i + j][k] = 2;
                }
                z[i + h - 1][k] = 1;
                for (int j = 0; j < h; j++) {
                    c[i + j]--;
                }
            }

            for (int j = 0; j < n; j++) {
                if (d[j] == i) {
                    d[j]++;
                }
            }
        }

        for (int i = 0; i < n; i++) {
        	if (b[i] != 0) {
        		possible = false;
        	}
        }

        if (!possible) {
            out.println("inconsistent");
        } else {
            for (int i = 0; i < m; i++) {
                for (int j = 0; j < n; j++) {
                    out.print("*+|".charAt(z[i][j]));
                }
                out.println();
            }
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new chip_as()).start();
    }
}