import java.util.*;
import java.io.*;

public class game_as_stupid implements Runnable {
    int[][] next;
    int[] suf;
    int[] par;
    int[] via;
    ArrayList<Integer>[] dsuf;
    boolean[] term;
    int[] win;
    int nc;

    void insert(String s, int f, boolean isTerm) {
        int c = 0;
        for (int i = f; i < s.length(); i++) {
            int v = s.charAt(i) - 33;
            if (next[c][v] == -1) {
                next[c][v] = nc;
                par[nc] = c;
                via[nc] = v;
                Arrays.fill(next[nc], -1);
                nc++;
            }
            c = next[c][v];
        }
        if (isTerm) {
	        term[c] = true;
	    }
    }

    int winner(int v) {
        if (term[v]) {
            return win[v] = 1;
        } else {
            if (win[v] != 0) {
                return win[v];
            }

            for (int i = 0; i < next[v].length; i++) {
                if (next[v][i] != -1) {
                    if (winner(next[v][i]) == -1) {
                        return win[v] = 1;
                    }
                }
            }
            if (dsuf[v] != null) {
                for (int x : dsuf[v]) {
                    if (winner(x) == -1) {
                        return win[v] = 1;
                    }
                }
            }
            return win[v] = -1;
        }
    }

    void dfs(int x, int[] p, int l) {
        search:
        for (int c = 0; c < 126 - 32; c++) {
            if (next[0][c] != -1) {
                int q = next[0][c];
                for (int j = 0; j < l; j++) {
                    if (next[q][p[j]] != -1) {
                        q = next[q][p[j]];
                    } else {
                        continue search;
                    }
                }
                if (dsuf[x] == null) {
                    dsuf[x] = new ArrayList<Integer>();
                }
                dsuf[x].add(q);
            }
        }

        for (int c = 0; c < next[x].length; c++) {
            if (next[x][c] != -1) {
                p[l] = c;
                dfs(next[x][c], p, l + 1);
            }
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("game.in"));
        PrintWriter out = new PrintWriter("game.out");

        int n = in.nextInt();
        String[] w = new String[n];
        int l = 1;
        for (int i = 0; i < n; i++) {
            w[i] = in.next();
            l += w[i].length() * (w[i].length() + 1) / 2;
        }

        nc = 1;
        next = new int[l][126 - 32];
        Arrays.fill(next[0], -1);
        term = new boolean[l];
        par = new int[l];
        via = new int[l];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < w[i].length(); j++) {
                insert(w[i], j, j == 0);
            }
        }

        dsuf = new ArrayList[l];
        dfs(0, new int[50], 0);

        win = new int[l];
        int p = winner(0);
        if (p == 1) {
            out.println("First");
            for (int x = 0; x < next[0].length; x++) {
                if (next[0][x] != -1 && winner(next[0][x]) == -1) {
                    out.print((char) (x + 33));
                }
            }
            out.println();
        } else {
            out.println("Second");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new game_as_stupid()).start();
    }
}