// ""
//3- -  2008-2009,  .
// :  , tsarev@rain.ifmo.ru
// :  , buzdalov@rain.ifmo.ru

//,  -    .

import java.io.*;
import java.util.*;

public class robot_mb_hash {
    private static void assertion(boolean exp, String msg) {
        if (!exp) {
            throw new AssertionError(msg);
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new FileReader("robot.in"));
        String cmd = in.readLine();
        in.close();
        
        assertion(cmd.length() > 0 && cmd.length() <= 1000, "string length is wrong");
        
        HashSet<Integer> firstTime = new HashSet<Integer>();
        HashSet<Integer> extraTime = new HashSet<Integer>();
        
        int current = 0;
        firstTime.add(current);
        for (int i = 0; i < cmd.length(); ++i) {
            switch (cmd.charAt(i)) {
                case 'U':
                    current -= 2048;
                    break;
                case 'D':
                    current += 2048;
                    break;
                case 'L':
                    current -= 1;
                    break;
                case 'R':
                    current += 1;
                    break;
                default:
                    assertion(false, "illegal symbol: " + cmd.charAt(i));
            }
            if (firstTime.contains(current)) {
                extraTime.add(current);
            } else {
                firstTime.add(current);
            }
        }
        
        PrintWriter out = new PrintWriter("robot.out");
        out.println(extraTime.size());
        out.close();
    }
}
