//  ""
// 3- -  2008-2009,  
//  :  
//  :  , melnikov@rain.ifmo.ru

//   -   O(n)   O(n) 

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class sequence_sm_slow extends Thread {

	void solve() {
		long x = in.nextInt();
		long y = in.nextInt();
		long z = in.nextInt();
		long w = in.nextInt();
		int n = in.nextInt();
		int k = in.nextInt();
		long a[] = new long[n + 1];
		a[0] = Integer.MAX_VALUE;
		a[1] = w;
		for (int i = 2; i < n; i++) {
			a[i] = (x * a[i - 1] + y) % z;
		}
		Arrays.sort(a);
		out.println(a[k]);
		return;
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	Scanner in;
	PrintWriter out;

	public void run() {
		try {
			in = new Scanner(new File("sequence.in"));
			out = new PrintWriter(new File("sequence.out"));
			solve();
			out.flush();
			out.close();
			// new FilePrinter("sequence.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new sequence_sm_slow().start();
	}

}
