// "  - 3"
//3- -  2008-2009,  .
// :   , tsarev@rain.ifmo.ru
// :  , buzdalov@rain.ifmo.ru

// .    BufferedReader/StringTokenizer.

import java.io.*;
import java.util.*;

public class ticket3_mb_fastio {
    private static void assertion(boolean expr, String msg) {
        if (!expr) {
            throw new AssertionError(msg);
        }
    }
    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new FileReader("ticket3.in"));
        int n = 2 * Integer.parseInt(in.readLine());
        assertion(2 <= n && n <= 10000, "n is out of bounds");
        int[] ticket = new int[n];
        StringTokenizer st = new StringTokenizer(in.readLine());
        for (int i = 0; i < n; ++i) {
            ticket[i] = Integer.parseInt(st.nextToken());
            assertion(0 <= ticket[i] && ticket[i] <= 9, "digit is not between 0 and 9");
        }
        in.close();
        
        int firstHalf = 0, secondHalf = 0;
        int oddPlace = 0, evenPlace = 0;
        int odds = 0, evens = 0;
        
        for (int i = 0; i < n; ++i) {
            if (i < n / 2) {
                firstHalf += ticket[i];
            } else {
                secondHalf += ticket[i];
            }
            if (i % 2 == 0) {
                evenPlace += ticket[i];
            } else {
                oddPlace += ticket[i];
            }
            if (ticket[i] % 2 == 0) {
                evens += ticket[i];
            } else {
                odds += ticket[i];
            }
        }
        
        PrintWriter out = new PrintWriter("ticket3.out");
        out.println((firstHalf == secondHalf || oddPlace == evenPlace || odds == evens) ? "YES" : "NO");
        out.close();
    }
}
