//  "  - 4"
// 3- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class ticket3_sp_wrong1 implements Runnable {

	public static void main(String[] args) {
		new Thread(new ticket3_sp_wrong1()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "ticket3";

	public void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[2 * n];
		for (int i = 0; i < 2 * n; i++) {
			a[i] = nextInt();
		}
		int s1 = 0;
		int s2 = 0;
		for (int i = 0; i < n; i++) {
			s1 += a[2 * i];
			s2 += a[2 * i + 1];
		}
		if (s1 == s2) {
			out.println("YES");
			return;
		}
		s1 = 0;
		s2 = 0;
		for (int i = 0; i < 2 * n; i++) {
			if ((a[i] & 1) == 0) {
				s1 += a[i];
			} else {
				s2 += a[i];
			}
		}
		if (s1 == s2) {
			out.println("YES");
			return;
		}
		out.println("NO");
	}
}
