//  ""
// ??- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class tridiag_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new tridiag_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "tridiag";

	public void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 100, "Wrong n");
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				int t = nextInt();
				myAssert(Math.abs(t) <= 10000, "Wrong value");
				if (t != 0 && Math.abs(i - j) > 1) {
					out.println("NO");
					return;
				}
			}
		}
		out.println("YES");
	}
}
