// ""
//2-  -  2008-2009
// :  , ulyantsev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class cosmo_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new cosmo_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "cosmo_aa".substring(0, "cosmo_aa".indexOf('_'));

	private void solve() throws IOException {
		int a = nextInt();
		inBounds(a, 1, 9, "a");
		int b = nextInt();
		inBounds(b, 0, 9, "b");
		if (a == 1 && b == 1) {
			out.println(0);
			return;
		}
		if (b % 2 != 0 || b == 0) {
			out.println(-1);
			return;
		}
		int n = 0;
		BigInteger x = BigInteger.ONE;
		BigInteger deg10 = BigInteger.ONE;
		while (true) {
			if (x.mod(BigInteger.TEN).intValue() == b) {
				while (deg10.multiply(BigInteger.TEN).compareTo(x) <= 0) {
					deg10 = deg10.multiply(BigInteger.TEN);
				}
				if (x.divide(deg10).intValue() == a) {
					out.println(n);
					return;
				}
			}
			n++;
			x = x.multiply(BigInteger.valueOf(2));
		}
	}
}
