// ""
//2-  -  2008-2009
// :  , ulyantsev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class cosmo_aa_precalc implements Runnable {

	public static void main(String[] args) {
		new Thread(new cosmo_aa_precalc()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "cosmo_aa".substring(0, "cosmo_aa".indexOf('_'));

	int[][] c = new int[][] { { -1, 0, 17, -1, 10, -1, 4, -1, 7, -1, },
			{ -1, -1, 1, -1, 18, -1, 8, -1, 11, -1, },
			{ -1, -1, 5, -1, 78, -1, 88, -1, 15, -1, },
			{ -1, -1, 105, -1, 2, -1, 12, -1, 115, -1, },
			{ -1, -1, 9, -1, 102, -1, 112, -1, 19, -1, },
			{ -1, -1, 89, -1, 6, -1, 16, -1, 79, -1, },
			{ -1, -1, 149, -1, 46, -1, 56, -1, 159, -1, },
			{ -1, -1, 13, -1, 106, -1, 116, -1, 3, -1, },
			{ -1, -1, 53, -1, 166, -1, 156, -1, 63, -1, }, };

	private void solve() throws IOException {
		int a = nextInt();
		inBounds(a, 1, 9, "a");
		int b = nextInt();
		inBounds(b, 0, 9, "b");
		out.println(c[a - 1][b]);
	}
}
