// ""
//2-  -  2008-2009
// :  , buzdalov@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class log_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new log_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "log_aa".substring(0, "log_aa".indexOf('_'));

	private void solve() throws IOException {
		BigInteger a = nextBigInteger();
		BigInteger b = nextBigInteger();
		inBounds(a.longValue(), 2, 1000000000000000000L, "a");
		inBounds(b.longValue(), 1, 1000000000000000000L, "b");
		for (int p = 0; p < 60; p++) {
			for (int q = 1; q < 60; q++) {
				if (a.pow(p).equals(b.pow(q))) {
					int g = gcd(p, q);
					p /= g;
					q /= g;
					out.println(p + " " + q);
					return;
				}
			}
		}
		out.println("irrational");
	}

	int gcd(int a, int b) {
		while (b != 0) {
			int tmp = a % b;
			a = b;
			b = tmp;
		}
		return a;
	}

}
