import java.util.*;
import java.io.*;

public class pattern_as implements Runnable {
    public void solve() throws IOException {
        Scanner in = new Scanner(new File("pattern.in"));
        PrintWriter out = new PrintWriter("pattern.out");

        String s = in.next();
        int n = s.length();
        int[] z = new int[n];
        for (int i = 0; i < n; i++) {
            z[i] = s.charAt(i) - 'a';
        }

        short[][] a = new short[n][n];

        for (int i = 0; i < n; i++) {
            int[] last = new int[26];
            Arrays.fill(last, -1);
            for (int j = i; j < n; j++) {
                if (last[z[j]] == -1) {
                    a[i][j - i] = 0;
                } else {
                    a[i][j - i] = (short) ((j - i) - last[z[j]]);
                }
                last[z[j]] = j - i;
            }
            for (int j = n - i; j < n; j++) {
                a[i][j] = (short) n;
            }
        }

        short[][] b = new short[n + 1][n];
        int[] bsz = new int[n + 1];
        short[] p = new short[n];
        for (int i = 0; i < n; i++) {
            p[i] = (short) i;
        }

        short[] np = new short[n];
        for (int i = 0; i < n; i++) {
            Arrays.fill(bsz, 0);
            for (int j = 0; j < n; j++) {
                int c = a[p[j]][n - i - 1];
                b[c][bsz[c]++] = p[j];
            }
            int v = 0;
            for (int j = 0; j <= n; j++) {
                for (int k = 0; k < bsz[j]; k++) {
                    np[v++] = b[j][k];
                }
            }
            short[] tmp = p; p = np; np = tmp;
        }

        int[] l = new int[n];
        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < n; j++) {
                if (a[p[i]][j] != a[p[i + 1]][j]) {
                    l[i] = j;
                    break;
                }
            }
        }

        int[] x = new int[n + 1];
        int[] st = new int[n + 1];
        x[0] = -1;

        int best = n;
        int bs = 0;
        for (int i = 0; i < n; i++) {
            if (p[i] == 0) {
                bs = i;
            }
        }
        int bl = n;

        int sp = 1;
        for (int i = 0; i < n; i++) {
            while (st[sp - 1] > l[i]) {
                if ((i - (x[sp - 2] + 1) + 1) * st[sp - 1] > best) {
                    best = (i - (x[sp - 2] + 1) + 1) * st[sp - 1];
                    bs = x[sp - 2] + 1;
                    bl = st[sp - 1];
                }
                sp--;
            }
            if (l[i] > st[sp - 1]) {
                st[sp] = l[i];
                x[sp] = i;
                sp++;
            } else {
                x[sp - 1] = i;
            }
        }

        for (int i = 0; i < bl; i++) {
            out.print((char)(z[p[bs] + i] + 'a'));
        }
        out.println();
        System.out.println(best);
        //out.println(bl);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
        }
    }

    public static void main(String[] arg) {
        new Thread(new pattern_as()).start();
    }
}