//  "ࠫ ண"
// 5- ୥- ᥧ 2008-2009, ᫮ ஢.
//  :   ॢ, tsarev@rain.ifmo.ru
//  襭:  ॢ, tsarev@rain.ifmo.ru 

import java.io.*;
import java.util.*;

public class roads_ft_wrong implements Runnable {

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}

	private final static int INF = (int) 1e9;
    
    int n;
    int[][] a;
    int k;
    int[][] proposal;
    int p;
    int[][] req;
    
    boolean check(int cnt) {
    	int[][] b = new int[n][n];
    	for (int i = 0; i < n; i++) {
    		for (int j = 0; j < n; j++) {
    			b[i][j] = a[i][j];
    		}
    	}
    	for (int i = 0; i <= cnt; i++) {
    		int u = proposal[i][0];
    		int v = proposal[i][1];
    		int w = proposal[i][2];
    		b[u][v] = w;
    		b[v][u] = w;
    	}
    	for (int k = 0; k < n; k++) {
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < n; j++) {
    				b[i][j] = Math.min(b[i][j], b[i][k] + b[k][j]);
    			}
    		}
    	}
    	for (int i = 0; i < p; i++) {
    		int u = req[i][0];
    		int v = req[i][1];
    		if (b[u][v] > req[i][2]) {
    			return false;
    		}
    	}
    	return true;
    }

	void solve() throws NumberFormatException, IOException {
		n = nextInt();
		int m = nextInt();
		a = new int[n][n];
		for (int[] b : a) {
			Arrays.fill(b, INF);
		}
		for (int i = 0; i < m; i++) {
			int u = nextInt() - 1;
			int v = nextInt() - 1;
			int w = nextInt();
			a[u][v] = w;
			a[v][u] = w;
		}
		for (int i = 0; i < n; i++) {
			a[i][i] = 0;
		}
		k = nextInt();
		proposal = new int[k][5];
		for (int i = 0; i < k; i++) {
			proposal[i][0] = nextInt() - 1; 
			proposal[i][1] = nextInt() - 1; 
			proposal[i][2] = nextInt();
			proposal[i][3] = nextInt();
			proposal[i][4] = i;
		}

		p = nextInt();
		req = new int[p][3];
		for (int i = 0; i < p; i++) {
			req[i][0] = nextInt() - 1;
			req[i][1] = nextInt() - 1;
			req[i][2] = nextInt();
		}
		Arrays.sort(proposal, new Comparator<int[]>() {
			public int compare(int[] a, int[] b) {
				return a[3] - b[3];
			}
		});

		if (check(0)) {
			out.println(0);
			return;
		}
		if (!check(k - 1)) {
			out.println(-1);
			return;
		}

		int l = 0;
		int r = k - 1;
		while (r - l > 1) {
			int mm = (l + r) / 2;
			if (check(mm)) {
				r = mm;
			} else {
				l = mm;
			}
		}
		ArrayList<Integer> ans = new ArrayList<Integer>();
		for (int i = 0; i <= r; i++) {
			ans.add(proposal[i][4] + 1);
		}
		Collections.sort(ans);
		out.println(ans.size());
		for (int x : ans) {
			out.print(x + " ");
		}
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new Thread(new roads_ft_wrong("roads")).start();
	}

	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;
	
	public roads_ft_wrong(String fname) throws IOException {
		in = new BufferedReader(new FileReader(fname + ".in"));
		st = new StringTokenizer("");
		out = new PrintWriter(new FileWriter(fname + ".out"));
	}
	
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			apstenu(e);
		} finally {
			out.close();
		}
	}

	private void apstenu(Exception e) {
		e.printStackTrace();
		System.exit(1);
	}
	
}
