//  "  "
// 5- -  2008-2009,  .
//  :   , tsarev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//   (n^2)
        
import java.util.*;
import java.io.*;
import java.math.*;

public class subseq_vu_slow implements Runnable {
	final static String FILE = "subseq";

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new subseq_vu_slow()).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	int nextInt() throws IOException {
		while (st == null || !st.hasMoreElements()) {
			st = new StringTokenizer(in.readLine());
		}
		return Integer.parseInt(st.nextToken());
	}

	public subseq_vu_slow() {
		try {
			in = new BufferedReader(new FileReader(FILE + ".in"));
			out = new PrintWriter(new File(FILE + ".out"));
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = nextInt();

		int[] end = new int[n];
		int[] min = new int[n];
		Arrays.fill(min, Integer.MAX_VALUE);
		for (int i = 0; i < n; i++) {
			int pos = 0;
			for (; min[pos] < a[i]; pos++);
			end[i] = pos + 1;
			min[pos] = a[i];
		}
		
		int mod = 1000000007;
		int[] ans = new int[n + 1];
		ans[0] = 1;
		for (int i = 0; i < n; i++) {
			ans[end[i]] += ans[end[i] - 1];
			ans[end[i]] %= mod;
		}
		out.println(ans[-Arrays.binarySearch(min, Integer.MAX_VALUE - 1) - 1]);
	}
}
