//  "  "
// 5- -  2008-2009,  .
//  :   , tsarev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

// ,    
// Anton Akhi (22:04:32 27/11/2008)
//  ,    
//       ,    ...
        
import java.util.*;
import java.io.*;
import java.math.*;

public class subseq_vu_wrong3 implements Runnable {
	final static String FILE = "subseq";

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new subseq_vu_wrong3()).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	int nextInt() throws IOException {
		while (st == null || !st.hasMoreElements()) {
			st = new StringTokenizer(in.readLine());
		}
		return Integer.parseInt(st.nextToken());
	}

	public subseq_vu_wrong3() {
		try {
			in = new BufferedReader(new FileReader(FILE + ".in"));
			out = new PrintWriter(new File(FILE + ".out"));
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int[] ans = new int[n + 1];
		ans[0] = 1;
		int[] min = new int[n];
		Arrays.fill(min, Integer.MAX_VALUE);

		for (int i = 0; i < n; i++) {
			int t = nextInt();
			int pos = Arrays.binarySearch(min, t);
			if (pos < 0)
				pos = -pos - 1;
			ans[pos + 1] = (ans[pos + 1] + ans[pos]) % 1000000007;
			min[pos] = t;
		}
		
		out.println(ans[-Arrays.binarySearch(min, Integer.MAX_VALUE - 1) - 1]);
	}
}
