//  " "
// 5- -  2008-2009,  .
//   :  , buzdalov@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//    ---     .

import java.io.*;
import java.util.*;

public class tickets_vu_wrong {

	static final int maxn = 13;
	static int d;
	static long[][] z;

	static long[] cnt(char[] s, int mod) {
		long[] ans = new long[maxn + 1];
		int n = s.length;

		int prev = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < s[i] - '0'; j++) {
				int plus = j == d ? 1 : 0;
				for (int k = 0; k <= n - i - 1; k++) {
					ans[k + prev + plus] += z[n - i - 1][k];
				}
			}
			prev += s[i] - '0' == d ? 1 : 0;
		}
		ans[prev] += mod == 0 ? 1 : 0;

		return ans;
	}

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new File("tickets.in"));
		PrintWriter out = new PrintWriter(new File("tickets.out"));

		int n = in.nextInt();
		int c = in.nextInt();
		d = in.nextInt(); 
		int p = in.nextInt();

		z = new long[maxn + 1][maxn + 1]; // length | count
		z[0][0] = 1;

		for (int i = 1; i <= maxn; i++) {
			for (int j = 0; j <= maxn; j++) {
				z[i][j] = (j != 0 ? z[i - 1][j - 1] : 0) + z[i - 1][j];
			}
		}

		for (int i = 1; i <= maxn; i++) {
			for (int j = 0; j < i; j++) {
				z[i][j] *= Math.pow(9, i - j);
			}
		}

		for (int i = 0; i < n; i++) {
			long[] min = cnt(in.next().toCharArray(), 1);
			long[] max = cnt(in.next().toCharArray(), 0);
			double ans = 0;
			double price = c;
			for (int j = 0; j <= maxn; j++) {
				ans += price * (max[j] - min[j]);
				price *= (1 - p / 100.0);
			}
			out.println((long)ans);
		}

		in.close();
		out.close();
	}
}