//  "-2"
// 5- -  2008-2009,  
//  :  
//  :  , melnikov@rain.ifmo.ru

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class circles2_sm_slow extends Thread {

	void solve() {
		int n = in.nextInt();
		myAssert(0 <= n && n <= 100000000);
		myAssert(!in.hasNext());
		long a[] = new long[n + 4];
		a[0] = 1;
		a[1] = 2;
		for (int i = 2; i <= n; i++) {
			a[i] = a[i - 1] + 2 * i - 2;
		}
		out.println(a[n]);
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	Scanner in;
	PrintWriter out;

	public void run() {
		try {
			in = new Scanner(new File("circles2.in"));
			out = new PrintWriter(new File("circles2.out"));
			solve();
			out.flush();
			out.close();
			// new FilePrinter("circles2.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new circles2_sm_slow().start();
	}

}
