// " "
//5- -  2008-2009,  
// :  , toropov@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class frac_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new frac_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "frac_aa".substring(0, "frac_aa".indexOf('_'));

	private void solve() throws IOException {
		int p = nextInt();
		int q = nextInt();
		inBounds(p, 1, 1000, "p");
		inBounds(q, 1, 1000, "q");
		ArrayList<Integer> al = new ArrayList<Integer>();
		while (true) {
			int a = p / q;
			int b = p % q;
			al.add(a);
			if (b == 0) {
				break;
			}
			p = q;
			q = b;
		}
		out.println(al.size());
		for (int i : al) {
			out.print(i + " ");
		}
	}
}
