//  ""
// 5- -  2007-2008,  
//  :  , ulyantsev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class period_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new period_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "period";

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		int[] c = new int[k];
		Arrays.fill(c, -1);
		c[1] = 0;
		long t = 1;
		int i = 1;
		while (true) {
			t *= n;
			t %= k;
			if (c[(int) t] != -1) {
				out.println(i - c[(int) t]);
				return;
			}
			c[(int) t] = i++;
		}
	}
}
