//  ""
// 5- -  2007-2008,  
//  :  , ulyantsev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class time_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new time_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "time";

	public void solve() throws IOException {
		String s = nextToken();
		int ans = 0;
		for (int i = 0; i < 24 * 60; i++) {
			String time = Integer.toString(i / 600) + Integer.toString((i % 600) / 60) + Integer.toString((i % 60) / 10) + Integer.toString(i % 10);
			int j = 0;
			while (time.indexOf(s, j) >= 0) {
				ans++;
				j = time.indexOf(s, j) + 1;
			}
		}
		out.println(ans);
	}
}
