import java.io.*;
import java.util.*;

public class prefixes_as implements Runnable {

    public void solve() throws IOException {
        BufferedReader in = new BufferedReader(new FileReader("prefixes.in"));
        PrintWriter out = new PrintWriter(new File("prefixes.out"));

        String s = in.readLine();
        int n = s.length();

        char[] ans = new char[2 * n + 1];
        int l, r;
        l = r = n;

        char min = 'z' + 1;
        for (int i = 0; i < n; i++) {
            if (s.charAt(i) <= min) {
                ans[--l] = s.charAt(i);
                min = s.charAt(i);
            } else {
                ans[r++] = s.charAt(i);
            }
        }

        String answer = new String(ans, l, r - l);

        out.println(answer);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new prefixes_as()).start();
    }
}
