// "⨪-"
//5- 筠 ୥- ᥧ 2008-2009
// :  楢, ulyancev@rain.ifmo.ru
// 襭: ⮭ 쪮, feskov@rain.ifmo.ru


//One line skipped
import java.io.*;
import java.math.*;
import java.util.*;

public class gomoku_af_bug3 implements Runnable {
	public static void main(String[] args) {
		new Thread(new gomoku_af_bug3()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("gomoku.in"));
			out = new PrintWriter("gomoku.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	int[] dx = {1, 1,0};
	int[] dy = {-1, 1, 1};
	
	void solve() throws IOException {
		int n = nextInt();
		myAssert(0 <= n && n <= MAXN, "n out of bounds exception");
		TreeSet<Point> t = new TreeSet<Point>();
		int who = 0;
		int winner = -1;
		all:
		for (int i = 0; i < n; ++i) {
			int x = nextInt();
			int y = nextInt();
			myAssert(-MAX <= x && x <= MAX, "x out of bounds exception");
			myAssert(-MAX <= y && y <= MAX, "y out of bounds exception");
			Point c = new Point(x, y, who);
			Point nc = new Point(c.x, c.y, 1 ^ who);
			if (t.contains(c) || t.contains(nc)) {
				winner = -2;
				break;
			}
			t.add(c);
			int mk = 0;
			for (int j = 0; j < 3; ++j) {
				int tk = -1;
				for (int s = -1; s <= 1; s += 2) {
					Point p = c;
					while (t.contains(p)) {
						p = p.add(s * dx[j], s * dy[j]);
						++tk;
					}
				}
				if (tk >= 5) {
					if (i == n - 1) {
						winner = who;
					} else {
						winner = -2;
					}
					break all;
				}
			}
			who ^= 1;
		}
		
		switch (winner) {
		case -2:
			out.println("Inconsistent");
			break;
		case -1:
			out.println("Draw");
			break;
		case 0:
			out.println("First player won");
			break;
		case 1:
			out.println("Second player won");
			break;
		default:
			break;
		}
		
		
	}
	
	final int MAX = (int)(1e+9);
	final int MAXN = 10000;
	
	class Point implements Comparable<Point> {
		int x, y, t;
		
		public Point(int x, int y, int t) {
			this.x = x;
			this.y = y;
			this.t = t;
		}
		
		public Point add(int dx, int dy) {
			return new Point(x + dx, y + dy, t);
		}
		
		@Override
		public String toString() {
			return x + " " + y + " " + t;
		}
		
		@Override
		public boolean equals(Object o) {
			return (o instanceof Point) && this.compareTo((Point) o) == 0;
		}

		@Override
		public int compareTo(Point o) {
			return x < o.x ? -1 : x > o.x ? 1 : y < o.y ? -1 : y > o.y ? 1 : t < o.t ? -1 : t > o.t ? 1 : 0; 
		}
	}
}
