//  "Garland"
// 6  -
//  :  , ulyantsev@rain.ifmo.ru
//  :  , nosenkomax@gmail.com

import java.util.*;
import java.io.*;

public class garland_mn implements Runnable {

	public static void main(String args[]) {
		new Thread(new garland_mn()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	private String FNAME = "garland";
	boolean eof = false;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			br.close();
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}
	
	int dist[][];
	int d[][];
	int m;

	private void solve() {
		int n = nextInt();
		m = nextInt();
		My_Assert(1 <= n && n <= 1000, "n is out of range: " + n);
		My_Assert(1 <= m && m <= 15, "m is out of range: " + m);
		
		char[][] c = new char[m][];
		for (int i = 0; i < m; i++) {
			c[i] = nextToken().toCharArray();
			My_Assert(c[i].length == n, "Length of " + i + "string is not n " + n + " " + c[i].length);
		}
		nextToken();		
		My_Assert(eof, "Something is excess");
		
		dist = new int[m][m];
		int di[] = new int[m];
		for (int i = 0; i < m; i++) {
			di[i] = 0;
			for (int j = 0; j < n; j++)
				if (c[i][j] == '1')
					di[i]++;
		}
		
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < m; j++) {
				dist[i][j] = 0;
				for (int k = 0; k < n; k++) {
					if (c[i][k] != c[j][k])
						dist[i][j]++;
				}
				My_Assert(dist[i][j] > 0 || i == j, "Strings " + i +" and " + j + " are equal");
			}
		}
		
		d = new int[m][1 << m];
		for (int i = 0; i < d.length; i++) {
			Arrays.fill(d[i], -1);
		}
		int min = Integer.MAX_VALUE;
		for (int j = 0; j < m; j++) {
			calc(j, (1 << m) - 1);
			min = Math.min(min, di[j] + d[j][(1 << m) - 1]);
		}	
		
		out.println(min);
	}

	private void calc(int v, int mask) {
		
		if (d[v][mask] != -1)
			return;
		int tm = mask - (1 << v);
		if (tm == 0) {
			d[v][mask] = 0;
			return;
		}
		int min = Integer.MAX_VALUE / 10;
		for (int u = 0; u < m; u++)
			if ((tm & (1 << u)) != 0) {
				if (d[u][tm] == -1)
					calc(u, tm);
				min = Math.min(min, dist[v][u] + d[u][tm]);
			}
		d[v][mask] = min;
	}
}