//  ""
// 6-  -  2008-2009
//  :   , ulyantsev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//  ---    
//   --- O(2^m * m^2)

uses
	math, sysutils;
type
	int = longint;
const
	inf = 100000000;
	maxn = 1000;
	maxm = 15;
var
	n, m : int;
	s : array [0..maxm] of string;

	dist : array [0..maxm, 0..maxm] of int;
	price : array [1..1 shl (maxm + 1), 0..maxm] of int;
	i, j, k : int;

	ans : int;

//      
procedure assertions();
begin
	assert((1 <= n) and (n <= maxn));
	assert((1 <= m) and (m <= maxm));
	for i := 1 to m do begin
		assert(length(s[i]) = n);
		for j := 1 to n do
			assert((s[i][j] = '0') or (s[i][j] = '1'));
	end;
end;

begin
	reset(input, 'garland.in');
	rewrite(output, 'garland.out');
	
	readln(n, m);
	
	//  
	for i := 1 to n do
		s[0] := s[0] + '0';
	
	for i := 1 to m do
		readln(s[i]);

	assertions();

	// dist[i][j] ---      
	for i := 0 to m do
		for j := 0 to m do	
			for k := 1 to n do
				if (s[i][k] <> s[j][k]) then
					inc(dist[i][j]);
	
	// price[i][j] ---    ,     i,
	//  ,       j
	for i := 1 to (1 shl (m + 1) - 1) do
		for j := 0 to m do 
			price[i][j] := inf;
	
	//       
	price[1][0] := 0;

	//        
	for i := 2 to (1 shl (m + 1) - 1) do
		for j := 1 to m do
			if ((i and 1 = 1) and (i and (1 shl j) > 0)) then
				for k := 0 to m do
					price[i][j] := min(price[i][j], price[i - 1 shl j][k] + dist[j][k]);
	
	//         m
	ans := inf;
	for i := 1 to m do
		ans := min(ans, price[1 shl (m + 1) - 1][i]);
	writeln(ans);
end.
