//  "Perm"
// 6  -
//  :  , ulyantsev@rain.ifmo.ru
//  :  , nosenkomax@gmail.com
//   -    .  N = 100, C = 10.

import java.util.*;
import java.io.*;

public class perm_mn_wrong1 implements Runnable {

	public static void main(String args[]) {
		new Thread(new perm_mn_wrong1()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	private String FNAME = "perm";
	boolean eof = false;

//	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			br.close();
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}

	boolean good(char[] c) {
		if (c[0] != '1')
			return false;
		for (int i = 1; i < c.length; i++)
			if (c[i] != '0')
				return false;
		return true;                                
	}

	private void solve() {
		char[] a, b;
		a = nextToken().toCharArray();
		b = nextToken().toCharArray();
		My_Assert(a[0] != '0' || a.length == 1, "Extra zeros in first number");
		My_Assert(b[0] != '0' || b.length == 1, "Extra zeros in second number");

		My_Assert(a.length <= 100000 || a.length == 100001 && good(a) , "First number too big");
		My_Assert(b.length <= 100000 || b.length == 100001 && good(b), "Second number too big");

		int num[] = new int[10];
		for (int i = 0; i < a.length; i++) {
			num[a[i] - '0']++;
		}
		if (a.length < b.length) {
			for (int i = 9; i >= 0; i--)
				for (int j = 0; j < num[i]; j++)
					out.print(i);
			out.println();
			return;
		}
		if (b.length < a.length) {
			if (num[0] < a.length - b.length) {
				out.println(-1);
				return;
			}
			num[0] -= (a.length - b.length);
		}

		char c[] = new char[b.length];

		int t = -1;
		for (int i = 0; i < b.length; i++) {
			if (num[b[i] - '0'] > 0) {
				num[b[i] - '0']--;
				c[i] = b[i];
			} else {
				t = i;
				break;
			}
		}

		if (t == -1) {
			t = b.length - 1;
			num[b[t] - '0']++;
		}

		boolean good = false;
		boolean need = false;
		while (t >= 0 && !good) {
			if (need)
				num[b[t] - '0']++;
			else
				need = true;
			for (int i = b[t] - '1'; i >= 0; i--)
				if (num[i] > 0) {
					c[t] = (char) (i + '0');
					num[i]--;
					good = true;
					break;
				}
			if (!good)
				t--;
		}
		if (!good) {
			out.println(-1);
			return;
		}

		t++;
		for (int i = 9; i >= 0; i--)
			for (int j = 0; j < num[i]; j++) {
				c[t] = (char) (i + '0');
				t++;
			}

//		t = 0;
//		while (c[t] == '0')
//			t++;

		for (int i = t; i < c.length; i++) {
			out.print(c[i]);
		}
		out.println();

	}
}