import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class prizes_as implements Runnable {

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("prizes.in"));
        PrintWriter out = new PrintWriter(new File("prizes.out"));

        int n = in.nextInt();
        int m = in.nextInt();
        BigInteger[] a = new BigInteger[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextBigInteger();
            assert a[i].compareTo(BigInteger.valueOf(1000000000)) <= 0;
        }
        Arrays.sort(a);

        ArrayList<BigInteger> ans = new ArrayList<BigInteger>();
        BigInteger cur = BigInteger.ONE;
        int j = 0;
        for (int i = 0; i < m; i++) {
            while (j < n && a[j].compareTo(cur) <= 0) {
                cur = cur.add(a[j]);
                j++;
            }
            ans.add(cur);
            cur = cur.add(cur);
        }

        for (BigInteger v : ans) {
            out.print(v + " ");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new prizes_as()).start();
    }
}
