#include <iostream>  
#include <cstdio>  
#include <cctype>  
#include <string>  
#include <cmath>  
#include <vector>  
#include <algorithm>  
#include <stack>  
#include <queue>  
#include <map>  
#include <set>  
#include <sstream>  
#include <fstream>  
#include <ctime>  
#include <cassert>  
#include <string.h>  
using namespace std;  
#define GI ({int t;scanf("%d",&t);t;})  
#define GL ({LL t;scanf("%lld",&t);t;})  
#define GD ({double t;scanf("%lf",&t);t;})  
#define FOR(i,a,b) for(int i=a;i<b;i++)  
#define REP(i,n) FOR(i,0,n)  
#define ROF(i,a,b) for(int i=a;i>b;i--)  
#define SET(x,a) memset(x,a,sizeof(x))  
#define all(a) a.begin(),a.end()  
#define rall(a) a.rbegin(),a.rend()  
#define tr(i,a) for(__typeof(a.begin()) i=a.begin();i!=a.end();i++)  
#define pb push_back  
#define sz(a) (int)(a.size())  
#define INF (int)1e9  
#define EPS (double)1e-9  
#define is istringstream  
#define os ostringstream  
#define lb lower_bound  
#define ub upper_bound  
#define bs binary_search  
typedef unsigned long long ULL;  
typedef unsigned int UI;  
typedef long long LL;  
typedef set <int> si;  
typedef pair< int,int > ii;  
typedef pair< int, ii > pi;  
typedef vector< pi > vpi;  
typedef vector< ii > vii;  
typedef vector < vii > vvii;  
typedef vector< int > vi;  
typedef vector< vi > vvi;  
  
#define MAXN 1000+5  
#define MOD 1000000007  
  
LL dp[MAXN][MAXN];  
  
inline LL go(int n,int k){  
    if(k>=MAXN||n<0)  return 0;  
    if(!n)  return 1;  
    LL &ret=dp[n][k];  
    if(ret!=-1) return ret;  
    ret=0;  
    (ret+=go(n-k,k))%=MOD;  
    (ret+=go(n,k+1))%=MOD;  
    return ret;  
}  
  
int main(){  
    SET(dp,-1);  
    FOR(n,1,MAXN)   FOR(k,1,MAXN)   dp[n][k]=go(n,k);  
    int t=GI;  
    assert(t>=1 && t<=1000000);  
    while(t--){  
        int n=GI,k=GI;  
        assert(n>=1 && n<=1000 && k>=1 && k<=1000);  
        printf("%lld\n",dp[n][k]);  
        assert(dp[n][k]>=0 && dp[n][k]<MOD);  
    }  
    return 0;  
}  
