#include <cstring>  
#include <cstdio>  
#include <iostream>  
#include <vector>  
#include <map>  
#include <set>  
#include <algorithm>  
#define sz size()  
#define pb push_back  
#define _(x,a) memset(x,a,sizeof(x))  
#define LET(x,a) __typeof(a) x(a)  
#define FOR(i,a,b) for(LET(i,a);i!=(b);++i)  
#define REP(i,n) FOR(i,0,n)  
#define EACH(i,v) FOR(i,(v).begin(),(v).end())  
#define LL long long  
#define GI ({int t;scanf("%d",&t);t;})  
#define GL ({LL t;scanf("%lld",&t);t;})  
#define GD ({double t;scanf("%lf",&t);t;})  
#define maxl 1000010  
#define MOD 1000000007  
#define ff first  
#define ss second  
  
using namespace std;  
  
typedef pair<LL,int> node;  
char str[maxl];  
LL fact[maxl], invfact[maxl];  
int pos;  
  
LL exppmy(LL a, LL p) {  
    if(p==0) return 1LL;  
    if(p==1) return a;  
    LL ret = exppmy(a,p>>1);  
    (ret *= ret);  
    ret %= MOD;  
    if(p&1) { ret *= a; ret%=MOD; }  
    return ret;  
}  
  
LL ncr(int n, int r) {  
    if(r>n||r<0) return 0;  
    LL ret = (fact[n]*invfact[r])%MOD;  
    (ret *= invfact[n-r])%=MOD;  
    return ret;  
}  
  
node dfs() {  
    int h  = pos;  
    char now = str[pos++];  
    node ret(1,1);  
    if(now=='0') { return ret;}  
    if(now=='1') {  
        node left = dfs(), right = dfs();  
        ret = make_pair((left.ff*right.ff)%MOD,left.ss+right.ss);  
    } else if(now=='2') {  
        node left = dfs(), right = dfs();  
        LL ways = (left.ff*right.ff)%MOD;  
        (ways *= ncr(left.ss+right.ss,left.ss))%=MOD;  
        ret = make_pair(ways,left.ss+right.ss);  
    }  
    return ret;  
}  
  
int main (int argc, char const* argv[]) {  
      
    fact[0] = 1;  
    FOR(i,1,maxl) fact[i] = (fact[i-1]*i)%MOD;  
    invfact[maxl-1] = exppmy(fact[maxl-1],MOD-2);  
    for(int i=maxl-2;i>=0;i--) invfact[i] = (invfact[i+1]*(i+1))%MOD;  
    int t = GI;  
    while(t--) {  
        scanf("%s",str);  
        pos = 0;  
        printf("%lld\n",dfs().ff);  
    }  
      
    return 0;  
}  
