#include <iostream>  
#include <cstdio>  
#include <cctype>  
#include <string>  
#include <cmath>  
#include <vector>  
#include <algorithm>  
#include <stack>  
#include <queue>  
#include <map>  
#include <set>  
#include <sstream>  
#include <fstream>  
#include <ctime>  
#include <cassert>  
#include <string.h>  
using namespace std;  
#define GI ({int t;scanf("%d",&t);t;})  
#define GL ({LL t;scanf("%lld",&t);t;})  
#define GD ({double t;scanf("%lf",&t);t;})  
#define FOR(i,a,b) for(int i=a;i<b;i++)  
#define REP(i,n) FOR(i,0,n)  
#define ROF(i,a,b) for(int i=a;i>b;i--)  
#define SET(x,a) memset(x,a,sizeof(x))  
#define all(a) a.begin(),a.end()  
#define rall(a) a.rbegin(),a.rend()  
#define tr(i,a) for(__typeof(a.begin()) i=a.begin();i!=a.end();i++)  
#define pb push_back  
#define sz(a) (int)(a.size())  
#define INF 1000000000000000LL  
#define EPS (double)1e-9  
#define is istringstream  
#define os ostringstream  
#define lb lower_bound  
#define ub upper_bound  
#define bs binary_search  
typedef unsigned long long ULL;  
typedef unsigned int UI;  
typedef long long LL;  
typedef set <int> si;  
typedef pair< int,int > ii;  
typedef pair< int, ii > pi;  
typedef vector< pi > vpi;  
typedef vector< ii > vii;  
typedef vector < vii > vvii;  
typedef vector< int > vi;  
typedef vector< vi > vvi;  
  
#define MAXN 1000+5  
#define MAXM 1000000+5  
  
struct edge{int u,v,w;};  
  
inline bool cmp(const edge &A,const edge &B){  
    return A.w<B.w;    
}  
  
edge E[MAXM];  
  
int n,m;  
int p[MAXN];  
  
inline int find_set(int x){  
    if(x==p[x]) return p[x];  
    return p[x]=find_set(p[x]);  
}  
  
inline void union_set(int u,int v){  
    u=find_set(u),v=find_set(v);  
    p[u]=v;  
}  
  
int main(){  
    int t=GI;  
    assert(t>=1 && t<=100);  
    while(t--){  
        n=GI,m=GI;  
        assert(n>=1 && n<=1000);  
        assert(m>=0 && m<=1000000);  
        LL ans=0;  
        REP(i,m){  
            int u=GI,v=GI,d=GI,r=GI;  
            assert(u>=1 && u<=n && v>=1 && v<=n);  
            assert(d>=1 && d<=1000000 && r>=1 && r<=1000000);  
            E[i].u=u-1,E[i].v=v-1,E[i].w=r-d;  
            ans+=d;  
        }  
        sort(E,E+m,cmp);  
        REP(i,n)    p[i]=i;  
        REP(i,m){  
            int u=E[i].u,v=E[i].v,w=E[i].w;  
            if(w<=0||find_set(u)!=find_set(v))   ans+=w,union_set(u,v);  
        }  
        printf("%lld\n",ans);  
    }  
    return 0;  
}  
