#include <vector>  
#include <list>  
#include <map>  
#include <set>  
#include <queue>  
#include <deque>  
#include <stack>  
#include <bitset>  
#include <algorithm>  
#include <functional>  
#include <numeric>  
#include <utility>  
#include <sstream>  
#include <iostream>  
#include <iomanip>  
#include <cstdio>  
#include <cmath>  
#include <cstdlib>  
#include <ctime>  
#include <fstream>  
#include <cstring>  
using namespace std;  
  
typedef long long ll;  
typedef vector<int> vi;  
typedef pair<int, int> ii;  
typedef vector<ii> vii;  
typedef set<int> si;  
typedef map<string, int> msi;  
  
#define FOR(i, a, b) for (int i = a; i < b; i++)   
#define REP(i, n) FOR(i,0,n)  
#define GI ({int t;scanf("%d",&t);t;})  
#define GL ({LL t;scanf("%lld",&t);t;})  
#define GD ({double t;scanf("%lf",&t);t;})  
#define TRvi(c, it) for (vi::iterator it = (c).begin(); it != (c).end(); it++)  
#define TRvii(c, it) for (vii::iterator it = (c).begin(); it != (c).end(); it++)  
#define TRmsi(c, it) for (msi::iterator it = (c).begin(); it != (c).end(); it++)  
#define flush(x) memset(x,0,sizeof(x))  
#define MAXN 200000  
#define INF 1<<25  
#define MOD 1000000007  
  
int dp[MAXN];//0-invalid 1-win 2-true 3-tie  
  
int pwr(int a, int b)  
{  
    if(b==0) return 1;  
    if(b==1) return a;  
    int res=pwr(a,b/2);  
    if(b%2==1) return res*res*a;  
    return res*res;  
}  
  
bool wincheck(int x)  
{  
    int mat[3][3];  
    REP(i,3) REP(j,3) {mat[i][j]=x%3;x/=3;}  
    REP(i,3) if(mat[i][0]==mat[i][1] && mat[i][0]==mat[i][2] && mat[i][0]!=0) return true;  
    REP(j,3) if(mat[0][j]==mat[1][j] && mat[0][j]==mat[2][j] && mat[0][j]!=0) return true;    
    if(mat[0][0]==mat[1][1] && mat[1][1]==mat[2][2] && mat[0][0]!=0) return true;  
    if(mat[0][2]==mat[1][1] && mat[1][1]==mat[2][0] && mat[0][2]!=0) return true;  
    return false;  
}  
  
int go(int state, int p)  
{  
    if(dp[state]) return dp[state];  
    if(wincheck(state)) return dp[state]=2;  
    bool allwin=true, onelose=false, entered=false;  
    REP(i,9)  
    {  
        if(state/pwr(3,i)%3==0)  
        {  
            entered=true;  
            state+=pwr(3,i)*(p+1);  
            int res=go(state,p?0:1);  
            if(res!=1) allwin=false;  
            if(res==2) onelose=true;  
            state-=pwr(3,i)*(p+1);  
        }  
    }  
    if(onelose) return dp[state]=1;  
    if(allwin&&entered) return dp[state]=2;  
    return dp[state]=3;  
}  
  
int main()  
{  
    int t;  
    t = GI;  
    flush(dp);  
    go(0,0);  
    while(t--)  
    {  
        string s="";  
        char a[4];  
        REP(i,3){ scanf("%s",&a);s+=a;}  
        int state=0;  
        for(int i=8;i>=0;i--)  
        state=state*3+(s[i]=='x'?1:(s[i]=='o'?2:0));  
        switch(dp[state])  
        {  
            case 0: printf("invalid\n");break;  
            case 1: printf("win\n");break;  
            case 2: printf("lose\n");break;  
            case 3: printf("tie\n");break;            
        }  
    }  
}  
