#include<iostream>  
#include<cstdio>  
#include<algorithm>  
#include<vector>  
#include<stack>  
#include<set>  
using namespace std;  
  
#define MAXN 1000005  
  
vector<pair<int,int> > type[MAXN];  
  
struct node  
{  
    set<int> vc;  
    set<int> ts;  
};  
  
set<int> join(set<int> a,set<int> b)  
{  
    for(set<int>::iterator it=a.begin();it!=a.end();it++) b.insert(*it);  
    return b;  
}  
  
node func(int k)  
{  
    node ans;  
    ans.ts.insert(k);  
    for(int i=type[k].size()-1;i>=0;i--)  
    {  
        node temp=func(type[k][i].first);  
        if(type[k][i].second==1)  
        {  
            //pendant  
            set<int> temp1,temp2;  
            temp1=join(ans.vc,temp.ts);  
            temp2=join(ans.ts,temp.vc);  
            ans.ts=join(ans.ts,temp.vc);  
            if(temp1.size()==temp2.size())  
            {  
                if(temp1.find(k)!=temp1.end())  
                    ans.vc=temp1;  
                else  
                    ans.vc=temp2;  
            }  
            else if(temp1.size()<temp2.size())  
                ans.vc=temp1;  
            else  
                ans.vc=temp2;             
        }  
        else if(type[k][i].second==2)  
        {  
            //false  
            ans.ts=join(ans.ts,temp.ts);  
            ans.vc=join(ans.vc,temp.vc);  
        }  
        else if(type[k][i].second==3)  
        {  
            //true  
            set<int> temp1,temp2;  
            temp1=join(ans.vc,temp.ts);  
            temp2=join(ans.ts,temp.vc);  
            ans.ts=join(ans.ts,temp.ts);  
            if(temp1.size()==temp2.size())  
            {  
                if(temp1.find(k)!=temp1.end())  
                    ans.vc=temp1;  
                else  
                    ans.vc=temp2;  
            }  
            else if(temp1.size()<temp2.size())  
                ans.vc=temp1;  
            else  
                ans.vc=temp2;  
        }  
    }  
    return ans;  
}  
  
int main()  
{  
    int t,n,op,v;  
    scanf("%d",&t);  
    while(t--)  
    {  
        scanf("%d",&n);  
        for(int i=0;i<=MAXN;i++)  
            type[i].clear();  
        for(int i=0;i<n-1;i++)  
        {  
//          type[i].clear();  
            scanf("%d %d",&op,&v);  
            type[v-1].push_back(make_pair(i+1,op));  
        }  
        node ans=func(0);  
        printf("%d\n",ans.vc.size());  
    }  
    return 0;  
}  
