#include <stdio.h>
#include <string.h>

#define NMAX 53
#define SMAX 53

long long nsets[2][NMAX][NMAX][SMAX];
int a[NMAX];
int N, i, j, jj, k, kk, p, q, r, idx, pidx, sum;
double answer, tmp;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%d", &a[i]);
	scanf("%d", &p);

	memset(nsets, 0, sizeof(nsets));

	nsets[0][0][0][0] = 1;
	sum = 0;

	for (i = 1; i <= N; i++) {
		sum += a[i];
		for (k = 0; k <= N; k++)
			for (j = 0; j <= p; j++) {
				nsets[0][i][k][j] += nsets[0][i - 1][k][j];
				if (j + a[i] <= p)
					nsets[0][i][k + 1][j + a[i]] += nsets[0][i - 1][k][j];
			}
	}

	nsets[1][N + 1][0][0] = 1;
	for (i = N; i >= 1; i--) {
		for (k = 0; k <= N; k++)
			for (j = 0; j <= p; j++) {
				nsets[1][i][k][j] += nsets[1][i + 1][k][j];
				if (j + a[i] <= p)
					nsets[1][i][k + 1][j + a[i]] += nsets[1][i + 1][k][j];
			}
	}
	
	if (sum <= p)
		answer = N;
	else {
		answer = 0.0;
		for (i = 1; i <= N; i++) {
			for (k = 0; k < i; k++)
				for (j = 0; j <= p; j++)
					if (nsets[0][i - 1][k][j] > 0) {
						// Let i be the last person to fill in a table of length exactly p.
						if (j + a[i] <= p) {
							for (kk = 0; kk + k < N; kk++)
								if (nsets[1][i + 1][kk][p - j - a[i]] > 0) {
									tmp = nsets[0][i - 1][k][j] * nsets[1][i + 1][kk][p - j - a[i]] * (k + kk + 1);
									for (r = k + kk + 1, q = 1; r <= N || q <= N - k - kk - 1; r++, q++) {
										if (q <= N - k - kk - 1)
											tmp *= q;
										if (r <= N)
											tmp /= r;
									}
									//fprintf(stderr, "sum=p: i=%d k=%d j=%d kk=%d jj=%d nsets1=%I64d nsets2=%I64d tmp=%.9lf\n", i, k, j, kk, p - j - a[i], nsets[0][i - 1][k][j], nsets[1][i + 1][kk][p - j - a[i]], tmp);
									answer += tmp;
								}
						}

						// Let i be the last person whose size exceeds the length of the table.
						for (kk = 0; kk + k < N; kk++)
							for (jj = 0; jj + j < p; jj++)
								if (nsets[1][i + 1][kk][jj] > 0 && j + jj + a[i] > p) {
									tmp = nsets[0][i - 1][k][j] * nsets[1][i + 1][kk][jj] * (k + kk);
									for (r = k + kk + 1, q = 1; r <= N || q <= N - k - kk - 1; r++, q++) {
										if (q <= N - k - kk - 1)
											tmp *= q;
										if (r <= N)
											tmp /= r;
									}
									//fprintf(stderr, "sum>p: i=%d k=%d j=%d kk=%d jj=%d nsets1=%I64d nsets2=%I64d tmp=%.9lf\n", i, k, j, kk, jj, nsets[0][i - 1][k][j], nsets[1][i + 1][kk][p - j], tmp);
									answer += tmp;
								}
					}
		}
	}
	
	printf("%.9lf\n", answer);	
	return 0;
}
