#include <stdio.h>
#include <string.h>

#define BMAX 60

long long bit[BMAX], cnt[BMAX][BMAX], totalcnt[BMAX];
long long N, T, M, answer;
int i, j, bt, bitinc;

int main() {
	scanf("%I64d %I64d", &N, &T);

	bit[0] = 1;
	for (i = 1; i < BMAX; i++)
		bit[i] = bit[i - 1] * 2;
	
	bt = -1;
	for (i = 0; i < BMAX; i++)
		if (T == bit[i]) {
			bt = i;
			break;
		}
	
	if (bt < 0) {
		printf("0\n");
		return 0;
	}

	N++;
	
	memset(cnt, 0, sizeof(cnt));
	cnt[0][0] = 1;
	M = 1;
	
	memset(totalcnt, 0, sizeof(totalcnt));
	totalcnt[0] = 1;
	
	for (i = 1; i < BMAX; i++) {
		if (M + bit[i] > N)
			break;
		M += bit[i];
		
		cnt[i][0] = 1;
		for (j = 1; j <= i; j++)
			cnt[i][j] = cnt[i - 1][j - 1] + cnt[i - 1][j];
		
		for (j = 0; j <= i; j++)
			totalcnt[j] += cnt[i][j];
	}

	answer += totalcnt[bt];
	N -= M;
	i--;
	bitinc = 0;
	
	while (N > 0) {
		if (N >= bit[i]) {
			if (bt - bitinc >= 0)
				answer += cnt[i][bt - bitinc];
			N -= bit[i];
			bitinc++;
		} else {
			i--;
		}
	}

	if (bt == 0)
		answer--;

	printf("%I64d\n", answer);
	return 0;
}
