#include <stdio.h>
#include <vector>
#include <map>

using namespace std;

#define NMAX 200100
#define INF 1000000000

#define vec(i, j) (f[i][j].first)
#define ff(i, j) (f[i][j].second.first)
//#define flow(i, j) (f[i][vidx[i][j]].second.first)
#define cap(i, j) (f[i][j].second.second)

vector<pair<int, pair<int, int> > > f[NMAX];
vector<pair<int, int> > edges, ei, ej;
int visited[NMAX], visited_idx, q[NMAX], li, ls, parent[NMAX], pp[NMAX], tip[NMAX];
//map<int, int> vidx[NMAX];
int N, M, i, j, k, c, finc;

void IncFlow() {
	c = INF;
	i = N;
	while (i != 1 && c > 0) {
		if (tip[i] == 1) {
			j = /*vidx[parent[i]][i]*/ pp[i];
			if (cap(parent[i], j) - ff(parent[i], j) < c)
				c = cap(parent[i], j) - ff(parent[i], j);
		} else {
			//j = vidx[i][parent[i]];
			//if (ff(i, j) < c)
			//	c == ff(i, j);
		}
		i = parent[i];
	}
	
	if (c == 0)
		return;
	
	i = N;
	while (i != 1) {
		if (tip[i] == 1) {
			//flow(parent[i], i) += c;
			ff(parent[i], pp[i]) += c;
			//fprintf(stderr, "inc flow (c=%d): %d->%d\n", c, parent[i], i);
		} else {
			//flow(i, parent[i]) -= c;
			//fprintf(stderr, "dec flow (c=%d): %d->%d\n", c, i, parent[i]);
		}
		i = parent[i];
	}

	finc = 1;
}

int main() {
	//freopen("x.txt", "r", stdin);
	// Read the input.
	scanf("%d %d", &N, &M);
	for (k = 1; k <= M; k++) {
		scanf("%d %d %d", &i, &j, &c);
		f[i].push_back(make_pair(j, make_pair(0, c)));
		f[j].push_back(make_pair(i, make_pair(0, c)));
		//vidx[i][j] = f[i].size() - 1;
		//vidx[j][i] = f[j].size() - 1;
		edges.push_back(make_pair(i, j));
		ei.push_back(make_pair(i, f[i].size() - 1));
		ej.push_back(make_pair(j, f[j].size() - 1));
	}

	// Max flow.
	visited_idx = 0;
	
	while (1) {
		visited_idx++;
		q[li = ls = 0] = 1;
		visited[1] = visited_idx;
		
		//fprintf(stderr, "new iter\n");
		finc = 0;
		while (li <= ls /*&& visited[N] != visited_idx*/) {
			i = q[li];
			//fprintf(stderr, "li=%d i=%d\n", li, i);
			li++;
			for (k = 0; k < f[i].size(); k++) {
				j = vec(i, k);
				if (visited[j] == visited_idx)
					continue;

				//c = flow(j, i);
				c = 0;
				if (c == 0 && ff(i, k) < cap(i, k)) {
					parent[j] = i;
					tip[j] = 1;
					pp[j] = k;
					
					if (j == N) {
						IncFlow();
						continue;
					}

					visited[j] = visited_idx;
					ls++;
					q[ls] = j;
				} else if (c > 0) {
					parent[j] = i;
					tip[j] = 2;

					if (j == N) {
						IncFlow();
						continue;
					}

					visited[j] = visited_idx;
					ls++;
					q[ls] = j;
				}
			}	
		}

		//if (visited[N] != visited_idx)
		if (!finc)
			break;
	}

	// Write the output.
	for (k = 0; k < edges.size(); k++) {
		i = edges[k].first; j = edges[k].second;
		//c = vidx[i][j];
		if (ff(i, ei[k].second) > 0)
			printf("0\n");
		else
			printf("1\n");
	}
	
	return 0;
}
