#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <queue>
#include <memory.h>
#include <stack>
#define mp make_pair
#define pb push_back                     
#define setval(a,v) memset(a,v,sizeof(a))

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
  #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
  #endif
    ll n;
    cin >> n;
    ll minv,maxv;
    minv = (1LL<<60LL);
    maxv = -minv;


    for (int i = 1; i*i <= n; i++){
        if (n % i != 0)
            continue;
        for (int I = 0; I < 2; I++){
            int a = i;
            if (I) a = n/i;
            int n1 = n / a;
            for (int j = 1; j*j <= n1; j++){
                if (n1 % j) continue;
                int b = j;
                int c = n1 / j;
                ll val = (a+1)*1LL*(b+2)*1LL*(c+2);
                minv = min(minv,val);
                maxv = max(maxv,val);
            }
        }
    }

    cout << minv - n <<" "<<maxv - n << endl;
  return 0;
}

----

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <queue>
#include <memory.h>
#include <stack>
#define mp make_pair
#define pb push_back                     
#define setval(a,v) memset(a,v,sizeof(a))

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

int color[1100][1100];

int cnt[2];
int n,m;

void dfs(int x,int y,int c){
    if (x < 0 || y < 0 || x >= n || y >= m)
        return;
    if (color[x][y] != -1){
        assert(color[x][y] == c);
        return;
    }
    color[x][y] = c;
    cnt[c]++;
    for (int i = -1; i <= 1; i+=2)
        for (int j = -1; j <= 1; j+=2){
            dfs(x+i,y+2*j,1-c);
            dfs(x+2*j,y+i,1-c);
        }
    return;
}

int main()
{
  #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
  #endif
    scanf("%d %d",&n,&m);
    memset(color,-1,sizeof(color));

    int ans = 0;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
           if (color[i][j] == -1){
              cnt[0] = cnt[1] = 0;
              dfs(i,j,0);
              ans += max(cnt[0],cnt[1]);
           } 

    cout << ans << endl;
  return 0;
}

----

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <queue>
#include <memory.h>
#include <stack>
#define mp make_pair
#define pb push_back                     
#define setval(a,v) memset(a,v,sizeof(a))

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

char s[10][10];
char bs[10][10];

int ans;

int start = clock();

const int dx[4][5] = {{0,1,2,1,1},{0,1,2,2,2},{1,1,0,1,2},{0,0,1,2,0}};
const int dy[4][5] = {{0,0,0,1,2},{1,1,0,1,2},{0,1,2,2,2},{0,1,1,1,2}};
int n,m;

bool q,q1;

void dfs(int x,int y,int cur){
    if (cur == ans){
      memcpy(bs,s,sizeof(bs));
      q = q1 = true;
      return;
    }
    if (x >= n-2){
        if (clock() - start > 2.7*CLOCKS_PER_SEC)
           q = true, q1 = false; 
        return;
    }
    if (y >= m-2){
        dfs(x+1,0,cur);
        return;
    }
    if (((m-y+1)+(n-x)*m)/5 + cur <= ans)
        return;
    if ((m-y-1)+(n-x-2)*m+cur <= ans)
        return;
    for (int i = 0; i < 4; i++){
        bool ok = !q;
        for (int j = 0; j < 5; j++)
            ok &= s[x+dx[i][j]][y+dy[i][j]] == 0;
        if (ok){
            for (int j = 0; j < 5; j++)
                s[x+dx[i][j]][y+dy[i][j]] = 'A'+cur;
            dfs(x,y+1,cur+1);
            for (int j = 0; j < 5; j++)
                s[x+dx[i][j]][y+dy[i][j]] = 0;
        }
    }
    if (!q)
        dfs(x,y+1,cur);
}


int main()
{
  #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
  #endif

  scanf("%d %d",&n,&m);
  if (n > 2 && m > 2){
      for (ans = 0; ; ans++){
        cerr << ans << endl;
        q = q1= false;
        dfs(0,0,0);
        if (!q1){
            ans--;
            break;
        }
      }
  }
  printf("%d\n",ans);
  for (int i = 0; i < n; i++,printf("\n"))
    for (int j = 0; j < m; j++)
        if (bs[i][j] == 0)
            printf(".");
        else
            printf("%c",bs[i][j]); 
  return 0;
}

----

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <queue>
#include <memory.h>
#include <stack>
#define mp make_pair
#define pb push_back                     
#define setval(a,v) memset(a,v,sizeof(a))

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

typedef long long ll;
typedef long double ld;


int sum[100];
int n,m,k;

void add(int a){
   for (int i = 0; i < 10; i++)
        if (a & (1<<i))
            sum[i]++,sum[i] %= (k+1);

}

int main()
{
  #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
  #endif
    scanf("%d %d %d",&n,&m,&k);

    bool d1,d2;
    d1 = d2 = false;
    for (int i = 0; i < n; i++){
        int pos1,pos2;
        int cnt1,cnt2;
        cnt1 = cnt2 = 0;
        pos1 = pos2 = -1;
        for (int j = 0; j < m; j++){
            char c;
            scanf(" %c ",&c);
            if (c == 'G'){
               pos1 = j; 
               cnt1++;
            }
            else if (c == 'R'){
                pos2 = j;
                cnt2++;
            }
        }
       // cerr << pos1 <<" "<<pos2 << endl;
        if (pos1 == -1 && pos2 == -1)
            continue;
        if (pos1 == -1 && cnt2 != m)
            d2 = 1;
        else if (pos2 == -1 && cnt1 != m)
            d1 = 1;
        else {
            if (pos1 != -1 && pos2 != -1)
                add(abs(pos1-pos2)-1);
        }
    }


    if (d1 && !d2){
        printf("First\n");
        return 0;
    }

    if (d2 && !d1){
        printf("Second\n");
        return 0;
    }
    if (d1 && d2){
        printf("Draw\n");
        return 0;
    }


    for (int i = 0; i < 10; i++)
        if (sum[i]){
            printf("First\n");
            return 0;
        }
    printf("Second\n");
    return 0;
}
