#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

int a[100010];
ll dp[100010][5];

int c0[] = {0, 4, 4, 4, 4};
int c1[] = {2, 2, 2, -1, -1};
int c2[] = {1, 1, 3, 3, -1};

int main(void){
    int N,i,j;
    
    cin >> N; N--;
    REP(i,N) cin >> a[i];
    
    REP(i,N+1) REP(j,5) dp[i][j] = -1;
    dp[0][0] = 0;
    
    REP(i,N) REP(j,5) if(dp[i][j] != -1){
        // zero
        dp[i+1][c0[j]] = max(dp[i+1][c0[j]], dp[i][j]);
        
        // odd
        {
            ll x = a[i];
            if(x%2 != 1) x--;
            if(x > 0 && c1[j] != -1) dp[i+1][c1[j]] = max(dp[i+1][c1[j]], dp[i][j] + x);
        }
        
        // even
        {
            ll x = a[i];
            if(x%2 != 0) x--;
            if(x > 0 && c2[j] != -1) dp[i+1][c2[j]] = max(dp[i+1][c2[j]], dp[i][j] + x);
        }
    }
    
    ll ans = 0;
    REP(i,N+1) REP(j,5) ans = max(ans,dp[i][j]);
    cout << ans << endl;
    
    return 0;
}