#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

int Q;
int similarity[20];

int A,B;
string a[20],b[500010];
int first[20],next[20][500010];

int cost[(1<<15)][20];
int dp[(1<<15)][110];

int func(void){
    int i,j,mask;
    
    REP(i,A){
        int x = B;
        next[i][B] = B;
        for(j=B-1;j>=0;j--){
            next[i][j] = x;
            if(a[i] == b[j]) x = j;
        }
        first[i] = x;
    }
    
    int maxInv = A * (A-1) / 2;
    REP(mask,(1<<A)) REP(i,maxInv+1) dp[mask][i] = B;
    REP(i,A) dp[(1<<i)][0] = first[i];
    
    REP(mask,(1<<A)) REP(i,maxInv+1) if(dp[mask][i] < B){
        REP(j,A) if(!(mask&(1<<j))){
            int mask2 = (mask | (1<<j));
            int tmp = next[j][dp[mask][i]];
            int inv = i + cost[mask][j];
            if(tmp < dp[mask2][inv]) dp[mask2][inv] = tmp;
        }
    }
    
    int ans = -1;
    REP(i,maxInv+1) if(dp[(1<<A)-1][i] < B) ans = max(ans,maxInv-i+1);
    return ans;
}

int main(void){
    int i,j,mask;
    
    REP(mask,(1<<15)) REP(i,15) for(j=i;j<15;j++) if(mask&(1<<j)) cost[mask][i]++;
    
    cin >> A;
    REP(i,A) cin >> a[i];
    cin >> Q;
    REP(i,Q){
        cin >> B;
        REP(j,B) cin >> b[j];
        int ans = func();
        similarity[i] = ans;
    }
    
    int ans = -1;
    REP(i,Q) if(similarity[i] != -1 && (ans == -1 || similarity[i] > similarity[ans])) ans = i;
    
    if(ans == -1){
        cout << "Brand new problem!" << endl;
    } else {
        cout << ans + 1 << endl;
        string anss = "[:";
        REP(i,similarity[ans]) anss += "|";
        anss += ":]";
        cout << anss << endl;
    }
    
    return 0;
}