#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

#define INF (1<<29)

int X,Y;
string s[110];
int a[110][10010];

int main(void){
    int i,j,k;
    
    cin >> X >> Y;
    REP(i,X) cin >> s[i];
    
    REP(i,X) REP(j,Y) a[i][j] = INF;
    
    REP(i,X){
        int tmp = INF;
        
        REP(k,2) REP(j,Y){
            if(s[i][j] == '1') tmp = 0; else tmp++;
            a[i][j] = min(a[i][j],tmp);
        }
        
        REP(k,2) for(j=Y-1;j>=0;j--){
            if(s[i][j] == '1') tmp = 0; else tmp++;
            a[i][j] = min(a[i][j],tmp);
        }
    }
    
    int ans = INF;
    REP(i,Y){
        int tmp = 0;
        REP(j,X) tmp = min(tmp+a[j][i], INF);
        ans = min(ans,tmp);
    }
    
    if(ans == INF) ans = -1;
    cout << ans << endl;
    
    return 0;
}