#include <cstdio>
#include <cstring>
#include <iostream>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <deque>
#include <bitset>
#include <string>
#include <vector>
#include <sstream>
#define zero(a) (abs(a)<eps)
#define lowbit(a) ((a)&(-(a)))
#define abs(a) ((a)>0?(a):(-(a)))
#define dj(x1,y1,x2,y2) ((x1)*(x2)+(y1)*(y2))
#define cj(x1,y1,x2,y2) ((x1)*(y2)-(x2)*(y1))
#define dis(x1,y1,x2,y2) (((x2)-(x1))*((x2)-(x1))+((y2)-(y1))*((y2)-(y1)))
const double eps = 1e-9;
const double pi = acos(-1);
const int oo = 1000000000;
const int mod = 1000000009;
const double E = 2.7182818284590452353602874713527;
using namespace std;

int head[100001],next[200001],e[200001],du[100001],hash[100001],d[3][100001];
int totm=0;

void add(int a,int b)
{
   e[++totm]=b;
   next[totm]=head[a];
   head[a]=totm;
}

int main()
{
   int n,m,h,t,flag=0;
   cin>>n>>m>>h>>t;
   for (int i=1;i<=m;i++)
   {
      int a,b;
      scanf("%d%d",&a,&b);
      add(a,b);
      add(b,a);
      du[a]++;
      du[b]++;
   }
   for (int i=1;i<=n;i++)
      du[i]--;
   for (int i=1;i<=totm;i+=2)
   {
      int x=e[i],y=e[i+1];
      if (du[x]>du[y])
         swap(x,y);
      d[0][0]=d[1][0]=d[2][0]=0;
      flag++;
      if (min(du[x],du[y])>=min(h,t))
      {
         //int u,v;
         for (int j=head[x];j;j=next[j])
            if (e[j]!=y)
               hash[e[j]]=flag;
         for (int j=head[y];j;j=next[j])
            if (e[j]!=x&&hash[e[j]]==flag)
               d[2][++d[2][0]]=e[j];
         flag++;
         for (int j=1;j<=d[2][0];j++)
            hash[d[2][j]]=flag;
         if (max(min(h,t)-(du[x]-d[2][0]),0)+max(max(h,t)-(du[y]-d[2][0]),0)<=d[2][0])
         {
            for (int j=head[x];j&&d[0][0]<min(h,t);j=next[j])
               if (e[j]!=y&&hash[e[j]]!=flag)
                  d[0][++d[0][0]]=e[j];
            while (d[0][0]<min(h,t))
               d[0][++d[0][0]]=d[2][d[2][0]--];
            for (int j=head[y];j&&d[1][0]<max(h,t);j=next[j])
               if (e[j]!=x&&hash[e[j]]!=flag)
                  d[1][++d[1][0]]=e[j];
            while (d[1][0]<max(h,t))
               d[1][++d[1][0]]=d[2][d[2][0]--];
         }
         else
            continue;
         /*if (du[x]<=du[y]&&h<=t||du[x]>=du[y]&&h>=t)
         {
            u=x;
            v=y;
            if (du[x]<=du[y])
            {
               for (int j=head[x];d[0][0]<h;j=next[j])
                  if (e[j]!=y)
                  {
                     d[0][++d[0][0]]=e[j];
                     hash[e[j]]=flag;
                  }
               for (int j=head[y];j&&d[1][0]<t;j=next[j])
                  if (e[j]!=x&&hash[e[j]]!=flag)
                     d[1][++d[1][0]]=e[j];
            }
            else
            {
               for (int j=head[y];d[1][0]<t;j=next[j])
                  if (e[j]!=x)
                  {
                     d[1][++d[1][0]]=e[j];
                     hash[e[j]]=flag;
                  }
               for (int j=head[x];j&&d[0][0]<h;j=next[j])
                  if (e[j]!=y&&hash[e[j]]!=flag)
                     d[0][++d[0][0]]=e[j];
            }
         }
         else
         {
            u=y;
            v=x;
            if (du[x]<=du[y])
            {
               for (int j=head[x];d[1][0]<t;j=next[j])
                  if (e[j]!=y)
                  {
                     d[1][++d[1][0]]=e[j];
                     hash[e[j]]=flag;
                  }
               for (int j=head[y];j&&d[0][0]<h;j=next[j])
                  if (e[j]!=x&&hash[e[j]]!=flag)
                     d[0][++d[0][0]]=e[j];
            }
            else
            {
               for (int j=head[y];d[0][0]<h;j=next[j])
                  if (e[j]!=x)
                  {
                     d[0][++d[0][0]]=e[j];
                     hash[e[j]]=flag;
                  }
               for (int j=head[x];j&&d[1][0]<t;j=next[j])
                  if (e[j]!=y&&hash[e[j]]!=flag)
                     d[1][++d[1][0]]=e[j];
            }
         }*/
         puts("YES");
         if (d[0][0]==h&&d[1][0]==t)
         {
         cout<<x<<' '<<y<<endl;
         for (int j=1;j<=h;j++)
            printf("%d%c",d[0][j],(j==h)?'\n':' ');
         for (int j=1;j<=t;j++)
            printf("%d%c",d[1][j],(j==t)?'\n':' ');
         }
         else
         {
         cout<<y<<' '<<x<<endl;
         for (int j=1;j<=h;j++)
            printf("%d%c",d[1][j],(j==h)?'\n':' ');
         for (int j=1;j<=t;j++)
            printf("%d%c",d[0][j],(j==t)?'\n':' ');
         }
         goto end;
      }
   }
   puts("NO");
   end:
   return 0;
}