#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
using namespace std;
typedef long long ll;
typedef double du;
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define FOR(i, s, t) for(i = (s); i < (t); i++)
#define RFOR(i, s, t) for(i = (s)-1; i >= (t); i--)
const ll MOD = 10000000000LL;
const ll MOD1 = 120000000000LL;

ll mul(ll a, ll b){
    return (a*b - ((int)((du)a*b/MOD1) - 2) * MOD1) % MOD1;
}

//ll pow(int a, int k){
//    ll ret = 1;
//    while(k--)
//        ret = ret*a%MOD;
//    return ret;
//}
//
//struct Num{
//    int p2, p5, etc;
//    du v;
//    
//    Num(){}
//    Num(int v){
//        p2 = p5 = 0;
//        this->v = v;
//        while(v % 2 == 0){
//            p2++;
//            v /= 2;
//        }
//        while(v % 5 == 0){
//            p5++;
//            v /= 5;
//        }
//        etc = v % MOD;
//    }
//    
//    Num operator+(const Num& a){
//        Num ret;
//        ret.v = v + a.v;
//        
//    }
//}

ll s3(int n){
    return mul(n, mul(n, mul(n+1, n+1)))/4;
}

ll s2(int n){
    return mul(n, mul(n+1, 2*n+1))/6;
}

ll s1(int n){
    return mul(n, n+1)/2;
}

ll s0(int n){
    return n;
}

ll solve(int x1, int x2, int y1, int y2){
    if(x2 < x1 || y2 < y1)
        return 0;
    if(x1 == y1 && x2 == y2){
        return (2*(s3(x2) - s3(x1-1) - s2(x2) + s2(x1-1) + s1(x2) - s1(x1-1)) - mul(2*x1-1, s2(x2) - s2(x1-1) - s1(x2) + s1(x1-1) + s0(x2) - s0(x1-1))) % MOD;
    }
    if(x2 < y1){
        return (mul(x2-x1+1, s2(y2)-s2(y1-1)+s0(y2)-s0(y1-1)) - mul(y2-y1+1, s1(x2) - s1(x1-1))) % MOD;
    }
    if(y2 < x1){
        return (mul(y2-y1+1, s2(x2-1)-s2(x1-2)) + mul(x2-x1+1, s1(y2) - s1(y1-1))) % MOD;
    }
    int p1, p2;
    p1 = max(x1, y1);
    p2 = min(x2, y2);
    return (solve(x1, p1-1, y1, p1-1) + solve(x1, p1-1, p1, p2) + solve(x1, p1-1, p2+1, y2)
            + solve(p1, p2, y1, p1-1) + solve(p1, p2, p1, p2) + solve(p1, p2, p2+1, y2)
            + solve(p2+1, x2, y1, p1-1) + solve(p2+1, x2, p1, p2) + solve(p2+1, x2, p2+1, y2)) % MOD;
}

ll f(int x, int y){
    if(x < y)
        return (ll)y*y+1-x;
    return (ll)(x-1)*(x-1)+y;
}

ll solve1(int x1, int x2, int y1, int y2){
    ll ret = 0;
    int i, j;
    for(i = x1; i <= x2 && ret < MOD; i++)
        for(j = y1; j <= y2 && ret < MOD; j++)
            ret += f(i, j);
    if(ret < MOD)
        cout<<ret<<endl;
    else{
        ll t = (solve(x1, x2, y1, y2)%MOD + MOD) % MOD;
        printf("...%010I64d\n", t);
    }
}

int main()
{
    #ifdef __FIO
    freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    #endif
    int n;
    int x1, x2, y1, y2;
    scanf("%d", &n);
    while(n--){
        cin>>x1>>y1>>x2>>y2;
        solve1(y1, y2, x1, x2);
    }
    return 0;
}