#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define foreach(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;

ll func2(ll x, ll y, ll t){
    if(t >= x+y-2) return x * y;
    ll ans = (t+1) * (t+2) / 2;
    if(t >= x) ans -= (t-x+1) * (t-x+2) / 2;
    if(t >= y) ans -= (t-y+1) * (t-y+2) / 2;
    return ans;
}

ll func(ll N, ll x, ll y, ll t){
    ll ans = func2(x, y, t) + func2(x, N-y+1, t) + func2(N-x+1, y, t) + func2(N-x+1, N-y+1, t);
    ans -= 3;
    ans -= min(x-1, t);
    ans -= min(N-x, t);
    ans -= min(y-1, t);
    ans -= min(N-y, t);
    return ans;
}

int main(void){
    ll N,x,y,c;
    
    cin >> N >> x >> y >> c;
    
    if(1 >= c){
        cout << 0 << endl;
        return 0;
    }
    
    ll low = 0, high = (1ll<<33);
    while(high-low > 1){
        ll mid = (high + low) / 2;
        ll tmp = func(N, x, y, mid);
        if(tmp >= c) high = mid; else low = mid;
    }
    
    cout << high << endl;
    
    return 0;
}