#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define snuke(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

int N,K;
vector <vector <int> > v;
set <pair <int, int> > smallest[100010]; // (size K) number, pos
int bad[100010];
set <pair <int, int> > s; // bad, id

int ans[100010];

void update(int id){
    s.erase(make_pair(bad[id], id));
    bad[id]--;
    s.insert(make_pair(bad[id], id));
}

int main(void){
    int step,i,j;
    
    cin >> K >> N;
    v.resize(N);
    REP(i,K) REP(j,N){
        int x;
        scanf("%d", &x);
        v[j].push_back(x);
    }
    
    REP(i,N) REP(j,K) if(v[i][j] != -1) smallest[j].insert(make_pair(v[i][j], i));
    REP(j,K){
        int small = -1;
        if(!smallest[j].empty()) small = ((smallest[j].begin())->first);
        REP(i,N) if(v[i][j] != -1 && v[i][j] != small) bad[i]++;
    }
    REP(i,N) s.insert(make_pair(bad[i], i));
    
    REP(step,N){
        int x = (s.begin()->second);
        if(bad[x] != 0) break;
        ans[step] = x;
        s.erase(s.begin());
        
        // update smallest
        REP(i,K) if(v[x][i] != -1){
            if(smallest[i].erase(make_pair(v[x][i], x)));
            if(!smallest[i].empty()){
                int next = (smallest[i].begin()->first);
                if(next != v[x][i]){
                    snuke(smallest[i],itr){
                        int id = (itr->second);
                        int val = (itr->first);
                        if(val != next) break;
                        update(id);
                    }
                }
            }
        }
    }
    
    if(step != N){
        cout << -1 << endl;
        return 0;
    }
    
    REP(i,N){
        printf("%d", ans[i]+1);
        if(i == N-1) printf("\n"); else printf(" ");
    }
    
    return 0;
}