import java.util.*;
import java.math.*;

public class Main{

    static boolean graph[][] = new boolean[710][710];
    static BigInteger dp[][] = new BigInteger[710][3];
    
    public static void dfs(int N, int p, int x){ // System.out.println(N + " " + p + " " + x);
        int i,j;
        
        int c[] = new int[N+10];
        int sz = 0;
        
        for(i=0;i<N;i++) if(i != p && graph[x][i]){
            c[sz] = i; sz++;
            dfs(N,x,i);
        }
        
        for(i=0;i<3;i++) dp[x][i] = BigInteger.ONE;
        if(sz == 0) return;
        
    //  System.out.println(N + " " + p + " " + x);
        
        // type 0 and 2
        BigInteger a[][] = new BigInteger[2][sz+10]; // pos, dp1
        
        for(i=0;i<=sz;i++) a[0][i] = BigInteger.ZERO;
        a[0][0] = BigInteger.ONE;
        
        for(i=0;i<sz;i++){
            int prev = i % 2, cur = (i+1) % 2;
            for(j=0;j<=sz;j++) a[cur][j] = BigInteger.ZERO;
            
            for(j=0;j<=i;j++){
                BigInteger tmp = a[prev][j].multiply(dp[c[i]][0]);
                if(tmp.compareTo(a[cur][j]) > 0) a[cur][j] = tmp;
                tmp = a[prev][j].multiply(dp[c[i]][1]);
                if(tmp.compareTo(a[cur][j+1]) > 0) a[cur][j+1] = tmp;
            }
        }
        
        for(i=0;i<=sz;i++){
            BigInteger tmp = a[sz%2][i].multiply(BigInteger.valueOf(i+1));
            if(tmp.compareTo(dp[x][0]) > 0) dp[x][0] = tmp;
            tmp = a[sz%2][i].multiply(BigInteger.valueOf(i+2));
            if(tmp.compareTo(dp[x][2]) > 0) dp[x][2] = tmp;
        }
        
        // type 0
        for(i=0;i<sz;i++){
            BigInteger tmp = dp[c[i]][2];
            for(j=0;j<sz;j++) if(j != i) tmp = tmp.multiply(dp[c[j]][0]);
            if(tmp.compareTo(dp[x][0]) > 0) dp[x][0] = tmp;
        }
        
        // type 1
        for(i=0;i<sz;i++) dp[x][1] = dp[x][1].multiply(dp[c[i]][0]);
        
    //  System.out.println(x + " " + dp[x][0] + " " + dp[x][1] + " " + dp[x][2]);
    }

    public static void main(String args[]){
        int N,i,j,a,b;
        
        Scanner scan = new Scanner(System.in);
        N = scan.nextInt();
        
        for(i=0;i<N;i++) for(j=0;j<N;j++) graph[i][j] = false;
        for(i=0;i<N-1;i++){
            a = scan.nextInt(); b = scan.nextInt(); a--; b--;
            graph[a][b] = graph[b][a] = true;
        }
        
        dfs(N,-1,0);
        System.out.println(dp[0][0].toString());
    }

}