import java.util.*;
import java.math.*;
import static java.lang.Character.isDigit;
import static java.lang.Character.isLowerCase;
import static java.lang.Character.isUpperCase;
import static java.lang.Math.*;
import static java.math.BigInteger.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import static java.lang.Character.isDigit;

public class Main{
	static void debug(Object...os){
		System.err.println(deepToString(os));
	}
	
	void run(){
		n=nextInt();m=nextInt();a=nextInt();b=nextInt();c=nextInt();
		solve();
	}
	int n,m,a,b,c;
	boolean[][] black;
	
	int id,x,y;
	void inc() {
		id++;
		y++;
		if(y==m) {
			y=0;x++;
		}
	}
	
	void solve() {
		black=new boolean[n*m][4];
		for(int i=0;i<a;i++,inc()) for(int j=0;j<4;j++) {
			black[id][j]=true;
		}
		boolean initB = y%2==1;
		for(int i=0;i<m;i++,inc()) {
			black[id][0]=true;black[id][2]=false;
			if(y==0) {
				black[id][3]=initB;
				black[id][1]=!initB;
			}
			else {
				black[id][3] = black[id-1][1];
				black[id][1] = !black[id][3];
			}
		}
		for(int i=0;i<b;i++,inc())for(int j=0;j<4;j++)black[id][j]=false;
		initB = y%2==0;
		for(int i=0;i<c-m;i++,inc()) {
			black[id][0]=black[id-m][2];
			black[id][2]=!black[id][0];
			if(y==0) {
				black[id][3] = initB;
				black[id][1] = !initB;
				initB = !initB;
			}
			else {
				black[id][3]=black[id-1][1];
				black[id][1]=!black[id][3];
			}
		}
		show();
	}
	
	
	String[] get(boolean[] bs) {
		if(bs[0] && bs[1] && bs[2] && bs[3])return new String[] {"##","##"};
		if(!bs[0] && !bs[1] && !bs[2] && !bs[3])return new String[] {"..",".."};
		if(bs[0] && bs[1] && !bs[2] && !bs[3])return new String[] {"\\#",".\\"};
		if(!bs[0] && bs[1] && bs[2] && !bs[3])return new String[] {"./","/#"};
		if(!bs[0] && !bs[1] && bs[2] && bs[3])return new String[] {"\\.","#\\"};
		if(bs[0] && !bs[1] && !bs[2] && bs[3])return new String[] {"#/","/."};
		assert false;
		return null;
	}
	
	void show() {
		char[][] res=new char[n*2][m*2];
		for(int i=0;i<n;i++)for(int j=0;j<m;j++) {
			String[] ss=get(black[i*m+j]);
			for(int k=0;k<2;k++)for(int l=0;l<2;l++)res[i*2+k][j*2+l]=ss[k].charAt(l);
		}
		for(int i=0;i<res.length;i++)System.out.println(res[i]);
	}
	
	int nextInt(){
		try{
			int c=System.in.read();
			if(c==-1) return c;
			while(c!='-'&&(c<'0'||'9'<c)){
				c=System.in.read();
				if(c==-1) return c;
			}
			if(c=='-') return -nextInt();
			int res=0;
			do{
				res*=10;
				res+=c-'0';
				c=System.in.read();
			}while('0'<=c&&c<='9');
			return res;
		}catch(Exception e){
			return -1;
		}
	}
	
	long nextLong(){
		try{
			int c=System.in.read();
			if(c==-1) return -1;
			while(c!='-'&&(c<'0'||'9'<c)){
				c=System.in.read();
				if(c==-1) return -1;
			}
			if(c=='-') return -nextLong();
			long res=0;
			do{
				res*=10;
				res+=c-'0';
				c=System.in.read();
			}while('0'<=c&&c<='9');
			return res;
		}catch(Exception e){
			return -1;
		}
	}
	
	double nextDouble(){
		return Double.parseDouble(next());
	}
	
	String next(){
		try{
			StringBuilder res=new StringBuilder("");
			int c=System.in.read();
			while(Character.isWhitespace(c))
				c=System.in.read();
			do{
				res.append((char)c);
			}while(!Character.isWhitespace(c=System.in.read()));
			return res.toString();
		}catch(Exception e){
			return null;
		}
	}
	
	String nextLine(){
		try{
			StringBuilder res=new StringBuilder("");
			int c=System.in.read();
			while(c=='\r'||c=='\n')
				c=System.in.read();
			do{
				res.append((char)c);
				c=System.in.read();
			}while(c!='\r'&&c!='\n');
			return res.toString();
		}catch(Exception e){
			return null;
		}
	}
	public static void main(String[] args){
		new Main().run();
	}
}