/*
 * a.cpp
 *
 *  Created on: 2011-8-23
 *      Author: mac
 */
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <map>
#include <climits>
#define foreach(e,x) for(__typeof(x.begin()) e=x.begin();e!=x.end();++e)
#define REP(i,n) for(int i=0;i<n;++i)
using namespace std;
const int MAX_N = 1000 + 10;
int in[MAX_N] = { }, out[MAX_N] = { };
int C[MAX_N][MAX_N];
int n;
typedef pair<int, int> ipair;

int main() {
	int e;
	cin >> n >> e;
	for (int i = 0; i < e; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		C[a][b] = c;
		in[b] = a;
		out[a] = b;
	}

	int cnt = 0;
	for (int i = 1; i <= n; ++i) {
		if (in[i] == 0) {
			if (out[i] != 0) {
				++cnt;
			}
		}
	}

	cout << cnt << endl;
	for (int i = 1; i <= n; ++i) {
		if (in[i] == 0) {
			if (out[i] != 0) {
				int mind = INT_MAX;
				int u = i;
				while (true) {
					int v = out[u];
					if (!v)
						break;
					mind = min(mind, C[u][v]);
					u = v;
				}
				cout << i << " " << u << " " << mind << endl;
			}
		}
	}
	return 0;
}

----

/*
 * b.cpp
 *
 *  Created on: 2011-8-23
 *      Author: mac
 */
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#define foreach(e,x) for(__typeof(x.begin()) e=x.begin();e!=x.end();++e)
#define REP(i,n) for(int i=0;i<n;++i)
using namespace std;
const int MAX_N = 1000 + 10;
int s[MAX_N];

int main() {
	int n, m, h;
	int A = 0;
	cin >> n >> m >> h;
	for (int i = 1; i <= m; ++i) {
		cin >> s[i];
		A += s[i];
	}
	int B = A - s[h];
	--A;
	int x = n - 1;
	double ans = 1;
	if (A < x) {
		cout << -1 << endl;
		return 0;
	}
	if (B < x) {
		cout << 1 << endl;
		return 0;
	}
	for (int i = B + 1; i <= A; ++i) {
		ans /= i;
	}
	for (int i = B - x + 1; i <= A - x; ++i) {
		ans *= i;
	}
	printf("%0.10lf\n", 1 - ans);
	return 0;
}

----

/*
 * c.cpp
 *
 *  Created on: 2011-8-23
 *      Author: mac
 */
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#define foreach(e,x) for(__typeof(x.begin()) e=x.begin();e!=x.end();++e)
#define REP(i,n) for(int i=0;i<n;++i)
using namespace std;

typedef long long int64;
int n, m;
int64 kth;

int w[20];
int before[20] = { };
const int MAX_N = 16;
const int MAX_S = 1 << MAX_N;

int64 eval(int p) {
	static int64 dp[20][MAX_S];
	memset(dp, 0, sizeof dp);
	int at[MAX_N] = { };
	memset(at, -1, sizeof at);
	for (int i = 0; i < p; ++i) {
		at[w[i]] = i;
	}
	dp[0][0] = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < (1 << n); ++j) {
			if (dp[i][j] != 0) {
				int64 c = dp[i][j];
				for (int k = 0; k < n; ++k) {
					if (~j >> k & 1) {
						if (at[i] != -1 && at[i] != k)
							continue;
						if ((j & before[k]) == before[k]) {
							dp[i + 1][j ^ (1 << k)] += c;
						}
					}
				}
			}
		}
	}
	return dp[n][(1 << n) - 1];
}
int main() {
	cin >> n >> kth >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b, --a, --b;
		before[b] |= 1 << a;
	}
	kth -= 2001;
	if (eval(0) <= kth) {
		cout << "The times have changed" << endl;
		return 0;
	}
	int used = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (used >> j & 1)
				continue;
			w[i] = j;
			int64 tmp = eval(i + 1);
			if (tmp <= kth) {
				kth -= tmp;
			} else {
				used |= 1 << j;
				break;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << w[i] + 1 << " ";
	}
	cout << endl;
	return 0;
}

----

/*
 * d.cpp
 *
 *  Created on: 2011-8-23
 *      Author: mac
 */
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <vector>
#define foreach(e,x) for(__typeof(x.begin()) e=x.begin();e!=x.end();++e)
#define REP(i,n) for(int i=0;i<n;++i)
using namespace std;
typedef vector<vector<int> > mat;
const int MOD = 12345;
int N;

mat zero() {
	return mat(N, vector<int>(N, 0));
}

mat unit() {
	mat a = zero();
	for (int i = 0; i < N; ++i) {
		a[i][i] = 1;
	}
	return a;
}

mat operator*(mat a, mat b) {
	mat c = zero();
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j) {
			int tmp = 0;
			for (int k = 0; k < N; ++k) {
				tmp += a[i][k] * b[k][j];
				if (k % 10 == 0)
					tmp %= MOD;
			}
			c[i][j] = tmp % MOD;
		}
	}
	return c;
}

typedef long long int64;

mat matPow(mat a, int64 e) {
	if (!e)
		return unit();
	return e & 1 ? matPow(a, e - 1) * a : matPow(a * a, e >> 1);
}
int64 n;
int c;

int w[1000], mod[1000];
bool has[26] = { };

int main() {
	cin >> n >> c;
	N = 1;
	for (int i = 0; i < c; ++i) {
		char a;
		scanf(" ");
		cin >> a;
		w[i] = a - 'A';
		has[w[i]] = true;
		cin >> mod[i];
		N *= mod[i];
	}
	mat m = zero();
	for (int i = 0; i < N; ++i) {
		static int cur[1000];
		int x = i;
		for (int j = 0; j < c; ++j) {
			cur[j] = x % mod[j];
			x /= mod[j];
		}
		for (int nxt = 0; nxt < 26; ++nxt)
			if (has[nxt]) {
				for (int j = 0; j < c; ++j) {
					if (w[j] == nxt) {
						++cur[j];
						if (cur[j] >= mod[j])
							cur[j] = 0;
					}
				}
				int ni = 0;
				for (int j = c - 1; j >= 0; --j) {
					ni = ni * mod[j] + cur[j];
				}
				m[i][ni]++;
				if (m[i][ni] >= MOD)
					m[i][ni] -= MOD;
				for (int j = 0; j < c; ++j) {
					if (w[j] == nxt) {
						--cur[j];
						if (cur[j] < 0)
							cur[j] += mod[j];
					}
				}
			}
	}
	mat r = matPow(m, n);
	int ans = 0;
	for (int i = 0; i < N; ++i) {
		int x = i;
		bool ok[26] = { };
		for (int j = 0; j < c; ++j) {
			int cur = x % mod[j];
			x /= mod[j];
			if (cur == 0) {
				ok[w[j]] = true;
			}
		}
		bool check = true;
		for (int i = 0; i < 26; ++i) {
			if (has[i] && !ok[i]) {
				check = false;
				break;
			}
		}
		if (check) {
			(ans += r[0][i]) %= MOD;
		}
	}
	cout << ans << endl;
	return 0;
}