#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
 
using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int getcode(char c){
	int q = int(c);
	if(q<0) q += 256;
	return q;
}

int mirror(int code){
	int res = 0;
	REP(i,8)if(code&(1<<i))
		res ^= (1<<(7-i));
	return res;
}

int main(){
#ifdef LocalHost
    freopen("input.txt","r",stdin);
//  freopen("output.txt","w",stdout);
#endif
	
	string s;
	getline(cin,s);

	int prev = 0;
	REP(i,s.size()){
		prev = getcode(s[i]);
		prev = mirror(prev);

		int x = mirror(i?getcode(s[i-1]):0) - prev;
		x%=256;
		if(x<0) x+=256;
		cout<<x<<endl;
	}

 
#ifdef LocalHost
    cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
 
using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int dx[]={0,1,0,-1};
int dy[]={1,0,-1,0};

int n,m,t;
char s[55][55];
int c[55][55];
char color[55*55];
int per[55*55][5][5];

void dfs(int x,int y,int comp){
	if(c[x][y]!=-1) return;
	c[x][y]=comp;
	FOR(dx,-1,2)FOR(dy,-1,2)if(abs(dx)+abs(dy)==1){
		int nx = x + dx;
		int ny = y + dy;
		if(nx>=0 && nx<n && ny>=0 && ny<m && s[nx][ny]==s[x][y])
			dfs(nx,ny,comp);
	}
}

bool parsed[55*55];

int main(){
#ifdef LocalHost

    freopen("input.txt","r",stdin);
//  freopen("output.txt","w",stdout);
#endif

	cin>>n>>t;
	REP(i,n) cin>>s[i],m=strlen(s[i]);
	int comp=0;
	CL(c,-1);
	REP(i,n)REP(j,m) if(s[i][j]!='0' && c[i][j]==-1){
		color[comp]=s[i][j];
		dfs(i,j,comp);
		comp++;
	}
	CL(per,-1);

	REP(i,n)REP(j,m)if(c[i][j]!=-1 && !parsed[c[i][j]]){
		parsed[c[i][j]]=1;

		REP(dp,4)REP(bc,4){
			int x = i, y = j;
			while(1){
				int nx = x + dx[dp];
				int ny = y + dy[dp];
				if(nx<0 || nx>=n || ny<0 || ny>=m || s[nx][ny]!=s[x][y]) break;
				x = nx, y = ny;
			}

			while(1){
				int nx = x + dx[bc];
				int ny = y + dy[bc];
				if(nx<0 || nx>=n || ny<0 || ny>=m || s[nx][ny]!=s[x][y]) break;
				x = nx, y = ny;
			}

			x = x + dx[dp];
			y = y + dy[dp];

			if(x>=0 && x<n && y>=0 && y<m && s[x][y]!='0'){
				per[c[i][j]][dp][bc] = c[x][y];
			}
		}
	}

	int bpointer = 0;
	int dpointer = 0;
	int bchooser = 3;

	for(;t;t--){
		int val = per[bpointer][dpointer][bchooser];
		if(val==-1){
			if(bchooser == (dpointer+3)%4) bchooser = (dpointer+1)%4;
			else{
				dpointer = (dpointer+1)%4;
				bchooser = (dpointer+3)%4;
			}
		}else{
			bpointer = val;
		}
	}

	cout<<color[bpointer]<<endl;
	
#ifdef LocalHost
    cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
 
using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

string s;
int n;
int best = 0;

int a[111][55][211][3];
void go(int pos,int change,int x,int dx){
	if(a[pos][change][x+100][dx+1]) return;
	a[pos][change][x+100][dx+1]=1;
	if(pos==s.size()){
		if(change==0) best = max(best, abs(x));
		return;
	}
	REP(i,change+1){
		int val = (s[pos]=='F');
		if(i%2) val^=1;

		go(pos+1,change-i,x+(val==1?dx:0),dx*(val==0?-1:1));
	}
}

int main(){
#ifdef LocalHost

    freopen("input.txt","r",stdin);
//  freopen("output.txt","w",stdout);
#endif
	
	cin>>s>>n;
	go(0,n,0,1);
	cout<<best<<endl;
 
#ifdef LocalHost
    cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
 
using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

char s[1111111];
int  n;
int main(){
#ifdef LocalHost

    freopen("input.txt","r",stdin);
//  freopen("output.txt","w",stdout);
#endif
	
	gets(s);
	n = strlen(s);
	ll rrr=0;
	REP(i,n) rrr=rrr*2+(s[i]-'0');

	vector<pii> r;
	vector<pii> v;
	int res = 0;
	REP(i,n){
		int dig = s[i]-'0';
		if(v.size() && v.back().first==dig) v.back().second++;
		else v.pb(pii(dig,1));
	}
	vector<pii> w;
	swap(v,w);

	int sm=0;
	REP(i,w.size()){
		pii curr = w[i];
		sm += curr.second;
		if(v.size() && v.back().first==0 && v.back().second==1 && (curr.second>1 || v.size()>1 && v[v.size()-2].second>1)){
			v.pop_back();
			v.back().second++;
			v.back().second+=curr.second;
			r.pb(pii(0,n-(sm-curr.second)));
		}else v.pb(curr);
	}

	int sum=0;
	REP(i,v.size()){
		if(v[i].first==1){
			if(v[i].second==1){
				r.pb(pii(1,n-sum-1));
			}else{
				r.pb(pii(1,n-sum));
				r.pb(pii(0,n-sum-v[i].second));
			}
		}
		sum += v[i].second;
	}
	cout<<r.size()<<endl;
	ll t = 0;
	REP(i,r.size()){
		//if(r[i].first) t += 1ll<<r[i].second;
		//else t-=1ll<<r[i].second;
		printf("%c2^%d\n",r[i].first?'+':'-',r[i].second);
	}

	
#ifdef LocalHost
    cout<<rrr<<' '<<t<<endl;
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
 
using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int nb(int x){return x==0?0:1+nb(x&(x-1));}

int n,m;
int a[555];

vector<pii> v[666];

const int inf = 1011111111;

int d[666];
int f[666];

int flow(){
	int N = 2*n+m+2;
	REP(i,N) d[i] = inf;
	int start = N - 2;

	d[start] = 0;
	priority_queue<pii> q;
	q.push(pii(0, start));

	while(!q.empty()){
		pii curr = q.top();q.pop();
		int ver = curr.second;
		int cost = -curr.first;
		if(d[ver]<cost) continue;

		REP(i,v[ver].size()){

			int nw = v[ver][i].first;
			int ncost = cost + v[ver][i].second;

			if(d[nw] > ncost){
				d[nw] = ncost;
				f[nw] = ver;
				q.push(pii(-ncost, nw));
			}
		}
	}

	int curr = N-1;
	while(curr!=N-2){
		int prev = f[curr];

		bool found = false;
		REP(i,v[prev].size()) if(v[prev][i].first == curr){
			swap(v[prev][i], v[prev].back());
			int cost = v[prev].back().second;
			v[prev].pop_back();

			v[curr].pb(pii(prev, -cost));

			found = true;
			break;
		}
		if(!found) puts("FACK");
		curr = prev;
	}

	
	return d[N-1];
}

string conv(int a){
	stringstream ss;
	ss<<a;
	return ss.str();
}

string var[333];

int main(){
#ifdef LocalHost

    freopen("input.txt","r",stdin);
//  freopen("output.txt","w",stdout);
#endif

	cin>>n>>m;
	REP(i,n) cin>>a[i];
	REP(i,n) FOR(j,i+1,n) if(a[i]==a[j]) v[i].pb(pii(n+m+j,0));
	else v[i].pb(pii(n+m+j,nb(a[j])));
	REP(i,m)REP(j,n) v[n+i].pb(pii(n+m+j,nb(a[j])));
	REP(i,n+m) v[2*n+m].pb(pii(i,0));
	REP(i,n) v[n+m+i].pb(pii(2*n+m+1,0));

	if(0)REP(i,2*n+m+2){
		cout<<"ver "<<i<<": ";
		REP(j,v[i].size())
			cout<<v[i][j].first<<','<<v[i][j].second<<" ";
		puts("");
		//	cout<<v[n+m+i].size()<<endl;
		//res.pb("print("+a+")");
	}

	int cost = 0;
	REP(tt,n) cost += flow();
	vector<string> res;

	REP(i,n){
		//cout<<"ver "<<i<<": ";
		//REP(j,v[n+m+i].size())
		//	cout<<v[n+m+i][j].first<<','<<v[n+m+i][j].second<<" ";
		//puts("");
		//cout<<v[n+m+i].size()<<endl;
		int from = v[n+m+i][0].first;
		if(from>=n){
			var[i] = string(1,char('a'+from-n));
			res.pb(var[i]+"="+conv(a[i]));
		}else{
			var[i] = var[from];
			if(a[i]!=a[from]) res.pb(var[i]+"="+conv(a[i]));
		}
		res.pb("print("+var[i]+")");

	}

	cout<<res.size()<<' '<<cost<<endl;
	REP(i,res.size()) cout<<res[i]<<endl;


#ifdef LocalHost
    cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}