/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 11-12-24
 * Time: ??7:56
 * To change this template use File | Settings | File Templates.
 */

import java.io.*;
import java.util.*;

public class a {

    BufferedReader reader;
    StringTokenizer tokenizer;
    PrintWriter writer;

    void run() {
        try {
            reader = new BufferedReader(new InputStreamReader(System.in));
            tokenizer = null;
            writer = new PrintWriter(System.out);
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    String get(String a, int k) {
        for (int i = a.length() - 1; i >= 0; i--) {
            if ("aoieu".indexOf(a.charAt(i)) >= 0) {
                --k;
                if (k == 0)
                    return a.substring(i);
            }
        }
        return null;
    }

    boolean check(String a, String b, int k) {
        a = get(a, k);
        b = get(b, k);
        if (a == null || b == null)
            return false;
        return a.equals(b);
    }

    String get(String[] lines, int k) {
        int[] mark = new int[4];
        for (int i = 0; i < 4; i++) {
            mark[i] = i;
        }
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < i; j++) {
                if (check(lines[i], lines[j], k)) {
                    int mi = mark[i], mj = mark[j];
                    for (int l = 0; l < 4; l++) {
                        if (mark[l] == mi)
                            mark[l] = mj;
                    }
                }
            }
        }
        char[] which = new char[4];
        Arrays.fill(which, '?');
        char cur = 'a';
        StringBuilder sb = new StringBuilder();

        for (int i = 0; i < 4; i++) {
            if (which[mark[i]] == '?')
                which[mark[i]] = cur++;
            sb.append(which[mark[i]]);
        }

        String a = sb.toString();
        if (a.equals("aaaa") || a.equals("abba") || a.equals("aabb") || a.equals("abab"))
            return a;
        else
            return "NO";
    }

    void solve() throws IOException {
        int n = nextInt();
        int k = nextInt();
        String[] lines = new String[4];
        Set<String> set = new HashSet<String>();

        for (int it = 0; it < n; it++) {
            for (int i = 0; i < 4; i++) {
                lines[i] = nextToken();
            }
            String me = get(lines, k);
            if (me.equals("NO")) {
                writer.println("NO");
                return;
            }
            set.add(me);
        }
        if (set.size() == 1) {
            writer.println(set.iterator().next());
            return;
        }
        if (set.size() > 2) {
            writer.println("NO");
            return;
        }

        boolean has = false;
        for (String s : set) {
            if (s.equals("aaaa"))
                has = true;
        }
        if (!has) {
            writer.println("NO");
            return;
        }
        for (String s : set) {
            if (!s.equals("aaaa"))
                writer.println(s);
        }
    }

    static public void main(String[] args) {
        new a().run();
    }
}

----

/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 11-12-24
 * Time: ??7:56
 * To change this template use File | Settings | File Templates.
 */

import java.io.*;
import java.util.*;

public class b {

    BufferedReader reader;
    StringTokenizer tokenizer;
    PrintWriter writer;

    void run() {
        try {
            reader = new BufferedReader(new InputStreamReader(System.in));
            tokenizer = null;
            writer = new PrintWriter(System.out);
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    void solve() throws IOException {
        String a = nextToken();
        int[] cnt = new int[10];
        for (char c : a.toCharArray()) {
            cnt[c - '0']++;
        }

        //justzero
        int maxLast = -1;
        int maxZero = cnt[0];

        for (int lastA = 1; lastA < 10; lastA++) {
            int lastB = 10 - lastA;
            int[] haveA = cnt.clone();
            int[] haveB = cnt.clone();
            if (haveA[lastA] == 0 || haveB[lastB] == 0)
                continue;
            --haveA[lastA];
            --haveB[lastB];
            int zero = 1;

            for (int i = 0; i < 10; i++) {
                int min = Math.min(haveA[i], haveB[9 - i]);
                zero += min;
                haveA[i] -= min;
                haveB[9 - i] -= min;
            }

            int min = Math.min(haveA[0], haveB[0]);
            haveA[0] -= min;
            haveB[0] -= min;
            zero += min;

            if (zero > maxZero) {
                maxZero = zero;
                maxLast = lastA;
            }
        }

        if (maxLast == -1) {
            StringBuilder sb = new StringBuilder();
            for (int i = 10 - 1; i >= 0; i--) {
                for (int j = 0; j < cnt[i]; j++) {
                    sb.append((char) ('0' + i));
                }
            }
            String ret = sb.toString();
            writer.println(ret);
            writer.println(ret);
            return;
        }

        {
            int lastA = maxLast;
            int lastB = 10 - lastA;
            int[] haveA = cnt.clone();
            int[] haveB = cnt.clone();
            StringBuilder sba = new StringBuilder(), sbb = new StringBuilder();

            --haveA[lastA];
            --haveB[lastB];
            sba.append((char) ('0' + lastA));
            sbb.append((char) ('0' + lastB));
            int zero = 1;

            for (int i = 0; i < 10; i++) {
                int min = Math.min(haveA[i], haveB[9 - i]);
                zero += min;
                for (int j = 0; j < min; j++) {
                    sba.append((char) ('0' + i));
                    sbb.append((char) ('0' + 9 - i));
                }
                haveA[i] -= min;
                haveB[9 - i] -= min;
            }


            int min = Math.min(haveA[0], haveB[0]);
            haveA[0] -= min;
            haveB[0] -= min;
            zero += min;

            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < haveA[i]; j++) {
                    sba.append((char) ('0' + i));
                }
                for (int j = 0; j < haveB[i]; j++) {
                    sbb.append((char) ('0' + i));
                }
            }

            sba = sba.reverse();
            sbb = sbb.reverse();

            for (int j = 0; j < min; j++) {
                sba.append('0');
                sbb.append('0');
            }

            writer.println(sba);
            writer.println(sbb);
        }
    }

    static public void main(String[] args) {
        new b().run();
    }
}

----

/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 11-12-24
 * Time: ??7:56
 * To change this template use File | Settings | File Templates.
 */

import java.io.*;
import java.util.*;

public class c {

    BufferedReader reader;
    StringTokenizer tokenizer;
    PrintWriter writer;

    void run() {
        try {
            reader = new BufferedReader(new InputStreamReader(System.in));
            tokenizer = null;
            writer = new PrintWriter(System.out);
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    void solve() throws IOException {
        int n = nextInt(), m = nextInt();
        int[] a = new int[n], h = new int[n], l = new int[n], r = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            h[i] = nextInt();
            l[i] = nextInt();
            r[i] = nextInt();
        }

        final int[] b = new int[m], j = new int[m];
        for (int i = 0; i < m; i++) {
            b[i] = nextInt();
            j[i] = nextInt();
        }

        Integer[] perm = new Integer[m];
        for (int i = 0; i < m; i++) {
            perm[i] = i;
        }
        Arrays.sort(perm, new Comparator<Integer>() {
            public int compare(Integer o1, Integer o2) {
                return b[o1] - b[o2];  //To change body of implemented methods use File | Settings | File Templates.
            }
        });

        int[] tmp = b.clone();
        for (int i = 0; i < m; i++) {
            b[i] = tmp[perm[i]];
        }

        tmp = j.clone();
        for (int i = 0; i < m; i++) {
            j[i] = tmp[perm[i]];
        }

        int[] cntBad = new int[m + 1];
        double[] sumExp = new double[m + 1];

        for (int i = 0; i < n; i++) {
            //left
            {
                int prob = 100 - l[i];
                int left = a[i] - h[i], right = a[i] - 1;
                int atL = Algorithms.lowerBound(b, left);
                int atR = Algorithms.upperBound(b, right) - 1;
                if (prob == 0) {
                    cntBad[atL]++;
                    cntBad[atR + 1]--;
                } else {
                    double exp = Math.log(prob / 100.0);
                    sumExp[atL] += exp;
                    sumExp[atR + 1] -= exp;
                }
            }

            //right
            {
                int prob = 100 - r[i];
                int left = a[i] + 1, right = a[i] + h[i];
                int atL = Algorithms.lowerBound(b, left);
                int atR = Algorithms.upperBound(b, right) - 1;
                if (prob == 0) {
                    cntBad[atL]++;
                    cntBad[atR + 1]--;
                } else {
                    double exp = Math.log(prob / 100.0);
                    sumExp[atL] += exp;
                    sumExp[atR + 1] -= exp;
                }
            }
        }

        for (int i = 1; i < cntBad.length; i++) {
            cntBad[i] += cntBad[i - 1];
        }

        for (int i = 1; i < sumExp.length; i++) {
            sumExp[i] += sumExp[i - 1];
        }

        double ans = 0;

        for (int i = 0; i < m; i++) {
            if (cntBad[i] > 0) {
                continue;
            }
            double exp = sumExp[i];
            ans += Math.exp(exp) * j[i];
        }

        writer.println(ans);
    }

    static public void main(String[] args) {
        new c().run();
    }
}


class Algorithms {
    static int lowerBound(int[] arr, int x) {//first index >= x
        int l = -1, r = arr.length;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (arr[m] >= x)
                r = m;
            else
                l = m;
        }
        return r;
    }

    static int upperBound(int[] arr, int x) {//first index > x
        int l = -1, r = arr.length;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (arr[m] > x)
                r = m;
            else
                l = m;
        }
        return r;
    }

    static int[] equalRange(int[] arr, int x) {
        return new int[]{lowerBound(arr, x), upperBound(arr, x)};
    }

    static int sortedCount(int[] arr, int x) {
        return upperBound(arr, x) - lowerBound(arr, x);
    }

    static int count(int[] arr, int x) {
        int cnt = 0;
        for (int i : arr) {
            if (x == i)
                ++cnt;
        }
        return cnt;
    }

    static int[] merge(int[] a, int[] b) {
        int ia = 0, ib = 0;
        int[] ret = new int[a.length + b.length];
        int cur = 0;

        while (ia < a.length || ib < b.length) {
            if (ia == a.length)
                ret[cur++] = b[ib++];
            else if (ib == b.length)
                ret[cur++] = a[ia++];
            else if (a[ia] < b[ib])
                ret[cur++] = a[ia++];
            else
                ret[cur++] = b[ib++];
        }

        return ret;
    }

    static int[] unique(int[] arr) {
        int[] tmp = new int[arr.length];
        int cur = 0;
        for (int i : arr) {
            if (cur == 0 || tmp[cur - 1] != i)
                tmp[cur++] = i;
        }
        int[] ret = new int[cur];
        System.arraycopy(tmp, 0, ret, 0, cur);
        return ret;
    }

    static int lowerBound(long[] arr, long x) {//first index >= x
        int l = -1, r = arr.length;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (arr[m] >= x)
                r = m;
            else
                l = m;
        }
        return r;
    }

    static int upperBound(long[] arr, long x) {//first index > x
        int l = -1, r = arr.length;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (arr[m] > x)
                r = m;
            else
                l = m;
        }
        return r;
    }

    static int[] equalRange(long[] arr, long x) {
        return new int[]{lowerBound(arr, x), upperBound(arr, x)};
    }

    static int sortedCount(long[] arr, long x) {
        return upperBound(arr, x) - lowerBound(arr, x);
    }

    static int count(long[] arr, long x) {
        int cnt = 0;
        for (long i : arr) {
            if (x == i)
                ++cnt;
        }
        return cnt;
    }

    static long[] merge(long[] a, long[] b) {
        int ia = 0, ib = 0;
        long[] ret = new long[a.length + b.length];
        int cur = 0;

        while (ia < a.length || ib < b.length) {
            if (ia == a.length)
                ret[cur++] = b[ib++];
            else if (ib == b.length)
                ret[cur++] = a[ia++];
            else if (a[ia] < b[ib])
                ret[cur++] = a[ia++];
            else
                ret[cur++] = b[ib++];
        }

        return ret;
    }

    static long[] unique(long[] arr) {
        long[] tmp = new long[arr.length];
        int cur = 0;
        for (long i : arr) {
            if (cur == 0 || tmp[cur - 1] != i)
                tmp[cur++] = i;
        }
        long[] ret = new long[cur];
        System.arraycopy(tmp, 0, ret, 0, cur);
        return ret;
    }
}

----

/**
 * Created by IntelliJ IDEA.
 * User: mac
 * Date: 11-12-24
 * Time: ??7:56
 * To change this template use File | Settings | File Templates.
 */

import java.io.*;
import java.util.*;

public class d {

    BufferedReader reader;
    StringTokenizer tokenizer;
    PrintWriter writer;

    void run() {
        try {
            reader = new BufferedReader(new InputStreamReader(System.in));
            tokenizer = null;
            writer = new PrintWriter(System.out);
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    int n, m;
    int[][][][] dp;
    int rem;

    int calc(int subL, int subR, int addL, int addR) {
        if ((subL & 1) != rem)
            ++subL;
        if ((subR & 1) != rem)
            --subR;
        if ((addL & 1) != rem)
            ++addL;
        if ((addR & 1) != rem)
            --addR;

        if (subL > subR || addL > addR)
            return 0;

        int ret = dp[subL + m][subR + m][addL][addR];
        if (ret != -1)
            return ret;
        boolean[] have = new boolean[(subR - subL + 1) * (addR - addL + 1) + 1];
        for (int sub = subL; sub <= subR; sub += 2) {
            for (int add = addL; add <= addR; add += 2) {
                int r = (add + sub) / 2;
                int c = add - r;
                if (r >= 0 && r < n && c >= 0 && c < m) {
                    char ch = grid[r][c];
                    if (ch == 'L') {//add
                        int tmp = calc(subL, subR, addL, add - 1) ^ calc(subL, subR, add + 1, addR);
                        if (tmp < have.length)
                            have[tmp] = true;
                    } else if (ch == 'R') {
                        int tmp = calc(subL, sub - 1, addL, addR) ^ calc(sub + 1, subR, addL, addR);
                        if (tmp < have.length)
                            have[tmp] = true;
                    } else {
                        int tmp = calc(subL, sub - 1, addL, add - 1) ^ calc(sub + 1, subR, addL, add - 1) ^
                                calc(subL, sub - 1, add + 1, addR) ^ calc(sub + 1, subR, add + 1, addR);
                        if (tmp < have.length)
                            have[tmp] = true;
                    }
                }
            }
        }

        for (int i = 0; i < have.length; i++) {
            if (!have[i])
                return dp[subL + m][subR + m][addL][addR] = i;
        }

        return -1;
    }

    char[][] grid;

    void solve() throws IOException {
        n = nextInt();
        m = nextInt();

        dp = new int[n + m + 3][n + m + 3][n + m + 3][n + m + 3];
        grid = new char[n][];
        for (int r = 0; r < n; r++) {
            grid[r] = nextToken().toCharArray();
        }

        int xor = 0;
        for (rem = 0; rem < 2; ++rem) {
            for (int[][][] a : dp) {
                for (int[][] b : a) {
                    for (int[] c : b) {
                        Arrays.fill(c, -1);
                    }
                }
            }
            xor ^= calc(0 - (m - 1), n - 1 - 0, 0, n + m - 2);
        }

        if (xor == 0)
            writer.println("LOSE");
        else
            writer.println("WIN");
    }

    static public void main(String[] args) {
        new d().run();
    }
}