#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <vector>
#include <cmath>
#include <map>
#include <set>

#define SIZE(A) ((int)A.size())
#define LENGTH(A) ((int)A.length())
#define MP(A,B) make_pair(A,B)
#define PB(A) push_back(A)

typedef long long ll;
typedef double ld;

using namespace std;

map <int, long long> dp;

long long solve(int n)
{
	if (n == 1) return 1;
 	if (dp.count(n)) return dp[n];
 	dp[n] = n;

 	for (int i = 1; i*i <= n; i++)
 		if (n % i == 0)
 		{
 			long long best = 0;
 			if (n/i != 1)
 				best = solve(i);
 			if (i != 1)
 				best = max(best, solve(n/i));
 			dp[n] = max(dp[n], n + best);
 		}

 	return dp[n];
}

int main()
{
	#ifndef ONLINE_JUDGE
		freopen("input", "r", stdin);
		freopen("output", "w", stdout);
	#endif

	int n;

	scanf("%d", &n);

	cout << solve(n) << endl;

	return 0;
}