#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

char s[1024];
int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int id;
  while (scanf("%s%d", s, &id) >= 2) {
    id--;

    int i1 = strcmp(s, "front") == 0;
    i1 ^= id;
    printf(i1 == 0 ? "R\n" : "L\n");
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int n, k;
  while (scanf("%d%d", &n, &k) >= 1) {
    k--;

    vi as(n);
    for (int i = 0; i < n; i++)
      scanf("%d", &as[i]);

    while (!as[k])
      k = (k + 1) % n;
    printf("%d\n", k + 1);
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int n, k;
  while (scanf("%d%d", &n, &k) >= 1) {
    vi as(n);
    for (int i = 0; i < n; i++)
      scanf("%d", &as[i]);

    int ans = 0;
    for (int i = 0; i < n; i++) {
      if (as[i] >= 3 * k) {
        as[i] -= 3 * k;
      } else
        as[i] %= k;
      ans += as[i];
    }
    printf("%d\n", ans);
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int h, w;
  while (scanf("%d%d", &h, &w) >= 1) {
    vvi as(h, vi(w));
    for (int y = 0; y < h; y++)
      for (int x = 0; x < w; x++)
        scanf("%d", &as[y][x]);

    vi cs(3);
    scanf("%d%d%d", &cs[0], &cs[1], &cs[2]);
    sort(cs.begin(), cs.end());

    int ans = 0;
    for (int step = 0; step < 2; step++) {
      for (int x1 = 1; x1 < w; x1++)
        for (int x2 = x1 + 1; x2 < w; x2++) {
          vi ccs(3);
          for (int x = 0; x < x1; x++)
            for (int y = 0; y < h; y++)
              ccs[0] += as[y][x];
          for (int x = x1; x < x2; x++)
            for (int y = 0; y < h; y++)
              ccs[1] += as[y][x];
          for (int x = x2; x < w; x++)
            for (int y = 0; y < h; y++)
              ccs[2] += as[y][x];
          sort(ccs.begin(), ccs.end());
          ans += ccs == cs;
        }

      // turn
      vvi nas(w, vi(h));
      for (int y = 0; y < h; y++)
        for (int x = 0; x < w; x++)
          nas[x][y] = as[y][x];
      nas.swap(as);
      swap(w, h);
    }
    printf("%d\n", ans);
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int tc;
  while (scanf("%d", &tc) >= 1) {
    for (int i = 0; i < tc; i++) {
      int n;
      scanf("%d", &n);
      printf("%d\n", !(n & 1));
    }
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int n;
vvi es;
vi ds;

void dfs(int v) {
  for (int i = 0; i < sz(es[v]); i++) {
    int b = es[v][i];
    if (ds[b] >= 0) {
      assert(ds[b] <= ds[v] + 1);
      continue;
    }
    ds[b] = ds[v] + 1;
    dfs(b);
  }
}

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int m;
  while (scanf("%d", &m) >= 1) {
    int ans = 0;

    for (int i = 0; i < m; i++) {
      scanf("%d", &n);
      es = vvi(n);
      for (int i2 = 0; i2 < n - 1; i2++) {
        int a, b;
        scanf("%d%d", &a, &b), a--, b--;
        es[a].pb(b); es[b].pb(a);
      }

      int cres = 0;
      for (int a = 0; a < n; a++) {
        ds = vi(n, -1);
        ds[a] = 0;
        dfs(a);

        for (int b = 0; b < n; b++)
          cres = max(cres, ds[b]);
      }
      ans += cres;
    }
    printf("%d\n", ans);
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>
#include <deque>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int n, t;
  while (scanf("%d%d", &n, &t) >= 2) {
    vvi as(n, vi(2)), bs(n, vi(2));
    for (int i = 0; i < n; i++)
      for (int i2 = 0; i2 < 2; i2++)
        scanf("%d%d", &as[i][i2], &bs[i][i2]);

    int m;
    scanf("%d", &m);
    vector<string> ns(m); vi cs(m);
    for (int i = 0; i < m; i++) {
      char buf[30];
      scanf("%s%d", buf, &cs[i]);
      ns[i] = buf;
    }

    vector<vector<string> > res(n);

    vvi d(n, vi(m, 0));
    deque<int> dq;
    for (int i = 0; i < m; i++) dq.pb(i);

    int cur = 0, cpl = 0;
    while (!dq.empty()) {
      int curt = t;
      while (curt > 0 && !dq.empty()) {
        int card = dq.front(); dq.pop_front();
        int need = max(1, cs[card] - (as[cur][cpl] + bs[cur][!cpl]) - d[cur][card]);
        if (curt >= need) {
          curt -= need;
          res[cur].pb(ns[card]);
        } else {
          dq.pb(card);
          d[cur][card] += curt;
          curt = 0;
        }
      }

      if (++cur >= n) {
        cur = 0;
        cpl = !cpl;
      }
    }
    for (int i = 0; i < n; i++) {
      printf("%d", sz(res[i]));
      for (int i2 = 0; i2 < sz(res[i]); i2++)
        printf(" %s", res[i][i2].c_str());
      printf("\n");
    }
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int P = 27;
const int n2 = P * P * P * P;

string getStr(int id) {
  string res = "";
  for (; id; id /= P)
    res = string(1, 'a' + id % P - 1) + res;
  return res;
}
void addes(char *s, vi &es, int cur, int rem) {
  if (!rem) { assert(0 <= cur && cur < n2); es.pb(cur); return; }
  if (!s[0]) return;

  addes(s + 1, es, cur * P + s[0] - 'a' + 1, rem - 1);
  addes(s + 1, es, cur, rem);
}

vvi es;
vi p1, p2;
vb was;

bool dfs(int v) {
  if (was[v]) return false;

  was[v] = true;
  for (int i = 0; i < sz(es[v]); i++) {
    int b = es[v][i];
    if (p2[b] < 0) {
      p2[b] = v;
      p1[v] = b;
      return true;
    } else if (dfs(p2[b])) {
      p2[b] = v;
      p1[v] = b;
      return true;
    }
  }
  return false;
}

char s[11];
int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int n;
  while (scanf("%d", &n) >= 1) {
    es = vvi(n);
    for (int i = 0; i < n; i++) {
      scanf("%s", s);
      addes(s, es[i], 0, 1);
      addes(s, es[i], 0, 2);
      addes(s, es[i], 0, 3);
      addes(s, es[i], 0, 4);
    }

    p1 = vi(n, -1);
    p2 = vi(n2, -1);
    int res = 0;
    for (;;) {
      bool cont = false;
      was = vb(n, false);
      for (int i = 0; i < n; i++)
        if (p1[i] < 0 && dfs(i)) {
          cont = true;
          res++;
        }
      if (!cont) break;
    }

    if (res < n) {
      printf("-1\n");
    } else {
      for (int i = 0; i < n; i++) {
        assert(p1[i] >= 0);
        printf("%s\n", getStr(p1[i]).c_str());
      }
    }
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const char* digs[] = {
  "HHH"
  "H H"
  "H H"
  "H H"
  "HHH",

  "  H"
  "  H"
  "  H"
  "  H"
  "  H",

  "HHH"
  "  H"
  "HHH"
  "H  "
  "HHH",

  "HHH"
  "  H"
  "HHH"
  "  H"
  "HHH",

  "H H"
  "H H"
  "HHH"
  "  H"
  "  H",

  "HHH"
  "H  "
  "HHH"
  "  H"
  "HHH",

  "HHH"
  "H  "
  "HHH"
  "H H"
  "HHH",

  "HHH"
  "  H"
  "  H"
  "  H"
  "  H",

  "HHH"
  "H H"
  "HHH"
  "H H"
  "HHH",

  "HHH"
  "H H"
  "HHH"
  "  H"
  "HHH",
};

int get(const char *s, int x, int y) {
  return s[y * 3 + x] != ' ';
}

const int pcnt = 7;
const int xs[] = { 1, 0, 2, 1, 0, 2, 1 };
const int ys[] = { 0, 1, 1, 2, 3, 3, 4 };
int cache[10][10];

int get(char a, char b) {
  if (cache[a][b] >= 0) return cache[a][b];
  int res = 0;
  for (int i = 0; i < pcnt; i++) {
    res += get(digs[a], xs[i], ys[i]) && get(digs[b], xs[i], ys[i]);
  }
  return cache[a][b] = res;
}

const int BEST = 8;

const int MAXN = 1e5;
const int MAXL = 2 * MAXN;

char s[MAXL + 100];

int n, n2;

string restore1(int pos, int minv, int source) {
  assert(pos >= n2);
  string res;
  for (int i = 0; i < pos; i++)
    res += string(1, '0' + s[i]);

  for (int i = n2; i < pos; i++)
    source -= get(s[i - n2], s[i]);

  int firmaxv = 0;
  for (int cval = minv; cval <= 9; cval++)
    firmaxv = max(firmaxv, get(s[pos - n2], cval));

  int crem = firmaxv;
  for (int i = pos + 1; i < n; i++)
    crem += get(s[i - n2], s[i - n2]);

  assert(crem >= source);

  for (int i = pos; i < n; i++) {
    crem -= i == pos ? firmaxv : get(s[i - n2], s[i - n2]);

    bool g = false;
    for (int cval = minv; cval <= 9; cval++) {
      crem += get(s[i - n2], cval);
      if (crem >= source) {
        res += string(1, '0' + cval);
        source -= get(s[i - n2], cval);
        g = true;
      }
      crem -= get(s[i - n2], cval);
      if (g) break;
    }
    minv = 0;
    assert(g);
  }
  assert(source <= 0);
  return res;
}

string restore2(int pos, int minv, int source) {
  int _source = source;

  assert(0 <= pos && pos < n2);
  string res;
  for (int i = 0; i < pos; i++)
    res += string(1, '0' + s[i]);

  int crem = 0;
  for (int i = 0; i < pos; i++)
    crem += get(s[i], s[i]);
  int firmaxv = 0;
  for (int val1 = minv; val1 <= 9; val1++) {
    firmaxv = max(firmaxv, get(val1, val1));
  }
  crem += firmaxv;
  for (int i = pos + 1; i < n2; i++)
    crem += get(BEST, BEST);

//  eprintf("pos=%d, minv=%d, crem=%d, source=%d\n", pos, minv, crem, source);
  assert(crem >= source);
  for (int i = pos; i < n2; i++) {
    crem -= i == pos ? firmaxv : get(BEST, BEST);

    bool g = false;
    for (int cval = minv; cval <= 9; cval++) {
      crem += get(cval, cval);
      if (crem >= source) {
//        eprintf("i=%d, cval=%d\n", i, cval);
        res += string(1, '0' + cval);
        source -= get(cval, cval);
        g = true;
      }
      crem -= get(cval, cval);
      if (g) break;
    }
    minv = 0;
    assert(g);
  }

  for (int i = 0; i < n2; i++)
    s[i] = res[i] - '0';
  return restore1(n2, 0, _source);
}

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  memset(cache, -1, sizeof cache);
  while (scanf("%s", s) >= 1) {
    n = strlen(s);
    n2 = n / 2;
//    eprintf("%s\n", s);

    for (int i = 0; i < n; i++)
      s[i] -= '0';

    int source = 0;
    for (int i = 0; i < n2; i++)
      source += get(s[i], s[i + n2]);

    int cur = source;
    for (int st = n - 1; st >= n2; st--) {
      cur -= get(s[st - n2], s[st]);

      for (int cval = s[st] + 1; cval < 10; cval++) {
        cur += get(s[st - n2], cval);
        if (cur > source) {
          printf("%s\n", restore1(st, s[st] + 1, source + 1).c_str());
          goto end;
        }
        cur -= get(s[st - n2], cval);
      }
      cur += get(s[st - n2], s[st - n2]);
    }

    for (int st = n2 - 1; st >= 0; st--) {
      cur -= get(s[st], s[st]);
      for (int cval = s[st] + 1; cval < 10; cval++) {
        cur += get(cval, cval);
        if (cur > source) {
          printf("%s\n", restore2(st, s[st] + 1, source + 1).c_str());
          goto end;
        }
        cur -= get(cval, cval);
      }
      cur += get(BEST, BEST);
    }
    printf("-1\n");

    end:;
  }
  return 0;
}

----

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define mp make_pair
#define sz(x) ((int)(x).size())
#define sqr(x) ((x) * (x))
#define INF ((int)1e9)

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

struct pt {
  int x, y, id;
  inline bool operator<(const pt &p2) const { return x == p2.x ? y < p2.y : x < p2.x; }

  int dist(const pt &p2) const {
    return sqr(x - p2.x) + sqr(y - p2.y);
  }
};

const int dx[] = { 1, -1, 1, -1 };
const int dy[] = { 1, 1, -1, -1 };
const int drev[] = { 3, 2, 1, 0  };

vector<pt> pts;
int getd(const pii &a) {
  return a.first >= 0 ? pts[a.first].dist(pts[a.second]) : INF;
}

pii getMin(const pii &a, const pii &b) {
  int d1 = getd(a), d2 = getd(b);
  if (d1 <= d2) return a;
  else return b;
}

bool cmp2(int a, int b) { return pts[a].y < pts[b].y; }

pii findNearest(int l, int r) {
  if (r - l + 1 < 2) return mp(-1, -1);
  if (r - l + 1 == 2) return mp(l, r);

  int m = (l + r) / 2;
  pii ans = getMin(findNearest(l, m), findNearest(m + 1, r));
  int rad = getd(ans);

  int midx = pts[m + 1].x;

  vi left, right;
  for (int i = l; i <= m; i++)
    if (pts[i].x >= midx - rad) {
      assert(pts[i].x <= midx);
      left.pb(i);
    }
  sort(left.begin(), left.end(), cmp2);

  for (int i = m + 1; i <= r; i++)
    if (pts[i].x <= midx + rad) {
      assert(pts[i].x >= midx);
      right.pb(i);
    }
  sort(right.begin(), right.end(), cmp2);

  int p1 = 0, p2 = 0;
  for (int i = 0; i < sz(left); i++) {
    int miny = pts[left[i]].y - rad;
    int maxy = pts[left[i]].y + rad;
    while (p2 < sz(right) && pts[right[p2]].y <= maxy) p2++;
    while (p1 < p2 && pts[right[p1]].y < miny) p1++;

    for (int i2 = p1; i2 < p2; i2++)
      ans = getMin(ans, mp(left[i], right[i2]));
  }

/*  for (int i = l; i <= m; i++)
    for (int j = m + 1; j <= r; j++)
      assert(getMin(ans, mp(i, j)) == ans);*/
  return ans;
}

int main() {
  #ifdef DEBUG
  freopen("std.in", "r", stdin);
  freopen("std.out", "w", stdout);
  #else
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  #endif

  int n;
  while (scanf("%d", &n) >= 1) {
    pts = vector<pt>(n);
    vi ks(n);

    for (int i = 0; i < n; i++) {
      scanf("%d%d", &pts[i].x, &pts[i].y), pts[i].id = i;
      for (ks[i] = 0; ks[i] < 4; ks[i]++)
        if (pts[i].x * dx[ks[i]] >= 0 && pts[i].y * dy[ks[i]] >= 0)
          break;
      pts[i].x = abs(pts[i].x);
      pts[i].y = abs(pts[i].y);
    }

    sort(pts.begin(), pts.end());
    pii res = findNearest(0, n - 1);

    int a = pts[res.first].id;
    int b = pts[res.second].id;
//    printf("%d\n", getd(res));
    printf("%d %d %d %d\n", a + 1, drev[ks[a]] + 1, b + 1, ks[b] + 1);
  }
  return 0;
}