#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <complex>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
#include<list>

using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int n,m,x,y;
int a[111111];
int b[111111];

int main(){
#ifdef LocalHost
    freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif

	cin>>n>>m>>x>>y;
	REP(i,n) scanf("%d",a+i);
	REP(i,m) scanf("%d",b+i);
	vector<pii> res;

	int p1 = 0, p2 = 0;
	while(p1<n && p2<m){
		while(p2<m && a[p1]-x > b[p2]) p2 ++;
		if(p2 < m && b[p2] <= a[p1]+y){
			res.pb(pii(p1,p2));
			p1++,p2++;
			continue;
		}
		p1++;
	}

	cout<<res.size()<<endl;
	REP(i,res.size())
		printf("%d %d\n",res[i].first +1 , res[i].second+1);

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <complex>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
#include<list>

using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int n,k;
int c[1111],t[1111];
vi r[1111];

int main(){
#ifdef LocalHost
    freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif

	cin>>n>>k;
	REP(i,n) scanf("%d %d",c+i,t+i);
	vector<pii> v;
	REP(i,n) if(t[i]==1)v.pb(pii(c[i],i));
	SORT(v);
	reverse(v.begin(),v.end());
	REP(i,v.size()) r[min(i,k-1)].pb(v[i].second);
	int pos = k-1;
	REP(i,k) if(r[i].size()==0){
		pos = i;
		break;
	}
	REP(i,n) if(t[i]==2){
		r[pos].pb(i);
		pos++;
		pos=min(pos,k-1);
	}
	double res = 0;
	REP(i,k){
		int mn = 1000000000;
		ll sum = 0;
		bool hasc = 0;
		REP(j,r[i].size()){
			if(t[r[i][j]]==1) hasc=1;
			mn = min(mn, c[r[i][j]]);
			sum += c[r[i][j]];
		}
		res += sum;
		res -= mn;
		if(hasc) res += mn/2.;
		else res += mn;
	}
	printf("%.1lf\n",res);
	REP(i,k){
		cout<<r[i].size();
		REP(j,r[i].size()) printf(" %d",r[i][j]+1);
		puts("");
	}

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <complex>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
#include<list>

using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

map< pair<pii,pii> , int> r[33];

int solve(int l1,int r1,int l2,int r2,int step){
	if(step==1){
		return 1;
	}

	if(r[step].count(make_pair(pii(l1,r1),pii(l2,r2))))
		return r[step][make_pair(pii(l1,r1),pii(l2,r2))];

	int middle_pos = ((1<<step)-1)/2;

	int res = 0;
	
	if(l1<=middle_pos && middle_pos<=r1)
		if(l2<=middle_pos && middle_pos<=r2){
			res = min(r1,r2)-max(l1,l2) + 1;
		}

	REP(type1,2)REP(type2,2){
		int from1 = l1;
		int to1 = min(middle_pos - 1, r1);
		if(type1){
			from1 = max(l1, middle_pos + 1);
			to1 = r1;

			from1 -= (middle_pos + 1);
			to1 -= (middle_pos + 1);
		}

		int from2 = l2;
		int to2 = min(middle_pos - 1, r2);
		if(type2){
			from2 = max(l2, middle_pos + 1);
			to2 = r2;

			from2 -= (middle_pos + 1);
			to2 -= (middle_pos + 1);
		}

		if(from1>=0 && from2>=0 && from1<=to1 && from2<=to2){
			if(res < min(to2-from2+1,to1-from1+1))
				res = max(res, solve(from1,to1,from2,to2,step-1));
		}
	}

	return r[step][make_pair(pii(l1,r1),pii(l2,r2))]=res;
}

int main(){
#ifdef LocalHost
    freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif

	int l1,r1,l2,r2;
	cin>>l1>>r1>>l2>>r2;
	l1--,r1--,l2--,r2--;
	cout<<solve(l1,r1,l2,r2,30)<<endl;

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <complex>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
#include<list>

using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

int n,k;
ll res;
vi v[55555];

vi dfs(int ver,int par=-1){
	vi temp(k+1);
	temp[0] = 1;
	REP(i,v[ver].size()) if(v[ver][i]!=par){
		vi t = dfs(v[ver][i], ver);
		REP(j,k+1) res += temp[j] * ll(t[k-j]);
		REP(j,k+1) temp[j] += t[j];
	}
	for(int i=k;i;i--) temp[i]=temp[i-1];
	temp[0]=0;
	return temp;
}

int main(){
#ifdef LocalHost
    freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif

	cin>>n>>k;
	REP(i,n-1){
		int x,y;
		scanf("%d %d",&x,&y);
		x--,y--;
		v[x].pb(y);
		v[y].pb(x);
	}
	dfs(0);
	cout<<res<<endl;

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}

----

#pragma comment(linker, "/STACK:65777216")
 
#include <algorithm>
#include <iostream>
#include <string>
#include<sstream>
#include<string.h>
#include <cstdio>
#include <complex>
#include <vector>
#include <bitset>
#include <cmath>
#include <queue>
#include<stack>
#include <set>
#include <map>
#include<ctime>
#include<list>

using namespace std;
 
typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<double,double> pdd;
typedef unsigned long long ull;
 
#define FOR(i,a,b) for (int i(a); i < (b); i++)
#define REP(i,n) FOR(i,0,n)
#define SORT(v) sort((v).begin(),(v).end())
#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())
#define CL(a,b) memset(a,b,sizeof(a))
#define pb push_back

vi primes[6][6][10000];

int a[5][5];
int n,res;

void go(int pos){
	if(pos==n) res++;
	else{
		int first_part = pos;
		int val1 = 0;
		REP(i,first_part) val1 = 10 * val1 + a[i][pos];
		//cout<<n<<' '<<first_part<<' '<<a[0][pos]<<' '<<val1<<endl;
		vi &t = primes[n][first_part][val1];
		REP(i,t.size()){
			int val2 = t[i];
			for(int j=n-1;j>=pos;j--){
				a[pos][j] = val2%10;
				val2/=10;
			}
			go(pos+1);
		}
	}
}

int main(){
#ifdef LocalHost
    freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
#endif
	vi pp;

	int cnt=0;
	for(int i=2;i<=99999;i++){
		bool pr = 1;
		for(int j=2;j*j<=i;j++)if(i%j==0){pr=0;break;}
		if(pr){
			pp.pb(i);
			stringstream ss;
			ss<<i;
			string s = ss.str();
			FOR(len,s.size(),6){

				FOR(first_part,1,s.size()){
					int val1=0,val2=0;
					REP(jj,first_part) val1 = 10 * val1 + s[jj] - '0';
					FOR(jj,first_part,s.size()) val2 = 10 * val2 + s[jj] - '0';
					primes[len][first_part][val1].pb(val2);
					cnt++;
				}

				s = "0" + s;
			}
		}
	}
	//cout<<pp.size()<<endl;


	//cout<<primes[2][1][9][9].size()<<endl;

	int tc;
	cin>>tc;
	REP(TC,tc){
		string s;
		cin>>s;
		n=s.size();
		REP(i,n) a[0][i]=s[i]-'0';
		res=0;
		go(1);
		cout<<res<<endl;
	}

#ifdef LocalHost
	cout<<endl<<endl<<"TIME: "<<clock()<<endl;
#endif
    return 0;
}
