#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <cassert>
using namespace std;
typedef long long ll;

#define REP(i,n) for (int i=0; i<(int)(n); ++i)
#define FOR(i,k,n) for (int i=(k); i<(int)(n); ++i)
#define FOREQ(i,k,n) for (int i=(k); i<=(int)(n); ++i)
#define FORIT(i,c) for(__typeof((c).begin())i=(c).begin();i!=(c).end();++i)
#define SZ(v) (int)((v).size())
#define MEMSET(v,h) memset((v),(h),sizeof(v))

bool message[2020][2020];

map<string, int> nid;
string names[2020];

int m;
void reg(string s) {
    if (nid.count(s)) return;
    nid[s] = m;
    names[m] = s;
    m++;
}

int sid[1010], tid[1010], tt[1010];

int main() {
    int N, D;
    while (cin >> N >> D) {
        nid.clear();
        m = 0;

        REP(i, N) {
            int d;
            string s, t; cin >> s >> t >> d;
            reg(s);
            reg(t);
            sid[i] = nid[s];
            tid[i] = nid[t];
            tt[i] = d;
        }

        MEMSET(message, false);
        REP(j, N) REP(i, N) {
            if (sid[i] == tid[j] && tid[i] == sid[j])
            if (0 < tt[j] - tt[i] && tt[j] - tt[i] <= D) {
                message[sid[i]][tid[i]] = message[tid[i]][sid[i]] = true;
            }
        }

        int cnt = 0;
        REP(j, m) REP(i, j) if (message[i][j]) cnt++;
        cout << cnt << endl;
        REP(j, m) REP(i, j) if (message[i][j]) {
            cout << names[i] << " " << names[j] << endl;
        }
    }
}

----

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <cassert>
using namespace std;
typedef long long ll;

#define REP(i,n) for (int i=0; i<(int)(n); ++i)
#define FOR(i,k,n) for (int i=(k); i<(int)(n); ++i)
#define FOREQ(i,k,n) for (int i=(k); i<=(int)(n); ++i)
#define FORIT(i,c) for(__typeof((c).begin())i=(c).begin();i!=(c).end();++i)
#define SZ(v) (int)((v).size())
#define MEMSET(v,h) memset((v),(h),sizeof(v))

int main() {
    int N, M;
    while (scanf("%d%d", &N, &M) != EOF) {
        map<int, int> c1, c2;
        map<pair<int, int>, int> b1, b2;
        REP(i, N) {
            int a, b; scanf("%d%d", &a, &b);
            c1[b]++;
            b1[make_pair(a, b)]++;
        }
        REP(i, M) {
            int a, b; scanf("%d%d", &a, &b);
            c2[b]++;
            b2[make_pair(a, b)]++;
        }

        int cres = 0, bres = 0;
        FORIT(ct, c1) cres += min(ct->second, c2[ct->first]);
        FORIT(bt, b1) bres += min(bt->second, b2[bt->first]);
        printf("%d %d\n", cres, bres);
    }
}

----

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <cassert>
using namespace std;
typedef long long ll;

#define REP(i,n) for (int i=0; i<(int)(n); ++i)
#define FOR(i,k,n) for (int i=(k); i<(int)(n); ++i)
#define FOREQ(i,k,n) for (int i=(k); i<=(int)(n); ++i)
#define FORIT(i,c) for(__typeof((c).begin())i=(c).begin();i!=(c).end();++i)
#define SZ(v) (int)((v).size())
#define MEMSET(v,h) memset((v),(h),sizeof(v))

struct Splay {
    struct Node {
        ll key;
        Node *lhs, *rhs;
        ll cnt_memo;

        Node(ll key = 0, Node *lhs = NULL, Node *rhs = NULL)
            : key(key), lhs(lhs), rhs(rhs) { cnt_memo = -1; }
    };
    Node *root;

    void forget(Node *t) {
        if (t == NULL) return;
        t->cnt_memo = -1LL;
    }
    ll cnt(Node *t) {
        if (t == NULL) return 0LL;
        if (t->cnt_memo >= 0) return t->cnt_memo;
        return t->cnt_memo = 1LL + cnt(t->lhs) + cnt(t->rhs);
    }

    Node *splay(ll x, Node *t) {
        if (t == NULL) return NULL;
        Node n, *l = &n, *r = &n, *s = NULL;

        for (;;) {
            forget(t); forget(s); forget(r);

            if (x < t->key) {
                if (t->lhs != NULL && x < t->lhs->key) {
                    s = t->lhs;
                    t->lhs = s->rhs;
                    s->rhs = t;
                    t = s;
                }
                if (t->lhs == NULL) break;
                r->lhs = t;
                r = t;
                t = t->lhs;
            } else if (x > t->key) {
                if (t->rhs != NULL && x > t->rhs->key) {
                    s = t->rhs;
                    t->rhs = s->lhs;
                    s->lhs = t;
                    t = s;
                }
                if (t->rhs == NULL) break;
                l->rhs = t;
                l = t;
                t = t->rhs;
            } else {
                break;
            }
        }
        forget(l); forget(r); forget(t);
        l->rhs = t->lhs;
        r->lhs = t->rhs;
        t->lhs = n.rhs;
        t->rhs = n.lhs;
        return t;
    }

    Node *find(ll x) {
        if (root == NULL) return NULL;
        root = splay(x, root);
        if (x == root->key) return root;
        else return NULL;
    }

    void insert(ll x) {
        if (root == NULL) {
            root = new Node(x, NULL, NULL);
        } else {
            root = splay(x, root);
            if (x < root->key) {
                Node *t = new Node(x, root->lhs, root);
                root->lhs = NULL;
                root = t;
            } else if (x > root->key) {
                Node *t = new Node(x, root, root->rhs);
                root->rhs = NULL;
                root = t;
            }
        }
    }

    void erase(ll x) {
        if (!find(x)) return;
        if (!root->lhs) {
            root = root->rhs;
        } else {
            Node *t = root->rhs;
            root = splay(x, root->lhs);
            root->rhs = t;
        }
    }

    ll get_nth(ll n, Node *t) {
        ll lc = cnt(t->lhs);
        if (lc == n) return t->key;
        else if (lc < n) return get_nth(n-lc-1, t->rhs);
        else return get_nth(n, t->lhs);
    }
    ll get_nth(ll n) {
        return get_nth(n, root);
    }
    
    Splay() : root(NULL) {}
};

Splay sp[30];

int main() {
    int K;
    char s[222];
    while (scanf("%d %s", &K, s) != EOF) {
        REP(i, 30) sp[i] = Splay();
        int n = strlen(s);
        REP(i, K) REP(j, n) sp[s[j]-'a'].insert(i*n+j);
        int Q; scanf("%d", &Q);
        while (Q--) {
            int n; char c; scanf("%d %c", &n, &c);
            ll v = sp[c-'a'].get_nth(n-1);
            sp[c-'a'].erase(v);
        }
        REP(i, K) REP(j, n) {
            if (sp[s[j]-'a'].find(i*n+j) != NULL) {
                putchar(s[j]);
            }
        }
        puts("");
    }
}

----

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <cassert>
using namespace std;
typedef long long ll;

#define REP(i,n) for (int i=0; i<(int)(n); ++i)
#define FOR(i,k,n) for (int i=(k); i<(int)(n); ++i)
#define FOREQ(i,k,n) for (int i=(k); i<=(int)(n); ++i)
#define FORIT(i,c) for(__typeof((c).begin())i=(c).begin();i!=(c).end();++i)
#define SZ(v) (int)((v).size())
#define MEMSET(v,h) memset((v),(h),sizeof(v))

bool is_palin[2222][2222];
char s[2222];

ll cntA[2222], cntB[2222];

int main() {
    while (scanf(" %s", s) != EOF) {
        int n = strlen(s);
        MEMSET(is_palin, false);
        REP(i, n) {
            is_palin[i][i] = true;
            for (int j = 1; i-j >= 0 && i+j < n; ++j) {
                if (s[i-j] != s[i+j]) break;
                is_palin[i-j][i+j] = true;
            }
        }
        REP(i, n) {
            for (int j = 0; i-j >= 0 && i+1+j < n; ++j) {
                if (s[i-j] != s[i+1+j]) break;
                is_palin[i-j][i+1+j] = true;
            }
        }
        // REP(j, n) REP(i, j+1) cout << i <<" " << j<<" => "<<is_palin[i][j]<<endl;

        MEMSET(cntA, 0);
        MEMSET(cntB, 0);

        cntA[0] = 1;
        FOR(i, 1, n) {
            cntA[i] = cntA[i-1];
            FOREQ(j, 0, i) if (is_palin[j][i]) cntA[i]++;
        }
        for (int i=n-1; i>=0; --i) {
            cntB[i] = 0;
            FOREQ(j, i, n-1) if (is_palin[i][j]) cntB[i]++;
        }

        ll res = 0LL;
        REP(i, n-1) res += cntA[i]*cntB[i+1];
        cout << res << endl;
    }
}

----

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <cassert>
using namespace std;
typedef long long ll;

#define REP(i,n) for (int i=0; i<(int)(n); ++i)
#define FOR(i,k,n) for (int i=(k); i<(int)(n); ++i)
#define FOREQ(i,k,n) for (int i=(k); i<=(int)(n); ++i)
#define FORIT(i,c) for(__typeof((c).begin())i=(c).begin();i!=(c).end();++i)
#define SZ(v) (int)((v).size())
#define MEMSET(v,h) memset((v),(h),sizeof(v))

ll best[100020][2], bsrc[100020][2];

int main() {
    int N;
    while (scanf("%d", &N) != EOF) {
        map<int, vector<pair<ll, int> > > mpl;
        REP(i, N) {
            int col, height; scanf("%d%d", &col, &height);
            mpl[col].push_back(make_pair(height, i));
        }

        REP(i, 100020) {
            best[i][0] = best[i][1] = -1LL<<60;
        }
        MEMSET(bsrc, -1);

        FORIT(vt, mpl) {
            sort(vt->second.begin(), vt->second.end());
            reverse(vt->second.begin(), vt->second.end());
            ll h = 0LL;
            REP(i, SZ(vt->second)) {
                h += vt->second[i].first;
                if (best[i+1][0] < h) {
                    best[i+1][1] = best[i+1][0];
                    bsrc[i+1][1] = bsrc[i+1][0];
                    best[i+1][0] = h;
                    bsrc[i+1][0] = vt->first;
                } else if (best[i+1][1] < h) {
                    best[i+1][1] = h;
                    bsrc[i+1][1] = vt->first;
                }
            }
        }

        ll res = 0LL, bi = -1, btype = -1;
        ll c0 = -1, c1 = -1;
        FOREQ(i, 1, N) {
            ll cand0 = best[i][0] + best[i][1];
            if (cand0 > res) {
                res = cand0; bi = i; btype = 0;
                c0 = bsrc[bi][0]; c1 = bsrc[bi][1];
            }

            REP(u0, 2) REP(u1, 2) if (bsrc[i][u0] != bsrc[i+1][u1]) {
                ll cand1 = best[i][u0] + best[i+1][u1];
                if (cand1 > res) {
                    res = cand1; bi = i; btype = 1;
                    c0 = bsrc[bi][u0]; c1 = bsrc[bi+1][u1];
                }
            }
        }

        printf("%I64d\n", res);
        if (btype == 0) {
            printf("%I64d\n", 2*bi);

            REP(i, bi) {
                if (i) printf(" ");
                printf("%d %d", 1+mpl[c0][i].second, 1+mpl[c1][i].second);
            }
            puts("");
        } else {
            printf("%I64d\n", 2*bi+1);

            REP(i, bi) {
                printf("%d %d ", 1+mpl[c1][i].second, 1+mpl[c0][i].second);
            }
            printf("%d\n", 1+mpl[c1][bi].second);
        }
    }
}