#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

vector<int> v;
int N, i, j, nneed, nextra, li, ls, mid, answer;

int ok(int M) {
	j = nneed = M;

	//fprintf(stderr, "Testing %d\n", M);
	
	for (i = N - 1; i >= 0; i--) {
		//fprintf(stderr, "  before i=%d (%d): j=%d nneed=%d\n", i, v[i], j, nneed);

		if (v[i] < nneed)
			nneed -= v[i];
		else {
			nextra = v[i] - nneed;
			if (nextra > (j - nneed))
				nextra = j - nneed;
			j--;
			if (j == 0)
				break;
			
			nneed = j - nextra;
			if (nneed == 0) {
				j--;
				if (j == 0)
					break;
				nneed = j;
			}
		}
	}

	//fprintf(stderr, "  j final=%d\n", j);
	return (j == 0);
}

int main() {
	freopen("lumanari.in", "r", stdin);
	scanf("%d", &N);
	v.resize(N);
	for (i = 0; i < N; i++)
		scanf("%d", &(v[i]));

	sort(v.begin(), v.end());
	
	li = 1; ls = N; answer = 0;
	while (li <= ls) {
		mid = (li + ls) / 2;
		if (ok(mid)) {
			answer = mid;
			li = mid + 1;
		} else
			ls = mid - 1;
	}
	
	freopen("lumanari.out", "w", stdout);
	printf("%d\n", answer);
	
	return 0;
}
