#include <stdio.h>
#include <string.h>
#include <time.h>

#define NMAX 72

long long cnt_x[NMAX][NMAX], cnt_total[NMAX], C[NMAX][NMAX], tmp, tmp2;
int N, X, P, i, j, x, y, z;

void ComputeComb() {
	int i, j;

	memset(C, 0, sizeof(C));
	C[0][0] = 1 % P;

	for (i = 1; i < NMAX; i++) {
		C[i][0] = 1 % P;
		for (j = 1; j <= i; j++)
			C[i][j] = (C[i - 1][j] + C[i - 1][j - 1]) % P;
	}
}

int main() {
	int tstart = clock();
	
	freopen("radacina2.in", "r", stdin);
	scanf("%d %d %d", &N, &X, &P);
	ComputeComb();
	
	memset(cnt_x, 0, sizeof(cnt_x));
	memset(cnt_total, 0, sizeof(cnt_total));
	
	cnt_x[1][1] = 1 % P;
	cnt_total[1] = 1 % P;
	
	for (i = 2; i <= N; i++) {
		for (x = 1; x <= i; x++) {
			for (j = 1; j <= i - 1; j++) {
				if (j < i - j)
					continue;
				for (y = 1; y <= j; y++) {
					if (y > x || j - y > i - x)
						continue;
					tmp = (C[x - 1][y - 1] * C[i - x][j - y]) % P;
					tmp = (tmp * cnt_x[j][y]) % P;

					if (j > i - j)
						tmp2 = cnt_total[i - j];
					else {
						tmp2 = 0;
						for (z = 1; z <= x - y; z++)
							tmp2 = (tmp2 + cnt_x[i - j][z]) % P;
					}

					tmp = (tmp * tmp2) % P;
					tmp = (tmp * C[i - 2][j - 1]) % P;
					cnt_x[i][x] = (cnt_x[i][x] + tmp) % P;
				}
			}

			cnt_total[i] = (cnt_total[i] + cnt_x[i][x]) % P;
		}
	}
	
	freopen("radacina2.out", "w", stdout);
	printf("%lld\n", cnt_x[N][X]);
	
	fprintf(stderr, "Duration=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);
	return 0;
}
