import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class coffin_dg_wrong8 {

	public static void main(String[] args) throws IOException {
		new coffin_dg_wrong8().run();
	}
	
	private void run() throws IOException {
		Scanner sc = new Scanner(new File("coffin.in"));
		PrintWriter pw = new PrintWriter("coffin.out");
		
		long t = sc.nextInt();
		long c1 = sc.nextInt();
		long c2 = sc.nextInt();
		int a1 = sc.nextInt();
		int a2 = sc.nextInt();
		int[] r = arrayOf2(a2, 2, a1, 1);
		long a = 0;
		long b = 0;
		long c = 0;
		for (int i = 0; i < a1 + a2; i++) {
			a += t;
			b = Math.max(a, b);
			if (r[i] == 1)
				b += c1;
			else
				b += c2;
			c = Math.max(b, c) + t;
		}
		
		pw.println(c);
		
		sc.close();
		pw.close();
	}

	private int[] solve(int p, int q, long c1, long c2, long t) {
		int n = p + q;
		if (n == 0)
			return new int[] {};
		if (p == 0)
			return arrayOf(q, 2);
		if (q == 0)
			return arrayOf(p, 1);
		if (c1 >= t && c2 >= t)
			return arrayOf2(p, 1, q, 2);
		if (c1 <= t && c2 <= t)	
			return arrayOf2(p, 1, q, 2);
		if (q == 1)
			return arrayOf2(q, 2, p, 1);
		
		if (q > n / 2) {
			int r = n - q + 1;
			int b = (q + r - 1) / r;
			int xb = n - r * b + 1;
			int xb1 = r * b - q;
			long nc1 = c2 * (b - 1) + c1    - b * t + t;
			long nc2 = c2 * b + c1     - (b + 1) * t + t;
			//int[] rs = solve(xb1, xb, nc1, nc2, t);
			int[] rs = arrayOf2(xb1, 1, xb, 2);
			int[] res = new int[n];
			int c = 0;
			for (int i = 0; i < rs.length; i++) {
				for (int j = 0; j < b - 1 + (rs[i] == 1 ? 0 : 1); j++)
					res[c++] = 2;
				if (i < rs.length - 1)
					res[c++] = 1;
			}
			return res;
		} else {
			int r = q - 1;
			int b = (n - q + r - 1) / r;
			int yb = n - r * b - 1;
			int yb1 = r * b + q - n;
			long nc1 = c1 * b + c2    - (b + 1) * t + t;
			long nc2 = c1 * (b - 1) + c2   - b * t + t;
			//int[] rs =  solve(yb, yb1, nc1, nc2, t);
			int[] rs = arrayOf2(yb1, 2, yb, 1);
			int[] res = new int[n];
			int c = 0;
			for (int i = 0; i < rs.length; i++) {
				res[c++] = 2;
				for (int j = 0; j < b - 1 + (rs[i] == 1 ? 1 : 0); j++)
					res[c++] = 1;
			}
			res[c++] = 2;
			return res;
		}
	}

	private int[] arrayOf2(int n1, int x1, int n2, int x2) {
		int[] r = new int[n1 + n2];
		Arrays.fill(r, 0, n1, x1);
		Arrays.fill(r, n1, n1 + n2, x2);
		return r;
	}

	private int[] arrayOf(int n, int x) {
		int[] r = new int[n];
		Arrays.fill(r, x);
		return r;
	}

}
