//  ""
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru
//  

import java.io.*;
import java.util.*;

public class equation_ft_wrong implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "equation";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}

    int gcd(int a, int b) {
    	if (b == 0) {
    		return a;
    	} else {
    		return gcd(b, a % b);
    	}
    }                        

	public void solve() {
		int a = in.nextInt();
		int b = in.nextInt();
		int c = in.nextInt();
		int d = in.nextInt();
		int v = in.nextInt();
		myAssert(Math.abs(a) <= 1000, "a is out of bounds: " + a);
		myAssert(Math.abs(b) <= 1000, "b is out of bounds: " + b);
		myAssert(Math.abs(c) <= 1000, "c is out of bounds: " + c);
		myAssert(Math.abs(d) <= 1000, "d is out of bounds: " + d);
		myAssert(Math.abs(v) <= 1000, "v is out of bounds: " + v);
		int num = v * d - b;
		int den = a - v * c;
		if (den == 0) {
			if (num == 0) {
				out.println("MULTIPLE");
			} else {
				out.println("NONE");
			}
			return;
		}
		int g = gcd(Math.abs(num), Math.abs(den));

		num /= g;
		den /= g;

		if (den < 0) {
			den = -den;
			num = -num;
		}

		if (c * (v * d - b) == d * (v * c - a)) {
			out.println("NONE");
		} else {
			out.println("X = " + num + "/" + den);
		}

	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public equation_ft_wrong() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new equation_ft_wrong()).start();
	}

}                       