//  " "
// 7- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class height_ft implements Runnable {

	public final static int MAX_N = (int) 2e5;

	private Scanner in;
	private PrintWriter out;
	String fname = "height";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               

	public void solve() {
		int l1 = in.nextInt();
		int l2 = in.nextInt();
		int l3 = in.nextInt();
		myAssert(1 <= l1 && l1 <= 1000, "l1 is out of bounds: " + l1);
		myAssert(1 <= l2 && l2 <= 1000, "l2 is out of bounds: " + l2);
		myAssert(1 <= l3 && l3 <= 1000, "l3 is out of bounds: " + l3);
		myAssert(l1 < l2 + l3 && l2 < l1 + l3 && l3 < l1 + l2, "Triangle inequality does not hold");
		int max = Math.max(Math.max(l1, l2), l3);
		double p = 0.5 * (l1 + l2 + l3);
		double s = Math.sqrt(p * (p - l1) * (p - l2) * (p - l3));
		out.println(2 * s / max);
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public height_ft() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new height_ft()).start();
	}

}                       