import java.io.*;
import java.util.*;

public class school_as implements Runnable {

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("school.in"));
        PrintWriter out = new PrintWriter(new File("school.out"));

        int a = in.nextInt();
        int b = in.nextInt();
        int c = in.nextInt();
        int d = in.nextInt();

        int n = (a + 1) * (b + 1) * (c + 1) * (d + 1);
        int[] z = new int[]{a + 1, b + 1, c + 1, d + 1};
        int[][][] next = new int[n][4][27];
        int[][] nl = new int[n][4];
        for (int i = 0; i < n; i++) {
            int[] y = new int[4];
            int v = i;
            for (int j = 0; j < 4; j++) {
                y[j] = v % z[j];
                v /= z[j];
            }
            for (int j = 0; j < 4; j++) {
                if (y[j] < z[j] - 1) {
                    for (int k = 0; k < 27; k++) {
                        int[] x = new int[4];
                        x[j] = 1;
                        int w = k;
                        for (int l = 0; l < 4; l++) {
                            if (l != j) {
                                x[l] = w % 3 - 1;
                                w /= 3;
                            }
                        }

                        boolean ok = true;
                        int u = 0;
                        int base = 1;
                        for (int l = 0; l < 4; l++) {
                            u += (y[l] + x[l]) * base;
                            base *= z[l];
                            if (y[l] + x[l] < 0 || y[l] + x[l] >= z[l]) {
                                ok = false;
                                break;
                            }
                        }

                        if (ok) {
                            next[i][j][nl[i][j]] = u;
                            nl[i][j]++;
                        }
                    }
                }
            }
        }

        double[] e = new double[n];
        Arrays.fill(e, 1e10);
        e[n - 1] = 0;
        double[] f = new double[n];
        while (true) {
            double[] tmp = e; e = f; f = tmp;
            double dx = 0;
            for (int i = 0; i < n - 1; i++) {
                e[i] = Double.POSITIVE_INFINITY;
                for (int j = 0; j < 4; j++) {
                    if (nl[i][j] != 0) {
                        double u = 0;
                        for (int k = 0; k < nl[i][j]; k++) {
                            u += f[next[i][j][k]];
                        }
                        u /= nl[i][j];
                        e[i] = Math.min(u + 1, e[i]);
                    }
                }
                dx = Math.max(dx, Math.abs(e[i] - f[i]));
            }
            if (dx < 1e-15) {
                break;
            }
        }

        out.printf("%.10f\n", e[0]);

/*
        double[] tmp = e; e = f; f = tmp;
        double dx = 0;
        for (int i = 0; i < n - 1; i++) {
            int v = i;
            for (int j = 0; j < 4; j++) {
//                out.print(v % z[j] + " ");
                v /= z[j];
            }

            e[i] = Double.POSITIVE_INFINITY;
            int toRead = 0;
            for (int j = 0; j < 4; j++) {
                if (nl[i][j] != 0) {
                    double u = 0;
                    for (int k = 0; k < nl[i][j]; k++) {
                        u += f[next[i][j][k]];
                    }
                    u /= nl[i][j];
                    if (u + 1 < e[i]) {
                        e[i] = u + 1;
                        toRead = j;
                    }
                }
            }
//            out.println(e[i] + " " + toRead);
            dx = Math.max(dx, Math.abs(e[i] - f[i]));
        }
*/

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
    	Locale.setDefault(Locale.US);
        new Thread(new school_as()).start();
    }
}

