import java.io.*;
import java.util.*;
import java.math.*;

//Problem "Words"
//11th Personal Internet Olympiad, season 2007-2008
//Problem Author: Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Maxim Buzdalov, buzdalov@rain.ifmo.ru

public class words_mb {
    public static void main(String[] args) throws IOException {
	Scanner in = new Scanner(new File("words.in"));
	long n = in.nextInt();
	long k = in.nextInt();
	in.close();
	
	long mod = 1000000007;
	assert 1 <= n && n <= 1000000000 : "N is out of bounds";
	assert 1 <= k && k <= 1000000000 : "K is out of bounds";
	BigInteger MOD = BigInteger.valueOf(mod);
	long powN = BigInteger.valueOf(k).modPow(BigInteger.valueOf(n), MOD).longValue();
	long powH = BigInteger.valueOf(k).modPow(BigInteger.valueOf((n + 1) / 2), MOD).longValue();
	long div2 = BigInteger.valueOf(2).modInverse(BigInteger.valueOf(mod)).longValue();
	
	PrintWriter out = new PrintWriter("words.out");
	out.println(((powN + powH) * div2) % mod);
	out.close();
    }
}
