#include <iostream>
#include <fstream>
#include <cassert>

//Problem "Words"
//11th Personal Internet Olympiad, season 2007-2008
//Problem Author: Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Maxim Buzdalov, buzdalov@rain.ifmo.ru

//A stupid brute force solution.

typedef long long int64;

int reverse(int x, int n, int k)
{
    int rv = 0;
    for (int i = 0; i < n; ++i) {
	rv = k * rv + x % k;
	x /= k;
    }
    return rv;
}

int main()
{
    int n, k;
    std::ifstream("words.in") >> n >> k;
    assert(1 <= n && n <= 1000000000);
    assert(1 <= k && k <= 1000000000);

    int uplim = 1;
    for (int i = 0; i < n; ++i) {
	uplim *= k;
    }
    int count = 0;
    for (int i = 0; i < uplim; ++i) 
    {
	count += reverse(i, n, k) >= i;
    }
    
    std::ofstream("words.out") << count % 1000000007 << std::endl;
    return 0;
}
