import java.io.*;
import java.util.*;

public class palin_af_partial1 implements Runnable {
	public static void main(String[] args) {
		new Thread(new palin_af_partial1()).start();
	}
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(-1);
		}
		out.close();
	}
	
	String FNAME = "palin";
	
	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;
	
	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}
	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	
	void solve() throws IOException {
		int k = nextInt();
		String s = nextToken();
		int[] c = new int[26];
		for (int i = 0; i < s.length(); i++) {
			c[s.charAt(i) - 'a']++;
		}
		int max = 0;
		for (int i = 0; i < 26; i++) {
			max = Math.max(c[i], max);
		}
		out.println(s.length() - max);
	}
}
