import java.io.*;
import java.util.*;

public class palin_af_partial2 implements Runnable {
	public static void main(String[] args) {
		new Thread(new palin_af_partial2()).start();
	}
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(-1);
		}
		out.close();
	}
	
	String FNAME = "palin";
	
	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;
	
	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}
	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	int[] genPerm(int n, int k) {
		int[] ans = new int[n];
		if (k == 0) {
			for (int i = 0; i < n; i++) {
				ans[i] = i;
			}
		} else {
			int[] tans = genPerm((n + 1) / 2, k - 1);
			for (int i = 0; i < tans.length; i++) {
				ans[i] = tans[i];
				ans[n - i - 1]  = tans[i];
			}
		}
		return ans;
	}
	
	void solve() throws IOException {
		int k = nextInt();
		String s = nextToken();
		int n = s.length();
		int l = (n + (1 << k) - 1) >> k;
		if ((n + (1 << (k - 1)) - 1) >> (k - 1) <= 1) {
			out.println(-1);
			return;
		}
		int[] p = genPerm(n , k);
		int[][] c = new int[l][26];
		for (int i = 0; i < n; i++) {
			c[p[i]][s.charAt(i) - 'a']++;
		}
		int ans = n;
		
		int[] gs = new int[l];
		while (true) {
			boolean bad = true;
			for (int i = 0; i < l / 2; i++) {
				bad &= gs[i] == gs[l - i - 1];
				if (!bad) break;
			}
			int tans = n;
			if (!bad) {
				for (int i = 0; i < l; i++) {
					tans -= c[i][gs[i]];
				}
			}
			
			ans = Math.min(ans, tans);
			
			int i = 0;
			while (i < l) {
				gs[i]++;
				if (gs[i] < 26) {
					break;
				} else {
					gs[i] = 0;
				}
				i++;
			}
			if (i == l) break;
			
		}
		out.println(ans);
	}
}
