import java.io.*;
import java.util.*;

public class permutominoes_as_short implements Runnable {

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("permutominoes.in"));
        PrintWriter out = new PrintWriter(new File("permutominoes.out"));

        int n = in.nextInt();
        long[][][] a = new long[n + 1][n + 1][4];
        a[2][1][3] = 1;

        for (int i = 2; i < n; i++) {
            for (int j = 1; j < n; j++) {
                a[i + 1][j + 1][1] += a[i][j][1];
                a[i + 1][j + 1][3] += a[i][j][3];
                for (int k = 1; k <= j; k++) {
                    a[i + 1][k][0] += a[i][j][0];
                    a[i + 1][k][0] += a[i][j][1];
                    a[i + 1][k][2] += a[i][j][2];
                    a[i + 1][k][2] += a[i][j][3];

                    a[i + 1][k][0] += a[i][j][0];
                    a[i + 1][k][0] += a[i][j][2];
                    a[i + 1][k][1] += a[i][j][1];
                    a[i + 1][k][1] += a[i][j][3];
                }
                a[i + 1][j + 1][2] += a[i][j][2];
                a[i + 1][j + 1][3] += a[i][j][3];
            }
        }

        long r = 0;
        for (int i = 0; i <= n; i++) {
            for (int j = 0; j < 4; j++) {
                r += a[n][i][j];
            }
        }
        out.println(r);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new permutominoes_as_short()).start();
    }
}
