import java.io.*;
import java.util.*;

//  " "
// 11- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , buzdalov@rain.ifmo.ru

public class hamming_mb {
    static Map<Long, Integer> answers = new HashMap<Long, Integer>();
    static final long LIMIT = 1000000000000000000L;

    static {
        TreeSet<Long> allHamming = new TreeSet<Long>();

        long current = 1;
        for (int i = 0; current <= LIMIT; i++) {
            long save2 = current;
            for (int j = 0; current <= LIMIT; j++) {
                long save3 = current;
                for (int k = 0; current <= LIMIT; k++) {
                    allHamming.add(current);
                    current *= 5;
                }
                current = 3 * save3;
            }
            current = 2 * save2;
        }

        int cur = 1;
        for (Long v : allHamming) {
            answers.put(v, cur++);
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader("hamming.in"));
        PrintWriter out = new PrintWriter("hamming.out");
        int n = Integer.parseInt(br.readLine());
        for (int i = 0; i < n; i++) {
            long v = Long.parseLong(br.readLine());
            Integer a = answers.get(v);
            out.println(a == null ? "Not in sequence" : a);
        }
        br.close();
        out.close();
    }
}