//  " -"
// 11- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class spbmetro_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new spbmetro_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new InputStreamReader(new FileInputStream(FILENAME + ".in"), "cp1251"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "spbmetro";
	
	String[] line1 = new String[] { 
		" ",
		" ",
		"",
		" ",
		"",
		"",
		"  - 1",
		"",
		"",
		" ",
		"",
		" ",
		"",
		"",
		" ",
		"",
		"",
		" ",
		""};

	String[] line2 = new String[] { 
			"",
			"¨",
			"",
			" ",
			"",
			" ",
			"",
			"  - 2",
			" ",
			" ",
			"",
			"",
			"ר ",
			"",
			"",
			"",
			" ",
			""};

	String[] line3 = new String[] { 
			"",
			"",
			"",
			"",
			"",
			"   - 1",
			"",
			" ",
			"",
			""};

	String[] line4 = new String[] { 
			" ",
			" ",
			"",
			"",
			"   - 2",
			" ",
			"",
			"",
			"",
			"",
			" ",
			" ",
			" "};

	String[] trans = new String[] {
			"  - 1",
			"  - 2",
			"",
			"",
			" ",
			"",
			" ",
			"",
			" ",
			" ",
			"   - 1",
			"   - 2"};
	
	public void solve() throws IOException {
		HashMap<String, Integer> hm = new HashMap<String, Integer>();
		int nst = 0;
		for (int i = 0; i < line1.length; i++) {
			hm.put(line1[i], nst++);
		}
		for (int i = 0; i < line2.length; i++) {
			hm.put(line2[i], nst++);
		}
		for (int i = 0; i < line3.length; i++) {
			hm.put(line3[i], nst++);
		}
		for (int i = 0; i < line4.length; i++) {
			hm.put(line4[i], nst++);
		}
		int[][] tab = new int[nst][nst];
		for (int i = 0; i < nst; i++) {
			Arrays.fill(tab[i], Integer.MAX_VALUE / 2);
		}
		int f = 0;
		for (int i = 0; i < line1.length - 1; i++) {
			tab[i][i + 1] = 1;
			tab[i + 1][i] = 1;
		}
		f += line1.length;
		for (int i = f; i < f + line2.length - 1; i++) {
			tab[i][i + 1] = 1;
			tab[i + 1][i] = 1;
		}
		f += line2.length;
		for (int i = f; i < f + line3.length - 1; i++) {
			tab[i][i + 1] = 1;
			tab[i + 1][i] = 1;
		}
		f += line3.length;
		for (int i = f; i < f + line4.length - 1; i++) {
			tab[i][i + 1] = 1;
			tab[i + 1][i] = 1;
		}
		for (int i = 0; i < trans.length / 2; i++) {
			tab[hm.get(trans[2 * i])][hm.get(trans[2 * i + 1])] = 0;
			tab[hm.get(trans[2 * i + 1])][hm.get(trans[2 * i])] = 0;
		}
		for (int i = 0; i < nst; i++) {
			for (int j = 0; j < nst; j++) {
				for (int k = 0; k < nst; k++) {
					if (tab[j][k] > tab[j][i] + tab[i][k]) {
						tab[j][k] = tab[j][i] + tab[i][k];
					}
				}
			}
		}
		String s1 = br.readLine();
		String s2 = br.readLine();
		out.println(tab[hm.get(s1)][hm.get(s2)]);
	}
}
