import java.io.*;
import java.util.*;
import java.math.*;

public class string_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new string_aa()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
		}
	}

	private void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String nextToken(String delim) {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), delim);
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken(delim);
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	int nextInt(String delim) {
		return Integer.parseInt(nextToken(delim));
	}

	String FILENAME = "string";

	void solve() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		int n = nextInt();
		int k = nextInt();
		char[] s = nextToken().toCharArray();
		TreeSet<Integer>[] ts = new TreeSet[26];
		for (int i = 0; i < ts.length; i++) {
			ts[i] = new TreeSet<Integer>();
		}
		int maxLen = -1;
		int pos = 0;
		int last = -1;
		for (int i = 0; i < s.length; i++) {
			if (ts[s[i] - 'a'].size() == k) {
				last = Math.max(last, ts[s[i] - 'a'].pollFirst());
			}
			ts[s[i] - 'a'].add(i);
			if (i - last > maxLen) {
				maxLen = i - last;
				pos = last + 1;
			}
		}
		out.println(maxLen + " " + (pos + 1));
		out.close();
	}
}
