//  "  "
// 11- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class again_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new again_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "again";

	public void solve() throws IOException {
		String s = nextToken();
		myAssert(s.length() <= 100, "Wrong length");
		int[] a = new int[256];
		for (int i = 0; i < s.length(); i++) {
			myAssert(s.charAt(i) >= 'a' && s.charAt(i) <= 'z', "Wrong character");
			a[s.charAt(i)]++;
		}
		Arrays.sort(a);
		int i = 0;
		while (a[i] == 0) i++;
		out.println(a[255] - a[i]);
	}
}
