import java.io.*;
import java.util.*;

public class btp_at implements Runnable {
	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;

	class Trip {

		public int r, r1, r2;
		
		Trip(int r, int r1, int r2) {
			this.r = r;
			this.r1 = r1;
			this.r2 = r2;
		}
		
		public String toString() {
			return r + " " + r1 + " " + r2;
		}
	}
	
	private ArrayList<Trip> list;
	
	public void make(int value, int count) {
		for(int i = 0; i < count - 1; ++i) {
			list.add(new Trip(value, value, value));
		}
	}
	
	public void outAns() {
		for(Trip p : list) {
			out.println(p);
		}
	}
	
	public void solve() throws Exception {
		int n = nextInt();
		int r = nextInt();
		HashMap<Integer, Integer> m = new HashMap<Integer, Integer>();
		list = new ArrayList<Trip>();
		TreeSet<Integer> bad = new TreeSet<Integer>();
		int countDiff = 0;
		int all = 0;
		for(int i = 0; i < n; ++i) {
			int ri = nextInt();
			if (!m.containsKey(ri)) {
				if (ri != r) {
					bad.add(ri);
					++countDiff;
				}
				m.put(ri, 1);
				++all;
			}
			else {
				m.put(ri, m.get(ri) + 1);
			}
		}	
		out.println((countDiff % 2 == 0) ? (countDiff / 2) : (countDiff / 2 + 1));
		if (countDiff == 0) {
			make(r, m.get(r));
		}
		else {
			if (countDiff != all && countDiff > 1) {
				make(r, 2);
			}
			make(r, (countDiff % 2 == 0) ? (countDiff / 2) : (countDiff / 2 + 1) - 1);
			while(bad.size() != 0) {
				if (bad.size() > 1) {
					int r1 = bad.first(); bad.remove(r1);
					int r2 = bad.first(); bad.remove(r2);
					list.add(new Trip(r, r1, r2));
				}
				else {
					int r1 = bad.first(); bad.remove(r1);
					list.add(new Trip(r, r, r1));
				}
			}
			for(int i : m.keySet()) {
					make(i, m.get(i));
			}
		}
		outAns();
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(89);
		} finally {
			out.close();
		}
	}

	private btp_at(String name) {
		try {
			in = new BufferedReader(new FileReader(name + ".in"));
//			in = new BufferedReader(new FileReader("input.txt"));
//			in = new BufferedReader(new InputStreamReader(System.in));
			st = new StringTokenizer("");
			out = new PrintWriter(new File(name + ".out"));
//			out = new PrintWriter(new File("output.txt"));
//			out = new PrintWriter(System.out);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(89);
		}
	}

	public static void main(String[] args) {
		(new Thread(new btp_at("btp"))).start();
	}

	private String nextToken() throws Exception {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}
}