import java.io.*;
import java.util.*;

public class video_as implements Runnable {

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("video.in"));
        PrintWriter out = new PrintWriter(new File("video.out"));

        long d = in.nextLong();
        long b = in.nextLong();
        long t = in.nextLong();
        long p = in.nextLong();

        long k = t * (b - d) / (d * p);
        if (t * (b - d) % (d * p) != 0) {
            k++;
        }

        long lt = 0;
        long rt = d * p;
        while (lt < rt - 1) {
            long m = (lt + rt) / 2;
            long l = t * (b - d) / m;
            if (t * (b - d) % m != 0) {
                l++;
            }
            if (l > k) {
                lt = m;
            } else {
                rt = m;
            }
        }

        out.println(rt);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new video_as()).start();
    }
}
