import java.io.*;
import java.util.*;

public class video_as_double implements Runnable {

    final double EPS = 1e-9;

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("video.in"));
        PrintWriter out = new PrintWriter(new File("video.out"));

        long d = in.nextLong();
        long b = in.nextLong();
        long t = in.nextLong();
        long p = in.nextLong();

        double per = 1.0 * d * p / (b - d);

        double k = Math.ceil(t / per - EPS);
        double tt = t / k;
        double s = tt * (b - d);

        long z = Math.round(s);
        while (z < s - EPS) {
            z++;
        }

        out.println(z);

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(64);
        }
    }

    public static void main(String[] arg) throws IOException {
        new Thread(new video_as_double()).start();
    }
}