import java.io.*;
import java.util.*;
import java.math.*;

public class fun_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new fun_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("fun.in"));
			out = new PrintWriter("fun.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	
	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}
	
	String IOB = "is out of bounds!";
	
	void solve() throws IOException {
		int a = nextInt();
		int b = nextInt();
		myAssert(10000 <= a && a <= 99999, "a " + IOB);
		myAssert(10000 <= b && b <= 99999, "b " + IOB);
		a = (a % 10000) / 10;
		b = (b % 10000) / 10;
		out.println(a + b);
		
	}
}
