//  "k- "
// 12- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class kmin_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new kmin_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "kmin";

	public void solve() throws IOException {
		int n = nextInt();
		myAssert(n >= 1 && n <= (int)1e5, "Wrong n");
		int k = nextInt();
		myAssert(k >= 1 && k <= Math.min(n, 10), "Wrong k");
		int[] min = new int[k];
		Arrays.fill(min, Integer.MAX_VALUE);
		for (int i = 0; i < n; i++) {
			int x = nextInt();
			myAssert(x >= -(int)1e9 && x <= (int)1e9, "Wrong number");
			int j = 0;
			while (j < k && min[j] < x) {
				j++;
			}
			if (j < k) {
				for (int ii = k - 1; ii > j; ii--) {
					min[ii] = min[ii - 1];
				}
				min[j] = x;
			}
		}
		out.println(min[k - 1]);
	}
}
