//  "  "
// 12- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class pac_as implements Runnable {

	public static void main(String[] args) {
		new Thread(new pac_as()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "pac";

	public void solve() throws IOException {
		int n = nextInt();
		int[] x = new int[n];
		int[] y = new int[n];
		int[] r = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = nextInt();
			y[i] = nextInt();
			r[i] = nextInt();
		}
		double ans = Double.POSITIVE_INFINITY;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				int d = (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
				if (d >= (r[i] + r[j]) * (r[i] + r[j])) {
					ans = Math.min(ans, Math.sqrt(d) - r[i] - r[j]);
				} else if (d <= (r[i] - r[j]) * (r[i] - r[j])) {
					ans = Math.min(ans, Math.max(r[i], r[j]) - Math.sqrt(d) - Math.min(r[i], r[j]));
				} else {
					ans = 0;
				}
			}
		}
		out.println(ans);
	}
}
