//Problem "Points and Circles"
//12th Internet Olympiad, season 2007-2008
//Problem Author:  Fedor Tsarev, tsarev@rain.ifmo.ru
//Solution Author: Vladimir Ulyantsev, ulyantsev@rain.ifmo.ru

#include <stdio.h>
#include <math.h>

#define MAXN 1000
#define MAXX 10000
#define INF 2000000000

int n;
int x[MAXN], y[MAXN], r[MAXN];
double ans = INF;

int sqr(int a) {
	return a * a;
}

int main() {
	freopen("pac.in", "r", stdin);
	freopen("pac.out", "w", stdout);
	
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d %d %d", &x[i], &y[i], &r[i]);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (sqrt(sqr(x[i] - x[j]) + sqr(y[i] - y[j])) - r[i] - r[j] < ans) {
				ans = sqrt(sqr(x[i] - x[j]) + sqr(y[i] - y[j])) - r[i] - r[j];
			}
		}
	}

	if (ans < 0) {
		ans = 0;
	}
	printf("%.8f", ans);

	return 0;
}
