//  ""
// 12- -  2007-2008,  
//  :  , akhi@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class snooker_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new snooker_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "snooker";
	
	class Player implements Comparable<Player> {
		String name;
		int n;
		ArrayList<Integer> games = new ArrayList<Integer>();

		public Player(String name, int i) {
			this.name = name;
			this.n = i;
		}

		@Override
		public int compareTo(Player o) {
			int i = 0;
			while (i < games.size() && i < o.games.size()) {
				if (games.get(i) > o.games.get(i)) return -1;
				if (games.get(i) < o.games.get(i)) return 1;
				i++;
			}
			if (i == games.size() && i == o.games.size()) {
				if (n < o.n) return -1;
				if (n > o.n) return 1;
				return 0;
			}
			if (i == games.size()) return 1;
			if (i == o.games.size()) return -1;
			return 0;
		}
		
		@Override
		public String toString() {
			String ans = "";
			ans += name.trim();
			for (int i = 0; i < games.size(); i++) {
				ans += " " + games.get(i);
			}
			return ans;
		}

		public void addGame(int a) {
			games.add(a);
		}

		public void sort() {
			for (int i = 0; i < games.size(); i++) {
				games.set(i, -games.get(i));
			}
			Collections.sort(games);
			for (int i = 0; i < games.size(); i++) {
				games.set(i, -games.get(i));
			}
		}

	}

	public void solve() throws IOException {
		int n = nextInt();
		ArrayList<Player> p = new ArrayList<Player>();
		HashMap<String, Player> hm = new HashMap<String, Player>();
		for (int i = 0; i < n; i++) {
			String s = br.readLine();
			st = new StringTokenizer(s);
			String t = st.nextToken();
			int a = Integer.parseInt(t);
			String name = s.substring(t.length());
			if (!hm.containsKey(name)) {
				Player tp = new Player(name, i);
				p.add(tp);
				hm.put(name, tp);
			}
			hm.get(name).addGame(a);
		}
		for (int i = 0; i < p.size(); i++) {
			p.get(i).sort();
		}
		Collections.sort(p);
		for (int i = 0; i < p.size(); i++) {
			out.println(p.get(i));
		}
	}
}
