import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.*;

public class sum_ft implements Runnable {
	
	void solve() throws NumberFormatException, IOException {
		int n = nextInt();
		long[] a = new long[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextLong();
		}
		long x = nextLong();
		if (Math.abs(x) > 1e14) {
			throw new Error("Bad x");
		}
        HashMap<Long, Integer> map = new HashMap<Long, Integer>();
        long cs = 0;
        map.put(0l, 0);
        for (int i = 1; i <= n; i++) {
        	cs += a[i - 1];
        	if (map.get(cs - x) != null) {
        		out.println((map.get(cs - x) + 1) + " " + i);
        		return;
        	}
        	map.put(cs, i);
        }
        out.println("-1 -1");
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new Thread(new sum_ft("sum")).start();
	}

	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;
	
	public sum_ft(String fname) throws IOException {
		in = new BufferedReader(new FileReader(fname + ".in"));
		st = new StringTokenizer("");
		out = new PrintWriter(new FileWriter(fname + ".out"));
	}
	
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			apstenu(e);
		} finally {
			out.close();
		}
	}

	private void apstenu(Exception e) {
		e.printStackTrace();
		System.exit(1);
	}
	
}
