import java.io.*;
import java.util.*;
import java.math.*;

public class invkth_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new invkth_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("invkth.in"));
			out = new PrintWriter("invkth.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	String IOB = "is out of bounds!";
	int MAX_X = (int)1e+9;
	void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		myAssert(1 <= k && k <= n && n <= 100000, "k or n " + IOB);
		int x = nextInt();
		myAssert(-MAX_X + k - 1 <= x && x <= MAX_X - n + k, "x " + IOB);
		for (int i = x - k + 1; i <= x + n - k; i++) {
			out.print(i + " ");
		}
	}
}
