import java.io.*;
import java.util.*;
import java.math.*;

public class navi_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new navi_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("navi.in"));
			out = new PrintWriter("navi.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	String IOB = "is out of bounds!";

	int mod(int a, int b) {
		return ((a % b) + b) % b;
	}
	
	void solve() throws IOException {
		int x = nextInt();
		myAssert(0 <= x && x < 360, "x " + IOB);
		int y = nextInt();
		myAssert(-180 <= y && y <= 180, "y " + IOB);
		out.println(mod(x + y, 360));
	}
}
