//  "⨯஬"
// 1- ୥- ᥧ 2008-2009,  ஢
//  :  楢, ulyantsev@rain.ifmo.ru
//  襭: ⮭ 쪮, feskov@rain.ifmo.ru

import java.io.*;
import java.math.*;
import java.util.*;

public class antipali_af implements Runnable {
    public static void main(String[] args) {
        new Thread(new antipali_af()).start();
    }
    
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    
    public void run() {
        try {
            br = new BufferedReader(new FileReader("antipali.in"));
            out = new PrintWriter("antipali.out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                throw new Error("Enexpected end of file");
            }
        }
        return st.nextToken();
    }
    
    void myAssert(boolean e, String msg) {
        if (!e) {
            throw new Error(msg);
        }
    }
    
    final int MAXLEN = 100000;
    
    void solve() {
        StringBuilder s = new StringBuilder(nextToken());
        myAssert(1 <= s.length() && s.length() <= MAXLEN, "String length is out of bounds");
        for (int i = 1; i < s.length(); ++i) {
            myAssert('a' <= s.charAt(i) && s.charAt(i) <= 'z', "invalid symbol");
        }
                
        
        if (!s.substring(0, (s.length() + 1) / 2).equals(s.reverse().substring(0, (s.length() + 1) / 2))) {
            s.reverse();
            out.println(s);
            return;
        } else {
            s.reverse();
        }
        s = s.deleteCharAt(s.length() - 1);
        if (!s.substring(0, (s.length() + 1) / 2).equals(s.reverse().substring(0, (s.length() + 1) / 2))) {
            s.reverse();
            out.println(s);
            return;
        } 
        out.println("NO SOLUTION");
    }
}
