//  "  "
// 1- -  2008-2009,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru
//   -    int

import java.io.*;
import java.util.*;

public class approach_sp_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new approach_sp_wrong()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}
	
	void inBounds(long n, long a, long b) {
		myAssert(n >= a && n <= b, "out of bounds");
	}

	private static final String FILENAME = "approach";

	public void solve() throws IOException {
		int x0 = nextInt();
		int y0 = nextInt();
		int vx = nextInt();
		int vy = nextInt();
		int v = nextInt();
		int t = nextInt();
		int d = nextInt();
		inBounds(x0, (long)-1e9, (long)1e9);
		inBounds(y0, (long)-1e9, (long)1e9);
		inBounds(vx, (long)-1e6, (long)1e6);
		inBounds(vy, (long)-1e6, (long)1e6);
		inBounds(v, 1, (long)1e6);
		inBounds(t, 1, (long)1e3);
		inBounds(d, 1, (long)1e9);
		int x = x0 + t * vx;
		int y = y0 + t * vy;
		int dist = x * x + y * y;
		if ((dist < (d - v * t) * (d - v * t)) || (dist > (v * t + d) * (v * t + d))) {
			out.println("NO");
		} else {
			out.println("YES");
		}
	}
}
