//  ""
// 1- -  2008-2009,  
//  :  , tsarev@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru
//   - ""  ( ,   ...) 

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class indic_sm_greedy extends Thread{
	public static final int[] CNT = {6,2,5,5,4,5,6,3,7,6};
	
	void solve() {
		int n = in.nextInt();
		int k = in.nextInt();
		if (k>7*n || k<2*n) {
			out.println("NO SOLUTION");
			return;
		}
		int j = k;
		for (int i = 0; i < n; i++) {
			int max = (n-1-i)*7;
			int min = (n-1-i)*2;
			int less = 0;
			if (i==0)less=1;
			while(less<10 && (CNT[less]+max<j || CNT[less]+min>j)) {
				less++;
			}
			myAssert(less<10);
			out.print(less);
			j-=CNT[less];
		}
		out.println();
		j = k;
		for (int i = 0; i < n; i++) {
			int max = (n-1-i)*7;
			int min = (n-1-i)*2;
			int less = 9;
			while(less>=(i==0?1:0) && (CNT[less]+max<j || CNT[less]+min>j)) {
				less--;
			}
			myAssert(less>=0);
			out.print(less);
			j-=CNT[less];
		}
		out.println();
//		System.err.println(j);
		
	}
	
	void myAssert(boolean b) {
		if (!b)throw new AssertionError();
	}
	Scanner in;
	PrintWriter out;
	public void run() {
		try {
			in = new Scanner(new File("indic.in"));
			out = new PrintWriter(new File("indic.out"));
			solve();
			out.flush();
			out.close();
//			new FilePrinter("indic.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}
	
	public static void main(String[] args) {
		new indic_sm_greedy().start();
	}

}
