//  ""
// 1- -  2008-2009,  
//  :  , tsarev@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru
//   -   ,    

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;


public class indic_sm_tle_naive extends Thread{
	public static final int[] CNT = {6,2,5,5,4,5,6,3,7,6};
	String [][][] min;
	int mul = 1;
	String min(int n,int k,int first) {
		if (n<0 || k<0)return null;
		if (min[n][k][first]!=null) {
			return min[n][k][first];
		}
		String res = null;
		for (int i = first; i <= 9; i++) {
			String p = min(n-1,k-CNT[i],0);
			if (p==null)continue;
			BigInteger to = new BigInteger(i+p);
			if (res==null || to.compareTo(new BigInteger(res))*mul<0) {
				res = i+p;
			}
		}
		return min[n][k][first] = res==null?null:res.toString();
	}
	
	void solve() {
		int n = in.nextInt();
		int k = in.nextInt();
		myAssert(1<=n && n<=100);
		myAssert(1<=k && k<=700);
		min = new String[n+1][k+1][2];
		min[0][0][0] = "";
		String ans = min(n,k,1);
		if (ans==null) {
			out.println("NO SOLUTION");
			return;
		}
		out.println(ans);

		
		mul = -1;
		min = new String[n+1][k+1][2];
		min[0][0][0] = "";
		out.println(min(n,k,1));
	}
	
	void myAssert(boolean b) {
		if (!b)throw new AssertionError();
	}
	Scanner in;
	PrintWriter out;
	public void run() {
		try {
			in = new Scanner(new File("indic.in"));
			out = new PrintWriter(new File("indic.out"));
			solve();
			out.flush();
			out.close();
//			new FilePrinter("indic.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}
	
	public static void main(String[] args) {
		new indic_sm_tle_naive().start();
	}

}
