//  "k-⠭"
// 1- ୥- ᥧ 2008-2009,  ஢
//  : ࣥ 쭨, melnikov@rain.ifmo.ru
//  襭: ⮭ 쪮, feskov@rain.ifmo.ru


import java.io.*;
import java.math.*;
import java.util.*;

public class kperms_af implements Runnable {
    public static void main(String[] args) {
        new Thread(new kperms_af()).start();
    }
    
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    
    public void run() {
        try {
            br = new BufferedReader(new FileReader("kperms.in"));
            out = new PrintWriter("kperms.out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                throw new Error("Enexpected end of file");
            }
        }
        return st.nextToken();
    }
    
    void myAssert(boolean e, String msg) {
        if (!e) {
            throw new Error(msg);
        }
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    double nextDouble() {
        return Double.parseDouble(nextToken());
    }
    
    boolean[] u;
    int[] p;
    int n, k;
    
    int dfs(int c) {
        if (c == n) {
            for (int i = 0; i < n - 1; i++) {
                if (Math.abs(p[i] - p[i + 1]) > k) return 0;
            }
            return 1;
        }
        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (!u[i]) {
                u[i] = true;
                p[c] = i;
                ans += dfs(c + 1);
                u[i] = false;
            }
        }
        return ans;
    }
    
    void solve() {
        n = nextInt();
        k = nextInt();
        u = new boolean[n];
        p = new int[n];
        
        out.println(dfs(0));
        
        
    }
}
