//  ""
// 1- -  2008-2009,  
//  :  , tsarev@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru
//   -   FORGET_CASE

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class tourist_sm_wa6 extends Thread{
	public static final int FORGET_CASE = 6;
	
	void solve() {
		int k = in.nextInt();
		myAssert(1<=k && k<=15);
		int w = in.nextInt();
		myAssert(1<=w && w<=30);
		int a[] = new int[3];
		int b[] = new int[3];
		for (int i = 0; i < a.length; i++) {
			a[i] = in.nextInt();
			myAssert(1<=a[i] && a[i]<=10);
			b[i] = in.nextInt();			
			myAssert(1<=b[i] && b[i]<=15);
		}
		for (int i = 1; i < 8; i++) {
			if (i==FORGET_CASE)continue;
			int sa = 0;
			int sb = 0;
			for (int j = 0; j < 3; j++) {
				if ((i & (1<<j))>0) {
					sa += a[j];
					sb += b[j];
				}
			}
			if (sb>=k && sa<=w) {
				out.println("YES");
				return;
			}
		}
		out.println("NO");
		return;
	}
	
	void myAssert(boolean b) {
		if (!b)throw new AssertionError();
	}
	Scanner in;
	PrintWriter out;
	public void run() {
		try {
			in = new Scanner(new File("tourist.in"));
			out = new PrintWriter(new File("tourist.out"));
			solve();
			out.flush();
			out.close();
//			new FilePrinter("tourist.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}
	
	public static void main(String[] args) {
		new tourist_sm_wa6().start();
	}

}
