//  ""
// 2- -  2008-2009,  
//  :  ,  buzdalov@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru

// Z-

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class strings_sm extends Thread {

	void solve() throws IOException {
		String s = in.readLine();
		String t = in.readLine();
		String q = t + "$" + s + "#";
		int[] z = new int[q.length()];
		z[0] = 0;
		int l = 1;
		int r = 0;
		for (int i = 1; i < q.length(); i++) {
			z[i] = Math.max(Math.min(r - i + 1, z[i - l]),0);
			while (q.charAt(z[i]) == q.charAt(i + z[i])) {
				z[i]++;
				r = i + z[i] - 1;
				l = i;
			}
			if (z[i]>=t.length()) {
				out.println(s);
				return;
			}
		}
		out.println("NO SOLUTION");
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	BufferedReader in;
	PrintWriter out;

	public void run() {
		try {
			in = new BufferedReader(new FileReader("strings.in"));
			out = new PrintWriter(new File("strings.out"));
			solve();
			out.flush();
			out.close();
//			new FilePrinter("strings.out", System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new strings_sm().start();
	}

}
