//  " "
// 2- -  2008-2009,  
//  :  , tsarev@rain.ifmo.ru
//  :  , tsarev@rain.ifmo.ru
//   ---     , 
// 

import java.io.*;
import java.util.*;

public class trans_ft_wrong implements Runnable {
	
	class Pair {
		int a;
		int b;
		public Pair(int a, int b) {
			if (a < b) {
				int t = a;
				a = b;
				b = t;
			}
			this.a = a;
			this.b = b;
		}

		public int hashCode() {
			return 239 * a + 17 * b;
		}

		public boolean equals(Object o) {
			Pair p = (Pair) o;
			return a == p.a && b == p.b;
		}

	}

	private Scanner in;
	private PrintWriter out;
	String fname = "trans";

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               

	public void solve() {
		int n = in.nextInt();
		myAssert(1 <= n && n <= 10000, "");
		int m = in.nextInt();
		myAssert(1 <= m && m <= 100000, "");
		int[] deg = new int[n];
		HashSet<Pair> set = new HashSet<Pair>();
		for (int i = 0; i < m; i++) {
			int u = in.nextInt();
			int v = in.nextInt();
			myAssert(1 <= u && u <= n, "");
			myAssert(1 <= v && v <= n, "");
			myAssert(u != v, "");
			Pair p = new Pair(u, v);
			assert(!set.contains(p));
			set.add(p);
			deg[u - 1]++;
//			deg[v - 1]++;
		}

		int k = in.nextInt();
		myAssert(1 <= k && k <= 10000, "");

		ArrayList<Integer> ans = new ArrayList<Integer>();
		for (int i = 0; i < n; i++) {
			if (deg[i] >= k) {
				ans.add(i + 1);
			}
		}

		out.println(ans.size());
		for (int x : ans) {
			out.print(x + " ");
		}
		out.println();
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}		
	}

	public trans_ft_wrong() {
		try {
			in = new Scanner(new File(fname + ".in"));
			out = new PrintWriter(new File(fname + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new trans_ft_wrong()).start();
	}

}                                      