// " "
//1-  -  2008-2009,  
// :  , akhi@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class prefrev_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new prefrev_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "prefrev_aa".substring(0, "prefrev_aa".indexOf('_'));

	private void solve() throws IOException {
		String s = nextToken();
		String[][] a = new String[s.length()][s.length()];
		for (int i = 0; i < a.length; i++) {
			a[i][i] = s.charAt(i) + "";
		}
		for (int l = 1; l < a.length; l++) {
			for (int i = 0; i + l < a.length; i++) {
				if ((a[i + 1][i + l] + s.charAt(i)).compareTo(a[i][i + l - 1]
						+ s.charAt(i + l)) < 0) {
					a[i][i + l] = a[i + 1][i + l] + s.charAt(i);
				} else {
					a[i][i + l] = a[i][i + l - 1] + s.charAt(i + l);
				}
			}
		}
		out.println(a[0][a.length - 1]);
	}

}
