//  " "
// 1-  -  2008-2009
//  :  , akhi@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class prefrev_sm extends Thread {

	String reverse(String s) {
		return new StringBuffer(s).reverse().toString();
	}

	void solve() throws IOException {
		String s = in.readLine();
		myAssert(1 <= s.length() && s.length() <= 300);
		for (int i = 0; i < s.length(); i++) {
			myAssert(('a' <= s.charAt(i) && s.charAt(i) <= 'z'));
		}
		myAssert(in.read() == -1);
		String[][] min = new String[s.length()][s.length()];
		String[][] rmin = new String[s.length()][s.length()];
		for (int i = 0; i < s.length(); i++) {
			rmin[i][0] = min[i][0] = "" + s.charAt(i);
		}
		for (int len = 1; len < s.length(); len++) {
			for (int i = 0; i + len < s.length(); i++) {
				// min
				{
					String s1 = min[i][len - 1] + s.charAt(i + len);
					String s2 = reverse(rmin[i + 1][len - 1]) + s.charAt(i);
					if (s1.compareTo(s2) < 0) {
						min[i][len] = s1;
					} else {
						min[i][len] = s2;
					}
				}
				// rmin
				{
					String s1 = s.charAt(i) + rmin[i + 1][len - 1];
					String s2 = s.charAt(i + len) + reverse(min[i][len - 1]);
					if (reverse(s1).compareTo(reverse(s2)) < 0) {
						rmin[i][len] = s1;
					} else {
						rmin[i][len] = s2;
					}
				}
				// System.err.println(i+" "+len+" "+min[i][len]+"
				// "+rmin[i][len]+" from "+s.substring(i,i+len+1));
			}
		}
		out.println(min[0][s.length() - 1]);
	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	BufferedReader in;
	PrintWriter out;

	public void run() {
		try {
			in = new BufferedReader(new FileReader("prefrev.in"));
			out = new PrintWriter(new File("prefrev.out"));
			solve();
			out.flush();
			out.close();
			// new FilePrinter("prefrev.out",System.out);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new prefrev_sm().start();
	}

}
