// ""
//3- -  2008-2009,  
// :  , toropov@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru
// :     

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class quadr_aa_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new quadr_aa_wrong()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "quadr_aa".substring(0, "quadr_aa".indexOf('_'));

	private void solve() throws IOException {
		int[] x = new int[4];
		int[] y = new int[4];
		for (int i = 0; i < x.length; i++) {
			x[i] = nextInt();
			y[i] = nextInt();
			inBounds(x[i], -1000, 1000, "x[" + i + "]");
			inBounds(y[i], -1000, 1000, "y[" + i + "]");
		}
		for (int i = 0; i < x.length; i++) {
			for (int j = 0; j < x.length; j++) {
				if (i != j) {
					for (int k = 0; k < x.length; k++) {
						if (i != k && j != k) {
							for (int l = 0; l < x.length; l++) {
								if (i != l && j != l && k != l) {
									long a = dist(x, y, i, j);
									if (dist(x, y, j, k) != a) {
										continue;
									}
									if (dist(x, y, k, l) != a) {
										continue;
									}
									if (dist(x, y, l, i) != a) {
										continue;
									}
									if (scal(x, y, i, j, k) != 0) {
										continue;
									}
									out.println("YES");
									return;
								}
							}
						}
					}
				}
			}
		}
		out.println("NO");
	}

	private long scal(int[] x, int[] y, int i, int j, int k) {
		long x1 = x[j] - x[i];
		long y1 = y[j] - y[i];
		long x2 = x[k] - x[j];
		long y2 = y[k] - y[j];
		return x1 * x2 + y1 * y2;
	}

	private long dist(int[] x, int[] y, int i, int j) {
		return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
	}

}
