//  ""
// 3- -  2008-2009,  
//  :  , tsarev@rain.ifmo.ru
//  :  , melnikov@rain.ifmo.ru

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.TreeMap;

public class robot_sm extends Thread {

	void solve() throws IOException {
		String s = in.readLine();
		myAssert(in.read() == -1);
		myAssert(s.length() <= 1000);
		int x = 0;
		int y = 0;
		TreeMap<Integer, Integer> tm = new TreeMap<Integer, Integer>();
		tm.put(0, 1);
		int ans = 0;
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) == 'U') {
				y++;
			} else if (s.charAt(i) == 'D') {
				y--;
			} else if (s.charAt(i) == 'R') {
				x++;
			} else if (s.charAt(i) == 'L') {
				x--;
			} else {
				myAssert(false);
			}
			if (!tm.containsKey(10000 * x + y)) {
				tm.put(10000 * x + y, 0);
			} else if (tm.get(10000 * x + y) == 1) {
				ans++;
			}
			tm.put(10000 * x + y, tm.get(10000 * x + y) + 1);
		}
		System.err.println(ans);
		out.println(ans);

	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	BufferedReader in;
	PrintWriter out;

	public void run() {
		try {
			in = new BufferedReader(new FileReader("robot.in"));
			out = new PrintWriter(new File("robot.out"));
			solve();
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new robot_sm().start();
	}

}
