// ""
//2-  -  2008-2009
// :  , buzdalov@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru
// :  

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class log_aa_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new log_aa_wrong()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "log_aa".substring(0, "log_aa".indexOf('_'));

	private void solve() throws IOException {
		long a = nextLong();
		long b = nextLong();
		inBounds(a, 2, 1000000000000000000L, "a");
		inBounds(b, 1, 1000000000000000000L, "b");
		if (b == 1) {
			out.println("0 1");
			return;
		}
		ArrayList<Pair> al = new ArrayList<Pair>();
		ArrayList<Pair> bl = new ArrayList<Pair>();
		long aa = a;
		for (int i = 2; i * i <= aa && i * i <= a; i++) {
			if (a % i == 0) {
				int k = 0;
				while (a % i == 0) {
					k++;
					a /= i;
				}
				al.add(new Pair(i, k));
			}
		}
		if (a > 1) {
			al.add(new Pair(a, 1));
		}
		a = aa;
		aa = b;
		for (int i = 2; i * i <= aa && i <= b; i++) {
			if (b % i == 0) {
				int k = 0;
				while (b % i == 0) {
					k++;
					b /= i;
				}
				bl.add(new Pair(i, k));
			}
		}
		if (b > 1) {
			bl.add(new Pair(b, 1));
		}
		b = aa;
		if (al.size() != bl.size()) {
			out.println("irrational");
			return;
		}
		for (int i = 0; i < al.size(); i++) {
			if (al.get(i).x != bl.get(i).x) {
				out.println("irrational");
				return;
			}
		}
		long q = al.get(0).y;
		long p = bl.get(0).y;
		long gcd = gcd(p, q);
		p /= gcd;
		q /= gcd;
		for (int i = 0; i < al.size(); i++) {
			if (al.get(i).y * p != bl.get(i).y * q) {
				out.println("irrational");
				return;
			}
		}
		out.println(p + " " + q);
	}

	private long gcd(long a, long b) {
		while (b != 0) {
			long tmp = a % b;
			a = b;
			b = tmp;
		}
		return a;
	}

	class Pair {
		public Pair(long i, long k) {
			x = i;
			y = k;
		}

		long x, y;
	}

}
