//  ""
// 2-  -  2008-2009
//  :   , buzdalov@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//      

import java.io.*;
import java.util.*;
import java.math.*;

public class log_vu_wrong1 {

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new File("log.in"));
		PrintWriter out = new PrintWriter(new File("log.out"));
		
		long a = in.nextLong();
		long b = in.nextLong();
  		assert 1 < a && a <= 10e9 : "a is out of bounds";
		assert 1 <= b && b <= 10e9 : "b is out of bounds";

		int maxn = 1000;
		double eps = 1e-9;
		int q = -1;
		int p = -1;
		for (int i = 0; i < maxn; i++) {
			for (int j = 1; j < maxn; j++) {
				if (p != -1 && Math.abs(Math.pow(a, i / (double)j) - b) < eps) {
					p = i;
					q = j;
				}
			}			
		}
		if (p == -1) {
			out.println("irrational");
		} else {
			out.println(p + " " + q);
		}

		in.close();
		out.close();
	}

}
