import java.io.*;
import java.util.*;
import java.math.*;

public class subseq_af_slow implements Runnable {

	public static void main(String[] args) {
		new Thread(new subseq_af_slow()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(25566);

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + "2.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "subseq";

	long P = 1000000007L;

	private void solve() throws IOException {
		int n = nextInt();
		long[] a = new long[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
		}
		if (n <= 16) {
			int max = 0;
			int ans = 0;
			all: for (int i = 0; i < 1 << n; i++) {
				long prev = Long.MIN_VALUE;
				for (int j = 0; j < a.length; j++) {
					if ((i & (1 << j)) != 0) {
						if (a[j] <= prev) {
							continue all;
						}
						prev = a[j];
					}
				}
				if (max == Integer.bitCount(i)) {
					ans++;
				}
				if (max < Integer.bitCount(i)) {
					max = Integer.bitCount(i);
					ans = 1;
				}
			}
			out.println(ans);
			return;
		}
		int[] l = new int[n];
		long[] ans = new long[n];
		int max = 0;
		for (int i = 0; i < n; i++) {
			int maxLen = 0;
			for (int j = 0; j < i; j++) {
				if (a[j] < a[i]) {
					maxLen = Math.max(maxLen, l[j]);
				}
			}
			l[i] = maxLen + 1;
			max = Math.max(l[i], max);
			if (maxLen == 0) {
				ans[i] = 1;
			} else {
				for (int j = 0; j < i; j++) {
					if (a[j] < a[i] && maxLen == l[j]) {
						ans[i] = (ans[i] + ans[j]) % P;
					}
				}
			}
		}

		long w = 0;
		for (int i = 0; i < n; i++) {
			if (l[i] == max) {
				w = (w + ans[i]) % P;
			}
		}
		out.println(w);
	}

}
