//  "  "
// 5- -  2008-2009,  .
//  :   , tsarev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//      3     . 

import java.util.*;
import java.io.*;
import java.math.*;

public class subseq_vu implements Runnable {
	final static String FILE = "subseq";

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new subseq_vu()).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	int nextInt() throws IOException {
		while (st == null || !st.hasMoreElements()) {
			st = new StringTokenizer(in.readLine());
		}
		return Integer.parseInt(st.nextToken());
	}

	public subseq_vu() {
		try {
			in = new BufferedReader(new FileReader(FILE + ".in"));
			out = new PrintWriter(new File(FILE + ".out"));
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	class Pair {
		long value, cnt;
		Pair(long value, long cnt) {
			this.value = value;
			this.cnt = cnt;
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int[] min = new int[n + 1];
		Arrays.fill(min, Integer.MAX_VALUE);

		ArrayList<Pair>[] el = new ArrayList[n + 1];
		for (int i = 0; i <= n; i++) {
			el[i] = new ArrayList();
		}

		min[0] = Integer.MIN_VALUE;
		el[0].add(new Pair(Integer.MIN_VALUE, 1));

		for (int i = 0; i < n; i++) {
			int t = nextInt();
			int pos = Arrays.binarySearch(min, t);
			if (pos < 0)
				pos = -pos - 1;
			//out.println(pos);
			min[pos] = t;
			long cnt = 0;
			for (Pair x : el[pos - 1]) {
				cnt += t >= x.value ? x.cnt : 0;
			}
			cnt %= 1000000007;
			el[pos].add(new Pair(t, cnt));
		}

		
		int pos = -Arrays.binarySearch(min, Integer.MAX_VALUE - 1) - 2;
		//out.println(pos);
		long ans = 0;
		for (Pair x : el[pos]) {
			ans += x.cnt;
		}
		out.println(ans % 1000000007);
	}
}
