// " "
//5- -  2008-2009,  .
//  -  , buzdalov@rain.ifmo.ru
//  -  , buzdalov@rain.ifmo.ru

//     ,
//   ,   RE.

import java.io.*;
import java.util.*;
import java.math.*;

public class tickets_mb_small {
    private static boolean equal(char[] x, char[] y) {
        for (int i = 0; i < x.length; ++i) {
            if (x[i] != y[i]) {
                return false;
            }
        }
        return true;
    }

    private static void increment(char[] x) {
        for (int i = x.length - 1; i >= 0; --i) {
            x[i]++;
            if (x[i] > '9') {
                x[i] = '0';
            } else {
                return;
            }
        }
    }

    private static int count(char[] x, char v) {
        int rv = 0;
        for (char c : x) {
            rv += c == v ? 1 : 0;
        }
        return rv;
    }

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("tickets.in"));
        PrintWriter out = new PrintWriter("tickets.out");
        int nn = in.nextInt();
        int c = in.nextInt();
        int d = in.nextInt();
        int p = in.nextInt();

        int maxn = 13;

        int[] costs = new int[maxn + 1];
        for (int i = 0; i <= maxn; ++i) {
            costs[i] = (int) (c * Math.pow(1 - p / 100.0, i));
        }

        for (int tt = 0; tt < nn; ++tt) {
            char[] start = in.next().toCharArray();
            char[] finish = in.next().toCharArray();
            int n = start.length;

            long answer = 0;

            while (!equal(start, finish)) {
                answer += costs[count(start, (char) (d + '0'))];
                increment(start);
            }
            answer += costs[count(finish, (char) (d + '0'))];

            out.println(answer);
        }
        in.close();

        out.close();
    }
}
