//  " "
// 5- -  2008-2009,  
//  :  
//  :  , melnikov@rain.ifmo.ru

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Vector;

public class frac_sm extends Thread {

	void solve() {
		int p = in.nextInt();
		myAssert(1 <= p && p <= 1000);
		int q = in.nextInt();
		myAssert(1 <= q && q <= 1000);
		myAssert(!in.hasNext());
		Vector<Integer> v = new Vector<Integer>();
		while (q != 0) {
			v.add(p / q);
			p = p % q;
			int tmp = p;
			p = q;
			q = tmp;
		}
		out.println(v.size());
		for (int i : v) {
			out.print(i + " ");
		}

	}

	void myAssert(boolean b) {
		if (!b)
			throw new AssertionError();
	}

	Scanner in;
	PrintWriter out;

	public void run() {
		try {
			in = new Scanner(new File("frac.in"));
			out = new PrintWriter(new File("frac.out"));
			solve();
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new frac_sm().start();
	}

}
