// ""
//5- -  2008-2009,  
// :  , ulyantsev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class period_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new period_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "period_aa".substring(0, "period_aa".indexOf('_'));

	private void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		inBounds(n, 2, 1000000000, "n");
		inBounds(k, 2, 36, "k");
		int[] a = new int[k];
		Arrays.fill(a, -1);
		n %= k;
		int j = 1;
		int i = 0;
		while (true) {
			if (a[j] > 0) {
				out.println(i - a[j]);
				break;
			}
			a[j] = i++;
			j = (j * n) % k;
		}
	}
}
