// " "
//3- -  2008-2009,  
// :  , ulyancev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class point_aa_slow implements Runnable {

	public static void main(String[] args) {
		new Thread(new point_aa_slow()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "point_aa".substring(0, "point_aa".indexOf('_'));

	private void solve() throws IOException {
		int x1 = nextInt();
		inBounds(x1, -1000000000, 1000000000, "x1");
		int y1 = nextInt();
		inBounds(y1, -1000000000, 1000000000, "y1");
		int x2 = nextInt();
		inBounds(x2, -1000000000, 1000000000, "x2");
		int y2 = nextInt();
		inBounds(y2, -1000000000, 1000000000, "y2");
		int x0 = nextInt();
		inBounds(x0, -1000000000, 1000000000, "x0");
		int y0 = nextInt();
		inBounds(y0, -1000000000, 1000000000, "y0");
		int x0_temp = nextInt();
		inBounds(x0_temp, -1000000000, 1000000000, "x00");
		int y0_temp = nextInt();
		inBounds(y0_temp, -1000000000, 1000000000, "y00");
		long dx = x0_temp - x0;
		long dy = y0_temp - y0;
		double ans = Double.POSITIVE_INFINITY;
		int t = 0;
		int bb = 2500000;
		int l = (int) Math.max(-bb, (-2000000000
				/ Math.max(Math.abs(dx), Math.abs(dy)) - 3));
		int r = (int) Math.min(bb, (2000000000 / Math.max(Math.abs(dx), Math
				.abs(dy)) + 3));
		for (int i = l; i <= r; i++) {
			long x = x0 + i * dx;
			long y = y0 + i * dy;
			if (ans > Math.sqrt((x1 - x) * (x1 - x) + (y1 - y) * (y1 - y))
					+ Math.sqrt((x2 - x) * (x2 - x) + (y2 - y) * (y2 - y))) {
				ans = Math.sqrt((x1 - x) * (x1 - x) + (y1 - y) * (y1 - y))
						+ Math.sqrt((x2 - x) * (x2 - x) + (y2 - y) * (y2 - y));
				t = i;
			}
		}
		out.println((x0 + t * dx) + " " + (y0 + t * dy));
	}
}
