// ""
//5-  -  2008-2009
// :  , ulyancev@rain.ifmo.ru
// :  , akhi@rain.ifmo.ru

//    ,       ,      2 

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class game_aa_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new game_aa_wrong()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	void MyAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		MyAssert(l <= x && x <= r, name + " is not in bounds!!! " + x
				+ " is not in [" + l + ", " + r + "]");
	}

	String FNAME = "game_aa".substring(0, "game_aa".indexOf('_'));

	private void solve() throws IOException {
		int n = nextInt();
		inBounds(n, 1, 1000, "n");
		if (n == 1) {
			out.println(8);
			return;
		}
		Point[] a = new Point[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = new Point(nextInt(), nextInt());
			inBounds(a[i].x, -200000, 200000, "x[" + i + "]");
			inBounds(a[i].y, -200000, 200000, "y[" + i + "]");
		}
		Arrays.sort(a);
		long dx = a[n - 1].x - a[0].x;
		long dy = a[n - 1].y - a[0].y;
		long gcd = gcd(Math.abs(dx), Math.abs(dy));
		if (gcd == 0) {
			out.println(8);
		}
		dx /= gcd;
		dy /= gcd;
		boolean onLine = true;
		for (int i = 1; i < a.length; i++) {
			long dx0 = a[i].x - a[0].x;
			long dy0 = a[i].y - a[0].y;
			gcd = gcd(Math.abs(dx0), Math.abs(dy0));
			if (gcd == 0) {
				continue;
			}
			dx0 /= gcd;
			dy0 /= gcd;
			onLine &= dx == dx0 && dy == dy0;
		}
		if (onLine) {
			out.println(7);
			return;
		}
		for (int dx1 = -1; dx1 < 2; dx1++) {
			for (int dy1 = -1; dy1 < 2; dy1++) {
				for (int dx2 = -1; dx2 < 2; dx2++) {
					for (int dy2 = -1; dy2 < 2; dy2++) {
						b = new boolean[n][n];
						int d = dx1 * dy2 - dx2 * dy1;
						if (d == 0)
							continue;
						for (int i = 0; i < b.length; i++) {
							for (int j = 0; j < b[i].length; j++) {
								if (d != 0) {
									long a0 = ((a[j].x - a[i].x) * dy2 - (a[j].y - a[i].y)
											* dx2)
											/ d;
									long a1 = (-(a[j].x - a[i].x) * dy1 + (a[j].y - a[i].y)
											* dx1)
											/ d;
									if (a0 >= 0 && a1 >= 0) {
										b[i][j] = true;
									}
								}
							}
						}
						q = new boolean[n];
						t = new int[n];
						time = 0;
						for (int i = 0; i < q.length; i++) {
							if (!q[i]) {
								dfs(i);
							}
						}
						boolean good = true;
						for (int i = 1; i < t.length; i++) {
							good &= b[t[i]][t[i - 1]];
						}
						if (good) {
							out.println(6);
							return;
						}
					}
				}
			}
		}
		out.println(5);
	}

	private void dfs(int x) {
		q[x] = true;
		for (int i = 0; i < b[x].length; i++) {
			if (b[x][i] && !q[i]) {
				dfs(i);
			}
		}
		t[time++] = x;
	}

	boolean[][] b;

	int[] t;

	int time;

	boolean[] q;

	private long gcd(long a, long b) {
		while (b != 0) {
			long tmp = a % b;
			a = b;
			b = tmp;
		}
		return a;
	}

	class Point implements Comparable<Point> {
		public Point(int i, int j) {
			x = 2L * i;
			y = 2L * j;
		}

		long x, y;

		public int compareTo(Point p) {
			return x < p.x ? -1 : x > p.x ? 1 : y < p.y ? -1 : y > p.y ? 1 : 0;
		}
	}

}
